/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

#define yylval          cf_lval
#define yychar          cf_char

/* Copy the first part of user declarations.  */
#line 1 "cf-parse.y" /* yacc.c:339  */

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->pxlen)
      cf_error("Interface name/mask expected, not IP prefix");
}


static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a << 8) | b)

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */
static int
f_valid_set_type(int type)
{
  switch (type)
  {
  case T_INT:
  case T_PAIR:
  case T_QUAD:
  case T_ENUM:
  case T_IP:
  case T_EC:
    return 1;

  default:
    return 0;
  }
}

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  struct f_tree *lst = NULL;
  int i;

  if ((fa == ta) || ((fb == 0) && (tb == 0xFFFF)))
    return f_new_pair_item(fa, ta, fb, tb);
  
  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define EC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if (ipv4_used || (key >= 0x10000)) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_inst *dyn)
{ 
  struct f_inst *e = f_new_inst();
  e->code = 'E';

  switch (dyn->aux & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  dyn->code = P('e','S');
  dyn->a1.p = e;
  return dyn;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst();
    rv->code = 'c';
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst();
    rv->code = P('m', 'p');
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->code == 'c') {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->code == 'C') {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->code == 'c') {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;
  
    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst();
    rv->code = 'C';
    rv->a1.p = val;    
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst();
    rv->code = P('m','c');
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}



/* Headers from ../../proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from ../../proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet;

static inline int ospf_cfg_is_v2(void) { return OSPF_CFG->ospf2; }
static inline int ospf_cfg_is_v3(void) { return ! OSPF_CFG->ospf2; }

static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if (ip->waitint == 0)
    ip->waitint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT3_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  int nssa = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
      backbone = 1;
    if (ac->type == OPT_N)
      nssa = 1;
  }

  cf->abr = areano > 1;

  /* Route export or NSSA translation (RFC 3101 3.1) */
  cf->asbr = (this_proto->out_filter != FILTER_REJECT) || (nssa && cf->abr);

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error("Vlinks cannot be used on single area router");

  if (cf->asbr && (areano == 1) && (this_area->type == 0))
    cf_error("ASBR must be in non-stub area");
}

static inline void
ospf_check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
ospf_check_auth(void)
{
  if (ospf_cfg_is_v3())
    cf_error("Authentication not supported in OSPFv3");
}


/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/radv/config.Y */

#include "proto/radv/radv.h"

/* Defines from ../../proto/radv/config.Y */

#define RADV_CFG ((struct radv_config *) this_proto)
#define RADV_IFACE ((struct radv_iface_config *) this_ipatt)
#define RADV_PREFIX this_radv_prefix
#define RADV_RDNSS (&this_radv_rdnss)
#define RADV_DNSSL (&this_radv_dnssl)

static struct radv_prefix_config *this_radv_prefix;
static struct radv_rdnss_config this_radv_rdnss;
static struct radv_dnssl_config this_radv_dnssl;
static list radv_dns_list;	/* Used by radv_rdnss and radv_dnssl */
static u8 radv_mult_val;	/* Used by radv_mult for second return value */


/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_config *) this_proto)
#define RIP_IFACE ((struct rip_iface_config *) this_ipatt)

static inline int rip_cfg_is_v2(void) { return RIP_CFG->rip2; }
static inline int rip_cfg_is_ng(void) { return ! RIP_CFG->rip2; }

static inline void
rip_check_auth(void)
{
  if (rip_cfg_is_ng())
    cf_error("Authentication not supported in RIPng");
}


/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;
static struct f_inst **this_srt_last_cmd;

static void
static_route_finish(void)
{
  struct static_route *r;

  /* Update undefined use_bfd entries in multipath nexthops */
  if (this_srt->dest == RTD_MULTIPATH)
    for (r = this_srt->mp_next; r; r = r->mp_next)
      if (r->use_bfd < 0)
        r->use_bfd = this_srt->use_bfd;
}

/* Headers from ../../proto/babel/config.Y */

#include "proto/babel/babel.h"
#include "nest/iface.h"

/* Defines from ../../proto/babel/config.Y */

#define BABEL_CFG ((struct babel_config *) this_proto)
#define BABEL_IFACE ((struct babel_iface_config *) this_ipatt)


#line 641 "cf-parse.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_CF_PARSE_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    END = 258,
    CLI_MARKER = 259,
    INVALID_TOKEN = 260,
    ELSECOL = 261,
    DDOT = 262,
    GEQ = 263,
    LEQ = 264,
    NEQ = 265,
    AND = 266,
    OR = 267,
    PO = 268,
    PC = 269,
    NUM = 270,
    ENUM = 271,
    RTRID = 272,
    IPA = 273,
    SYM = 274,
    TEXT = 275,
    PREFIX_DUMMY = 276,
    DEFINE = 277,
    ON = 278,
    OFF = 279,
    YES = 280,
    NO = 281,
    S = 282,
    MS = 283,
    US = 284,
    PORT = 285,
    LOG = 286,
    SYSLOG = 287,
    ALL = 288,
    DEBUG = 289,
    TRACE = 290,
    INFO = 291,
    REMOTE = 292,
    WARNING = 293,
    ERROR = 294,
    AUTH = 295,
    FATAL = 296,
    BUG = 297,
    STDERR = 298,
    SOFT = 299,
    TIMEFORMAT = 300,
    ISO = 301,
    OLD = 302,
    SHORT = 303,
    LONG = 304,
    BASE = 305,
    NAME = 306,
    CONFIRM = 307,
    UNDO = 308,
    CHECK = 309,
    TIMEOUT = 310,
    LATENCY = 311,
    LIMIT = 312,
    WATCHDOG = 313,
    CONFIGURE = 314,
    DOWN = 315,
    KERNEL = 316,
    PERSIST = 317,
    SCAN = 318,
    TIME = 319,
    LEARN = 320,
    DEVICE = 321,
    ROUTES = 322,
    GRACEFUL = 323,
    RESTART = 324,
    KRT_SOURCE = 325,
    KRT_METRIC = 326,
    MERGE = 327,
    PATHS = 328,
    TABLE = 329,
    KRT_PREFSRC = 330,
    KRT_REALM = 331,
    KRT_MTU = 332,
    KRT_WINDOW = 333,
    KRT_RTT = 334,
    KRT_RTTVAR = 335,
    KRT_SSTRESH = 336,
    KRT_CWND = 337,
    KRT_ADVMSS = 338,
    KRT_REORDERING = 339,
    KRT_HOPLIMIT = 340,
    KRT_INITCWND = 341,
    KRT_RTO_MIN = 342,
    KRT_INITRWND = 343,
    KRT_QUICKACK = 344,
    KRT_LOCK_MTU = 345,
    KRT_LOCK_WINDOW = 346,
    KRT_LOCK_RTT = 347,
    KRT_LOCK_RTTVAR = 348,
    KRT_LOCK_SSTRESH = 349,
    KRT_LOCK_CWND = 350,
    KRT_LOCK_ADVMSS = 351,
    KRT_LOCK_REORDERING = 352,
    KRT_LOCK_HOPLIMIT = 353,
    KRT_LOCK_RTO_MIN = 354,
    KRT_FEATURE_ECN = 355,
    KRT_FEATURE_ALLFRAG = 356,
    ROUTER = 357,
    ID = 358,
    PROTOCOL = 359,
    TEMPLATE = 360,
    PREFERENCE = 361,
    DISABLED = 362,
    DIRECT = 363,
    INTERFACE = 364,
    IMPORT = 365,
    EXPORT = 366,
    FILTER = 367,
    NONE = 368,
    STATES = 369,
    FILTERS = 370,
    RECEIVE = 371,
    ACTION = 372,
    WARN = 373,
    BLOCK = 374,
    DISABLE = 375,
    KEEP = 376,
    FILTERED = 377,
    PASSWORD = 378,
    FROM = 379,
    PASSIVE = 380,
    TO = 381,
    EVENTS = 382,
    PACKETS = 383,
    PROTOCOLS = 384,
    INTERFACES = 385,
    PRIMARY = 386,
    STATS = 387,
    COUNT = 388,
    FOR = 389,
    COMMANDS = 390,
    PREEXPORT = 391,
    NOEXPORT = 392,
    GENERATE = 393,
    ROA = 394,
    LISTEN = 395,
    BGP = 396,
    V6ONLY = 397,
    DUAL = 398,
    ADDRESS = 399,
    PASSWORDS = 400,
    DESCRIPTION = 401,
    SORTED = 402,
    RELOAD = 403,
    IN = 404,
    OUT = 405,
    MRTDUMP = 406,
    MESSAGES = 407,
    RESTRICT = 408,
    MEMORY = 409,
    IGP_METRIC = 410,
    CLASS = 411,
    DSCP = 412,
    WAIT = 413,
    MAX = 414,
    FLUSH = 415,
    AS = 416,
    SHOW = 417,
    STATUS = 418,
    SUMMARY = 419,
    ROUTE = 420,
    SYMBOLS = 421,
    ADD = 422,
    DELETE = 423,
    DUMP = 424,
    RESOURCES = 425,
    SOCKETS = 426,
    NEIGHBORS = 427,
    ATTRIBUTES = 428,
    EVAL = 429,
    ECHO = 430,
    ENABLE = 431,
    FUNCTION = 432,
    PRINT = 433,
    PRINTN = 434,
    UNSET = 435,
    RETURN = 436,
    ACCEPT = 437,
    REJECT = 438,
    QUITBIRD = 439,
    INT = 440,
    BOOL = 441,
    IP = 442,
    PREFIX = 443,
    PAIR = 444,
    QUAD = 445,
    EC = 446,
    SET = 447,
    STRING = 448,
    BGPMASK = 449,
    BGPPATH = 450,
    CLIST = 451,
    ECLIST = 452,
    IF = 453,
    THEN = 454,
    ELSE = 455,
    CASE = 456,
    TRUE = 457,
    FALSE = 458,
    RT = 459,
    RO = 460,
    UNKNOWN = 461,
    GENERIC = 462,
    GW = 463,
    NET = 464,
    MASK = 465,
    PROTO = 466,
    SOURCE = 467,
    SCOPE = 468,
    CAST = 469,
    DEST = 470,
    IFNAME = 471,
    IFINDEX = 472,
    LEN = 473,
    DEFINED = 474,
    CONTAINS = 475,
    RESET = 476,
    PREPEND = 477,
    FIRST = 478,
    LAST = 479,
    LAST_NONAGGREGATED = 480,
    MATCH = 481,
    ROA_CHECK = 482,
    EMPTY = 483,
    WHERE = 484,
    BFD = 485,
    MIN = 486,
    IDLE = 487,
    RX = 488,
    TX = 489,
    INTERVAL = 490,
    MULTIPLIER = 491,
    MULTIHOP = 492,
    NEIGHBOR = 493,
    DEV = 494,
    LOCAL = 495,
    SESSIONS = 496,
    HOLD = 497,
    CONNECT = 498,
    RETRY = 499,
    KEEPALIVE = 500,
    STARTUP = 501,
    VIA = 502,
    NEXT = 503,
    HOP = 504,
    SELF = 505,
    DEFAULT = 506,
    PATH = 507,
    METRIC = 508,
    START = 509,
    DELAY = 510,
    FORGET = 511,
    AFTER = 512,
    BGP_PATH = 513,
    BGP_LOCAL_PREF = 514,
    BGP_MED = 515,
    BGP_ORIGIN = 516,
    BGP_NEXT_HOP = 517,
    BGP_ATOMIC_AGGR = 518,
    BGP_AGGREGATOR = 519,
    BGP_COMMUNITY = 520,
    BGP_EXT_COMMUNITY = 521,
    RR = 522,
    RS = 523,
    CLIENT = 524,
    CLUSTER = 525,
    AS4 = 526,
    ADVERTISE = 527,
    IPV4 = 528,
    CAPABILITIES = 529,
    PREFER = 530,
    OLDER = 531,
    MISSING = 532,
    LLADDR = 533,
    DROP = 534,
    IGNORE = 535,
    REFRESH = 536,
    INTERPRET = 537,
    COMMUNITIES = 538,
    BGP_ORIGINATOR_ID = 539,
    BGP_CLUSTER_LIST = 540,
    IGP = 541,
    GATEWAY = 542,
    RECURSIVE = 543,
    MED = 544,
    TTL = 545,
    SECURITY = 546,
    DETERMINISTIC = 547,
    SECONDARY = 548,
    ALLOW = 549,
    AWARE = 550,
    LINK = 551,
    EXTENDED = 552,
    SETKEY = 553,
    OSPF = 554,
    AREA = 555,
    OSPF_METRIC1 = 556,
    OSPF_METRIC2 = 557,
    OSPF_TAG = 558,
    OSPF_ROUTER_ID = 559,
    RFC1583COMPAT = 560,
    STUB = 561,
    TICK = 562,
    COST = 563,
    COST2 = 564,
    RETRANSMIT = 565,
    HELLO = 566,
    TRANSMIT = 567,
    PRIORITY = 568,
    DEAD = 569,
    TYPE = 570,
    BROADCAST = 571,
    BCAST = 572,
    NONBROADCAST = 573,
    NBMA = 574,
    POINTOPOINT = 575,
    PTP = 576,
    POINTOMULTIPOINT = 577,
    PTMP = 578,
    SIMPLE = 579,
    AUTHENTICATION = 580,
    STRICT = 581,
    CRYPTOGRAPHIC = 582,
    ELIGIBLE = 583,
    POLL = 584,
    NETWORKS = 585,
    HIDDEN = 586,
    VIRTUAL = 587,
    ONLY = 588,
    BUFFER = 589,
    LARGE = 590,
    NORMAL = 591,
    STUBNET = 592,
    TAG = 593,
    EXTERNAL = 594,
    LSADB = 595,
    ECMP = 596,
    WEIGHT = 597,
    NSSA = 598,
    TRANSLATOR = 599,
    STABILITY = 600,
    GLOBAL = 601,
    LSID = 602,
    INSTANCE = 603,
    REAL = 604,
    NETMASK = 605,
    LENGTH = 606,
    LSA = 607,
    SUPPRESSION = 608,
    TOPOLOGY = 609,
    STATE = 610,
    PIPE = 611,
    PEER = 612,
    MODE = 613,
    OPAQUE = 614,
    TRANSPARENT = 615,
    RADV = 616,
    RA = 617,
    MANAGED = 618,
    OTHER = 619,
    CONFIG = 620,
    MTU = 621,
    REACHABLE = 622,
    RETRANS = 623,
    TIMER = 624,
    CURRENT = 625,
    VALID = 626,
    PREFERRED = 627,
    MULT = 628,
    LIFETIME = 629,
    SKIP = 630,
    ONLINK = 631,
    AUTONOMOUS = 632,
    RDNSS = 633,
    DNSSL = 634,
    NS = 635,
    DOMAIN = 636,
    TRIGGER = 637,
    SENSITIVE = 638,
    LOW = 639,
    MEDIUM = 640,
    HIGH = 641,
    RIP = 642,
    INFINITY = 643,
    UPDATE = 644,
    GARBAGE = 645,
    MULTICAST = 646,
    VERSION = 647,
    SPLIT = 648,
    HORIZON = 649,
    POISON = 650,
    REVERSE = 651,
    ZERO = 652,
    PLAINTEXT = 653,
    MD5 = 654,
    RIP_METRIC = 655,
    RIP_TAG = 656,
    STATIC = 657,
    PROHIBIT = 658,
    MULTIPATH = 659,
    BLACKHOLE = 660,
    UNREACHABLE = 661,
    BABEL = 662,
    RXCOST = 663,
    WIRED = 664,
    WIRELESS = 665,
    BABEL_METRIC = 666,
    ENTRIES = 667
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 570 "cf-parse.y" /* yacc.c:355  */

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;

#line 1121 "cf-parse.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE cf_lval;

int cf_parse (void);

#endif /* !YY_CF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 1138 "cf-parse.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  73
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3254

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  434
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  314
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1017
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1901

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   667

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    31,     2,     2,     2,    30,     2,     2,
     425,   426,    28,    26,   430,    27,    32,    29,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   427,   424,
      23,    22,    24,   431,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   432,     2,   433,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   428,     2,   429,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   771,   771,   772,   775,   777,   785,   794,   795,   796,
     803,   804,   805,   813,   814,   815,   816,   817,   818,   824,
     825,   832,   833,   837,   844,   845,   849,   853,   860,   868,
     869,   876,   877,   883,   892,   893,   897,   902,   903,   907,
     908,   912,   913,   917,   918,   919,   920,   921,   922,   923,
     924,   925,   931,   932,   942,   943,   944,   945,   948,   949,
     950,   951,   952,   953,   957,   963,   964,   965,   966,   974,
     977,   984,   987,   990,   993,   997,   998,  1002,  1003,  1004,
    1012,  1017,  1018,  1022,  1029,  1030,  1031,  1032,  1038,  1043,
    1047,  1061,  1077,  1078,  1082,  1083,  1084,  1085,  1092,  1106,
    1108,  1110,  1114,  1115,  1116,  1117,  1122,  1128,  1129,  1133,
    1141,  1145,  1147,  1153,  1154,  1161,  1162,  1166,  1172,  1176,
    1185,  1194,  1196,  1200,  1201,  1202,  1203,  1204,  1205,  1206,
    1207,  1208,  1209,  1210,  1211,  1215,  1216,  1217,  1218,  1222,
    1223,  1224,  1225,  1226,  1230,  1236,  1240,  1248,  1249,  1257,
    1265,  1266,  1267,  1271,  1272,  1276,  1281,  1282,  1286,  1288,
    1296,  1300,  1301,  1307,  1314,  1315,  1316,  1317,  1321,  1329,
    1335,  1336,  1337,  1341,  1342,  1346,  1347,  1348,  1349,  1350,
    1351,  1357,  1358,  1359,  1363,  1364,  1368,  1369,  1375,  1376,
    1379,  1381,  1385,  1386,  1390,  1408,  1409,  1410,  1411,  1412,
    1413,  1421,  1424,  1427,  1430,  1434,  1435,  1438,  1441,  1445,
    1449,  1454,  1460,  1467,  1472,  1477,  1482,  1486,  1490,  1494,
    1503,  1511,  1515,  1522,  1523,  1524,  1529,  1533,  1540,  1547,
    1551,  1559,  1560,  1561,  1566,  1570,  1573,  1574,  1575,  1576,
    1577,  1578,  1579,  1584,  1589,  1597,  1604,  1611,  1619,  1621,
    1623,  1625,  1627,  1629,  1631,  1633,  1636,  1640,  1646,  1647,
    1648,  1652,  1653,  1659,  1661,  1663,  1665,  1667,  1669,  1673,
    1677,  1680,  1684,  1685,  1686,  1690,  1691,  1692,  1700,  1700,
    1710,  1714,  1715,  1716,  1717,  1718,  1719,  1720,  1721,  1722,
    1723,  1724,  1725,  1726,  1747,  1758,  1759,  1766,  1767,  1774,
    1783,  1787,  1791,  1815,  1816,  1820,  1833,  1833,  1849,  1850,
    1853,  1854,  1858,  1861,  1870,  1883,  1884,  1885,  1886,  1887,
    1891,  1899,  1900,  1901,  1902,  1903,  1907,  1910,  1911,  1912,
    1916,  1919,  1928,  1931,  1932,  1933,  1934,  1938,  1939,  1940,
    1944,  1945,  1946,  1947,  1951,  1952,  1953,  1954,  1958,  1959,
    1963,  1964,  1968,  1975,  1976,  1977,  1978,  1985,  1986,  1989,
    1990,  1997,  2009,  2010,  2014,  2015,  2019,  2020,  2021,  2022,
    2023,  2027,  2028,  2029,  2033,  2034,  2035,  2036,  2037,  2038,
    2039,  2040,  2041,  2042,  2043,  2047,  2048,  2058,  2062,  2085,
    2099,  2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,
    2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,  2120,  2121,
    2122,  2123,  2124,  2125,  2126,  2127,  2129,  2130,  2131,  2133,
    2135,  2137,  2139,  2140,  2141,  2142,  2143,  2144,  2154,  2155,
    2156,  2157,  2158,  2159,  2160,  2162,  2163,  2168,  2191,  2192,
    2193,  2194,  2195,  2196,  2200,  2203,  2204,  2205,  2213,  2220,
    2229,  2230,  2234,  2240,  2250,  2259,  2265,  2270,  2277,  2282,
    2288,  2289,  2290,  2298,  2299,  2300,  2301,  2302,  2308,  2320,
    2321,  2322,  2323,  2326,  2328,  2332,  2336,  2347,  2348,  2349,
    2350,  2351,  2352,  2355,  2357,  2360,  2362,  2365,  2368,  2373,
    2374,  2375,  2379,  2380,  2384,  2385,  2388,  2407,  2413,  2438,
    2440,  2441,  2445,  2446,  2447,  2448,  2449,  2450,  2456,  2457,
    2458,  2459,  2460,  2461,  2462,  2463,  2464,  2465,  2466,  2467,
    2468,  2469,  2470,  2471,  2472,  2473,  2474,  2475,  2476,  2477,
    2478,  2479,  2480,  2481,  2482,  2483,  2484,  2485,  2486,  2487,
    2488,  2489,  2490,  2491,  2492,  2493,  2494,  2500,  2501,  2502,
    2503,  2504,  2505,  2506,  2507,  2508,  2509,  2510,  2511,  2512,
    2513,  2514,  2525,  2535,  2536,  2540,  2541,  2542,  2543,  2544,
    2545,  2546,  2547,  2548,  2551,  2566,  2569,  2571,  2575,  2576,
    2577,  2578,  2579,  2580,  2581,  2582,  2583,  2584,  2584,  2585,
    2585,  2586,  2587,  2588,  2592,  2593,  2597,  2605,  2607,  2611,
    2612,  2613,  2617,  2618,  2621,  2623,  2626,  2627,  2628,  2629,
    2630,  2631,  2632,  2633,  2634,  2635,  2636,  2639,  2659,  2660,
    2661,  2662,  2663,  2664,  2665,  2666,  2667,  2668,  2669,  2670,
    2671,  2672,  2673,  2674,  2675,  2676,  2677,  2678,  2679,  2680,
    2681,  2682,  2683,  2684,  2685,  2686,  2687,  2688,  2689,  2690,
    2691,  2692,  2693,  2694,  2695,  2696,  2697,  2700,  2702,  2705,
    2707,  2716,  2718,  2719,  2722,  2724,  2728,  2729,  2732,  2742,
    2763,  2765,  2769,  2769,  2772,  2774,  2777,  2779,  2783,  2787,
    2788,  2793,  2796,  2799,  2804,  2807,  2812,  2815,  2819,  2823,
    2826,  2827,  2828,  2829,  2830,  2831,  2832,  2833,  2839,  2846,
    2847,  2848,  2853,  2854,  2860,  2870,  2871,  2872,  2873,  2873,
    2874,  2874,  2875,  2882,  2884,  2888,  2892,  2910,  2911,  2912,
    2913,  2914,  2915,  2916,  2917,  2918,  2919,  2924,  2925,  2926,
    2926,  2927,  2927,  2928,  2929,  2933,  2934,  2935,  2938,  2956,
    2958,  2961,  2963,  2967,  2970,  2983,  2984,  2985,  2986,  2991,
    2999,  3007,  3009,  3012,  3014,  3018,  3022,  3032,  3037,  3038,
    3039,  3043,  3055,  3057,  3061,  3062,  3066,  3079,  3084,  3085,
    3086,  3090,  3102,  3104,  3108,  3109,  3114,  3115,  3119,  3120,
    3126,  3139,  3140,  3141,  3142,  3143,  3146,  3148,  3152,  3156,
    3179,  3195,  3196,  3197,  3198,  3199,  3200,  3201,  3205,  3206,
    3207,  3208,  3209,  3210,  3211,  3212,  3213,  3214,  3215,  3216,
    3217,  3218,  3219,  3220,  3221,  3222,  3226,  3227,  3228,  3229,
    3232,  3234,  3237,  3239,  3243,  3249,  3252,  3259,  3266,  3267,
    3268,  3269,  3270,  3273,  3283,  3292,  3296,  3302,  3303,  3307,
    3312,  3318,  3321,  3326,  3327,  3328,  3329,  3330,  3334,  3335,
    3338,  3340,  3343,  3345,  3349,  3355,  3362,  3363,  3366,  3368,
    3372,  3376,  3389,  3411,  3412,  3413,  3414,  3415,  3416,  3417,
    3418,  3419,  3420,  3421,  3422,  3425,  3427,  3430,  3432,  3437,
    3442,  3445,  3448,  3455,  3455,  3455,  3455,  3455,  3455,  3455,
    3455,  3455,  3455,  3455,  3455,  3455,  3455,  3455,  3455,  3456,
    3456,  3456,  3456,  3456,  3456,  3456,  3456,  3456,  3456,  3456,
    3456,  3456,  3456,  3456,  3456,  3456,  3456,  3456,  3456,  3456,
    3456,  3456,  3456,  3456,  3456,  3456,  3456,  3456,  3456,  3456,
    3456,  3456,  3456,  3456,  3456,  3456,  3456,  3456,  3456,  3456,
    3456,  3456,  3456,  3456,  3456,  3456,  3456,  3456,  3456,  3456,
    3456,  3457,  3457,  3457,  3457,  3457,  3457,  3457,  3457,  3457,
    3457,  3457,  3458,  3458,  3458,  3458,  3459,  3459,  3459,  3460,
    3460,  3460,  3460,  3460,  3460,  3460,  3460,  3460,  3460,  3460,
    3460,  3460,  3460,  3460,  3460,  3460,  3460,  3460,  3460,  3460,
    3460,  3460,  3460,  3460,  3460,  3460,  3460,  3460,  3460,  3461,
    3461,  3462,  3463,  3464,  3465,  3466,  3467,  3468,  3469,  3470,
    3471,  3472,  3472,  3472,  3472,  3472,  3472,  3472
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'", "DEFINE",
  "ON", "OFF", "YES", "NO", "S", "MS", "US", "PORT", "LOG", "SYSLOG",
  "ALL", "DEBUG", "TRACE", "INFO", "REMOTE", "WARNING", "ERROR", "AUTH",
  "FATAL", "BUG", "STDERR", "SOFT", "TIMEFORMAT", "ISO", "OLD", "SHORT",
  "LONG", "BASE", "NAME", "CONFIRM", "UNDO", "CHECK", "TIMEOUT", "LATENCY",
  "LIMIT", "WATCHDOG", "CONFIGURE", "DOWN", "KERNEL", "PERSIST", "SCAN",
  "TIME", "LEARN", "DEVICE", "ROUTES", "GRACEFUL", "RESTART", "KRT_SOURCE",
  "KRT_METRIC", "MERGE", "PATHS", "TABLE", "KRT_PREFSRC", "KRT_REALM",
  "KRT_MTU", "KRT_WINDOW", "KRT_RTT", "KRT_RTTVAR", "KRT_SSTRESH",
  "KRT_CWND", "KRT_ADVMSS", "KRT_REORDERING", "KRT_HOPLIMIT",
  "KRT_INITCWND", "KRT_RTO_MIN", "KRT_INITRWND", "KRT_QUICKACK",
  "KRT_LOCK_MTU", "KRT_LOCK_WINDOW", "KRT_LOCK_RTT", "KRT_LOCK_RTTVAR",
  "KRT_LOCK_SSTRESH", "KRT_LOCK_CWND", "KRT_LOCK_ADVMSS",
  "KRT_LOCK_REORDERING", "KRT_LOCK_HOPLIMIT", "KRT_LOCK_RTO_MIN",
  "KRT_FEATURE_ECN", "KRT_FEATURE_ALLFRAG", "ROUTER", "ID", "PROTOCOL",
  "TEMPLATE", "PREFERENCE", "DISABLED", "DIRECT", "INTERFACE", "IMPORT",
  "EXPORT", "FILTER", "NONE", "STATES", "FILTERS", "RECEIVE", "ACTION",
  "WARN", "BLOCK", "DISABLE", "KEEP", "FILTERED", "PASSWORD", "FROM",
  "PASSIVE", "TO", "EVENTS", "PACKETS", "PROTOCOLS", "INTERFACES",
  "PRIMARY", "STATS", "COUNT", "FOR", "COMMANDS", "PREEXPORT", "NOEXPORT",
  "GENERATE", "ROA", "LISTEN", "BGP", "V6ONLY", "DUAL", "ADDRESS",
  "PASSWORDS", "DESCRIPTION", "SORTED", "RELOAD", "IN", "OUT", "MRTDUMP",
  "MESSAGES", "RESTRICT", "MEMORY", "IGP_METRIC", "CLASS", "DSCP", "WAIT",
  "MAX", "FLUSH", "AS", "SHOW", "STATUS", "SUMMARY", "ROUTE", "SYMBOLS",
  "ADD", "DELETE", "DUMP", "RESOURCES", "SOCKETS", "NEIGHBORS",
  "ATTRIBUTES", "EVAL", "ECHO", "ENABLE", "FUNCTION", "PRINT", "PRINTN",
  "UNSET", "RETURN", "ACCEPT", "REJECT", "QUITBIRD", "INT", "BOOL", "IP",
  "PREFIX", "PAIR", "QUAD", "EC", "SET", "STRING", "BGPMASK", "BGPPATH",
  "CLIST", "ECLIST", "IF", "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT",
  "RO", "UNKNOWN", "GENERIC", "GW", "NET", "MASK", "PROTO", "SOURCE",
  "SCOPE", "CAST", "DEST", "IFNAME", "IFINDEX", "LEN", "DEFINED",
  "CONTAINS", "RESET", "PREPEND", "FIRST", "LAST", "LAST_NONAGGREGATED",
  "MATCH", "ROA_CHECK", "EMPTY", "WHERE", "BFD", "MIN", "IDLE", "RX", "TX",
  "INTERVAL", "MULTIPLIER", "MULTIHOP", "NEIGHBOR", "DEV", "LOCAL",
  "SESSIONS", "HOLD", "CONNECT", "RETRY", "KEEPALIVE", "STARTUP", "VIA",
  "NEXT", "HOP", "SELF", "DEFAULT", "PATH", "METRIC", "START", "DELAY",
  "FORGET", "AFTER", "BGP_PATH", "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN",
  "BGP_NEXT_HOP", "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "PREFER", "OLDER", "MISSING", "LLADDR", "DROP",
  "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID",
  "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL",
  "SECURITY", "DETERMINISTIC", "SECONDARY", "ALLOW", "AWARE", "LINK",
  "EXTENDED", "SETKEY", "OSPF", "AREA", "OSPF_METRIC1", "OSPF_METRIC2",
  "OSPF_TAG", "OSPF_ROUTER_ID", "RFC1583COMPAT", "STUB", "TICK", "COST",
  "COST2", "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY", "DEAD", "TYPE",
  "BROADCAST", "BCAST", "NONBROADCAST", "NBMA", "POINTOPOINT", "PTP",
  "POINTOMULTIPOINT", "PTMP", "SIMPLE", "AUTHENTICATION", "STRICT",
  "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN", "VIRTUAL",
  "ONLY", "BUFFER", "LARGE", "NORMAL", "STUBNET", "TAG", "EXTERNAL",
  "LSADB", "ECMP", "WEIGHT", "NSSA", "TRANSLATOR", "STABILITY", "GLOBAL",
  "LSID", "INSTANCE", "REAL", "NETMASK", "LENGTH", "LSA", "SUPPRESSION",
  "TOPOLOGY", "STATE", "PIPE", "PEER", "MODE", "OPAQUE", "TRANSPARENT",
  "RADV", "RA", "MANAGED", "OTHER", "CONFIG", "MTU", "REACHABLE",
  "RETRANS", "TIMER", "CURRENT", "VALID", "PREFERRED", "MULT", "LIFETIME",
  "SKIP", "ONLINK", "AUTONOMOUS", "RDNSS", "DNSSL", "NS", "DOMAIN",
  "TRIGGER", "SENSITIVE", "LOW", "MEDIUM", "HIGH", "RIP", "INFINITY",
  "UPDATE", "GARBAGE", "MULTICAST", "VERSION", "SPLIT", "HORIZON",
  "POISON", "REVERSE", "ZERO", "PLAINTEXT", "MD5", "RIP_METRIC", "RIP_TAG",
  "STATIC", "PROHIBIT", "MULTIPATH", "BLACKHOLE", "UNREACHABLE", "BABEL",
  "RXCOST", "WIRED", "WIRELESS", "BABEL_METRIC", "ENTRIES", "';'", "'('",
  "')'", "':'", "'{'", "'}'", "','", "'?'", "'['", "']'", "$accept",
  "config", "conf_entries", "definition", "expr", "expr_us", "bool", "ipa",
  "ipa_scope", "prefix", "prefix_or_ipa", "pxlen", "datetime", "text",
  "text_or_none", "log_config", "syslog_name", "log_file", "log_mask",
  "log_mask_list", "log_cat", "mrtdump_base", "timeformat_which",
  "timeformat_spec", "timeformat_base", "debug_unix", "cmd_CONFIGURE",
  "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM", "cmd_CONFIGURE_UNDO",
  "cmd_CONFIGURE_CHECK", "cmd_DOWN", "cfg_name", "cfg_timeout",
  "kern_proto_start", "kern_item", "kif_proto_start", "kif_item",
  "kern_sys_item", "rtrid", "idval", "listen", "listen_opts", "listen_opt",
  "gr_opts", "tab_sorted", "newtab", "roa_table_start", "roa_table_opts",
  "roa_table", "proto_start", "proto_name", "proto_item", "imexport",
  "limit_action", "limit_spec", "rtable", "debug_default",
  "iface_patt_node_init", "iface_patt_node_body", "iface_negate",
  "iface_patt_node", "iface_patt_list", "iface_patt_list_nopx",
  "iface_patt_init", "iface_patt", "tos", "dev_proto_start", "dev_proto",
  "dev_iface_init", "dev_iface_patt", "debug_mask", "debug_list",
  "debug_flag", "mrtdump_mask", "mrtdump_list", "mrtdump_flag",
  "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "cmd_SHOW_STATUS",
  "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL",
  "optsym", "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY",
  "cmd_SHOW_ROUTE", "r_args", "export_mode", "cmd_SHOW_ROA", "roa_args",
  "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args", "roa_table_arg",
  "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA", "cmd_DUMP_RESOURCES",
  "cmd_DUMP_SOCKETS", "cmd_DUMP_EVENTS", "cmd_DUMP_INTERFACES",
  "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES",
  "cmd_DUMP_PROTOCOLS", "cmd_EVAL", "cmd_ECHO", "echo_mask", "echo_size",
  "cmd_DISABLE", "cmd_ENABLE", "cmd_RESTART", "cmd_RELOAD",
  "cmd_RELOAD_IN", "cmd_RELOAD_OUT", "cmd_DEBUG", "cmd_MRTDUMP",
  "cmd_RESTRICT", "proto_patt", "proto_patt2", "filter_def", "$@1",
  "filter_eval", "type", "one_decl", "decls", "declsn", "filter_body",
  "filter", "where_filter", "function_params", "function_body",
  "function_def", "$@2", "cmds", "cmds_int", "block", "fipa", "set_atom",
  "switch_atom", "pair_expr", "pair_atom", "pair_item", "ec_expr",
  "ec_kind", "ec_item", "set_item", "switch_item", "set_items",
  "switch_items", "fprefix_s", "fprefix", "fprefix_set", "switch_body",
  "bgp_path_expr", "bgp_path", "bgp_path_tail1", "bgp_path_tail2",
  "constant", "constructor", "rtadot", "function_call", "symbol",
  "static_attr", "term", "break_command", "print_one", "print_list",
  "var_listn", "var_list", "cmd", "bfd_proto_start", "bfd_proto_item",
  "bfd_proto_opts", "bfd_proto", "bfd_iface_start", "bfd_iface_item",
  "bfd_iface_opts", "bfd_iface_opt_list", "bfd_iface", "bfd_multihop",
  "bfd_neigh_iface", "bfd_neigh_local", "bfd_neigh_multihop",
  "bfd_neighbor", "cmd_SHOW_BFD_SESSIONS", "bgp_proto_start",
  "bgp_nbr_opts", "bgp_proto", "ospf_proto_start", "ospf_proto",
  "ospf_proto_item", "ospf_area_start", "ospf_area", "ospf_area_opts",
  "ospf_area_item", "$@3", "$@4", "ospf_stubnet", "ospf_stubnet_start",
  "ospf_stubnet_opts", "ospf_stubnet_item", "ospf_vlink",
  "ospf_vlink_opts", "ospf_vlink_item", "ospf_vlink_start",
  "ospf_iface_item", "pref_list", "pref_item", "pref_base", "pref_opt",
  "nbma_list", "nbma_eligible", "nbma_item", "ospf_iface_start",
  "ospf_instance_id", "ospf_iface_patt_list", "$@5", "ospf_iface_opts",
  "ospf_iface_opt_list", "ospf_iface", "opttext", "cmd_SHOW_OSPF",
  "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "radv_proto_start",
  "radv_proto_item", "$@6", "$@7", "radv_proto_opts", "radv_proto",
  "radv_iface_start", "radv_iface_item", "$@8", "$@9", "radv_preference",
  "radv_iface_finish", "radv_iface_opts", "radv_iface_opt_list",
  "radv_iface", "radv_prefix_start", "radv_prefix_item",
  "radv_prefix_finish", "radv_prefix_opts", "radv_prefix_opt_list",
  "radv_prefix", "radv_rdnss_node", "radv_rdnss_start", "radv_rdnss_item",
  "radv_rdnss_finish", "radv_rdnss_opts", "radv_rdnss", "radv_dnssl_node",
  "radv_dnssl_start", "radv_dnssl_item", "radv_dnssl_finish",
  "radv_dnssl_opts", "radv_dnssl", "radv_mult", "radv_sensitive",
  "rip_proto_start", "rip_proto_item", "rip_proto_opts", "rip_proto",
  "rip_iface_start", "rip_iface_finish", "rip_iface_item", "rip_auth",
  "rip_iface_opts", "rip_iface_opt_list", "rip_iface",
  "cmd_SHOW_RIP_INTERFACES", "cmd_SHOW_RIP_NEIGHBORS",
  "static_proto_start", "static_proto", "stat_route0", "stat_multipath1",
  "stat_multipath", "stat_route", "stat_route_item", "stat_route_opts",
  "stat_route_opt_list", "cmd_SHOW_STATIC", "babel_proto_start",
  "babel_proto_item", "babel_proto_opts", "babel_proto",
  "babel_iface_start", "babel_iface_finish", "babel_iface_item",
  "babel_iface_opts", "babel_iface_opt_list", "babel_iface",
  "cmd_SHOW_BABEL_INTERFACES", "cmd_SHOW_BABEL_NEIGHBORS",
  "cmd_SHOW_BABEL_ENTRIES", "conf", "cli_cmd", "proto", "kern_proto",
  "kif_proto", "dynamic_attr", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,    43,    45,    42,    47,
      37,    33,    46,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,    59,    40,    41,    58,   123,   125,
      44,    63,    91,    93
};
# endif

#define YYPACT_NINF -1491

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1491)))

#define YYTABLE_NINF -451

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-451)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     105,  2919,   256,   654,   687,  1108,   261,   687,   687,   671,
     687,   347,   276,  1518,   320,   370,   978,  1520,    45,   687,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491,   508,   936,   331,   382,   315,
     334,   529,   429, -1491, -1491,   544,   518,   458,   468,  1520,
     595, -1491, -1491, -1491, -1491, -1491, -1491,   140,   140, -1491,
   -1491, -1491, -1491,   228, -1491,  2550, -1491,   140,  1622, -1491,
   -1491, -1491,   140, -1491,   140,  2456,   140,  2365,   140,  2317,
     140, -1491,   140, -1491,   140,  2546,   140, -1491, -1491, -1491,
    2342,  2666, -1491, -1491, -1491,   113, -1491,   599,   669,   701,
     599,   651, -1491,   708,   716,   687,   687,   718,   123, -1491,
     658,   730,   167, -1491,   727,   748, -1491, -1491,   501,   277,
     -10,   747,   -40,   577,   577,   778,   780,   790,   795,   798,
     800,   825,   834,    34, -1491, -1491, -1491,   726,   388, -1491,
     602,    38,    -3,  1520, -1491,   418,   420,   428, -1491, -1491,
     436,   457,   476,   894,   137, -1491, -1491, -1491, -1491, -1491,
    1985, -1491,  3099, -1491, -1491,  1766,   878,   901,   886, -1491,
   -1491,   857, -1491, -1491,    19,    60,   113,   216, -1491, -1491,
   -1491, -1491,   321,   500,   216,   216,   761,   783,   204, -1491,
     938, -1491,   123,   552,  3124, -1491,   843,   965,   558,   564,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491, -1491,   566,   113,   690,  1034,   941,   216,   214, -1491,
    1352,   753,   989,   642,   123, -1491,   640,   647,   649,   672,
     -66,   759,   999,   689,  1094,   847,   642,   214,  1049,  1047,
      54,   980,   214,    11,   577,   292,  1062,    -1,  1064,   889,
     887,   413,   888,   884,   515,   873,   871,   214,   869,   876,
     863,    41,   -21,   906,   872,   879,   214,   929,   214, -1491,
     760,   755,   835,   329,   214,  1075,   216,   214,  1081, -1491,
   -1491,   772,   784, -1491,   785,  1130,   454, -1491,   799,   791,
     797,   824,   915,   577,  1168, -1491,   836,   752,   831,   833,
    1177,   214,  1189,   214,  1188,  1190,  1184, -1491,   849,   851,
     853,  1196,  1266, -1491,   877,   882, -1491, -1491,   721,  1289,
     651, -1491, -1491,  1299,   216,  1304, -1491, -1491,  1313,  1314,
   -1491, -1491, -1491,   328,  1318,  1306,  1320, -1491, -1491,   897,
    1324, -1491,  1328,   439, -1491, -1491,  2900,  2382,   747, -1491,
     747,   747, -1491,   475,   557,  1330,   747,   747,  1331,   747,
     747,   747, -1491, -1491,    47,  1170,  1172, -1491, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491,    34, -1491,    34,  1520,    34,
      34,  1329, -1491,  1323,   242,  1319,  1105,  1322,    -3,    -3,
    1321,  1315,  1520,  1520,  1520,  1520,  1520,  1332, -1491, -1491,
    1338, -1491,   926,    32, -1491, -1491, -1491, -1491,   868, -1491,
    1351, -1491, -1491, -1491,  -230,    24, -1491,   179, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
    1520,  1520,  1520,  1520,  1520,  1520,  1520,  1520,  1520,  1520,
    1520,  1520,  1520,  1101, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491, -1491, -1491,   524, -1491, -1491,  1356, -1491,  1520,   642,
   -1491, -1491,  1766,   937, -1491, -1491, -1491, -1491, -1491, -1491,
     216,  1520, -1491, -1491, -1491, -1491,   216,   914,   970, -1491,
     810, -1491, -1491,   216, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491,  1520,   939,  2700, -1491,   491,   943, -1491,   935,  1345,
   -1491, -1491, -1491,   -73, -1491, -1491,   214, -1491, -1491,   329,
   -1491, -1491, -1491, -1491,   153,  2110, -1491,  1232,  1520, -1491,
   -1491,   153, -1491,   153, -1491, -1491, -1491, -1491, -1491, -1491,
    1294,  1297,   214,   546, -1491,   949,  1334,   950,   954,   216,
     150,  1088,   214,  1229,   577,   957, -1491,   971,  1364,    66,
     216,  1225,   216,  1333,  1336,   216,  1342,   121,   216,   216,
     214,  1343,   974,  1295,   995,   214,   997,   214,   327,   214,
    1034,   214,  1000,  1001,   214,   214,   214,  1014,  1251,  1015,
   -1491, -1491,   214, -1491, -1491,   214, -1491,  1372,   216, -1491,
   -1491, -1491,  1422,  1018,  1023, -1491, -1491, -1491, -1491,   214,
   -1491,  1034, -1491, -1491,   908, -1491,   577, -1491,  1192, -1491,
   -1491, -1491,  1027, -1491,   216, -1491,   216, -1491,   214,   214,
     214, -1491, -1491, -1491,   216, -1491,   577, -1491, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491,   614, -1491, -1491,  1449, -1491,
   -1491, -1491, -1491, -1491, -1491, -1491,   620, -1491, -1491, -1491,
   -1491,  1456, -1491, -1491, -1491,  1441, -1491, -1491,  1448,   577,
   -1491, -1491,  1467,  1469, -1491,  2110, -1491, -1491, -1491, -1491,
     577, -1491, -1491, -1491,  1471, -1491, -1491, -1491, -1491, -1491,
   -1491, -1491, -1491, -1491,  1489,  1476,  1476,  1013,   747,  1476,
     747,  1476, -1491,  1476,  1476, -1491,  1476,  1476,  1476,   216,
     577, -1491,  1482,  1483, -1491, -1491,   626, -1491, -1491, -1491,
   -1491,    59, -1491,  1073, -1491,  1475, -1491, -1491, -1491, -1491,
     112,   170,   275,   846,   306,    70, -1491,  1520, -1491,  1520,
   -1491,  1496,  1076,  1077,   940,   197,   307, -1491, -1491, -1491,
    1490,  1492, -1491,  1746,  1746,  1746,  2826,  2826,  1746,  1746,
    1746,  1746,   794,   794,  1315,  1315, -1491,  1090, -1491, -1491,
   -1491, -1491, -1491,  1766, -1491,  1286, -1491,   630, -1491, -1491,
     996,  1497, -1491, -1491, -1491, -1491, -1491, -1491, -1491,  1095,
   -1491,  1096,  1182, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491, -1491,    85,  1097,  1099, -1491,
   -1491,   216, -1491, -1491,   577, -1491, -1491, -1491,  1083,  2700,
   -1491,   577, -1491,  1098, -1491,  1491, -1491,  1100, -1491,  1396,
   -1491, -1491, -1491, -1491,   214,  3124, -1491, -1491,  2444,   216,
     216,  1104,   216,  1107,  1119, -1491,   214, -1491, -1491,  1121,
    1126,  1128,  1132,   214,  1133,   214,  1134, -1491, -1491,  1506,
   -1491,   216,   216, -1491,  1135,   216,  1145,   216,   216,  1146,
     216,  1147,  1148,  1152,  1153,  1154,   216, -1491,   329, -1491,
    1155, -1491,  1156,  1158,  1165,  1166,  1169,  1174,  1178, -1491,
   -1491,  1179,  1180,  1181, -1491,   110, -1491, -1491, -1491,   216,
   -1491,  2483,  1183, -1491, -1491,  2499,  2610,  1187,  1191, -1491,
    1364, -1491,   577,  -127,  1192,  1008, -1491,  2684, -1491, -1491,
   -1491, -1491,  1461, -1491,    47, -1491, -1491, -1491,   721, -1491,
   -1491,   328, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491, -1491, -1491,  1598,  1614, -1491, -1491,   329, -1491, -1491,
     329,  1604, -1491,   329,  1476,  1617,  1476,  1618,  1619,  1621,
    1623,  1624,  1625, -1491, -1491,  1453,  1459, -1491,  1520, -1491,
    1605,  1520,  1520,  1520, -1491,  1520, -1491,  1520,   364,  1218,
    1520,   916,  1520, -1491, -1491,  1520, -1491, -1491,  1203,   726,
   -1491,  1520, -1491, -1491, -1491, -1491, -1491, -1491,  1100, -1491,
   -1491, -1491, -1491,  2700,   597, -1491, -1491, -1491,  1210,  1209,
   -1491,  1468, -1491, -1491,   962, -1491,   540, -1491, -1491, -1491,
   -1491,   577, -1491, -1491,  1215,  1216,  1221, -1491,  1223, -1491,
   -1491,  1224, -1491, -1491, -1491, -1491,  1226, -1491,  1228, -1491,
   -1491,   191, -1491, -1491, -1491,  1233, -1491,  1237,  1238, -1491,
    1239, -1491, -1491, -1491, -1491, -1491,  1242,  1245, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
    1246, -1491, -1491,   214,   683,   570, -1491,  1346,   577, -1491,
   -1491,   127, -1491,  1247, -1491,  1290, -1491, -1491,   577, -1491,
   -1491,   577, -1491, -1491,  1253, -1491,   214,   216, -1491, -1491,
    1254, -1491, -1491, -1491,  1364,   214,   216,  -127,    26, -1491,
    1634, -1491, -1491,  1250,  1520, -1491, -1491, -1491,  1520,  1520,
     214, -1491,  1985,  1256,  1451, -1491, -1491, -1491, -1491, -1491,
    1258,   216, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
    1687, -1491,  1690, -1491, -1491, -1491, -1491, -1491, -1491,  1681,
    1682, -1491, -1491,  1378,  1404,  1693,  1813,   545,  1520, -1491,
   -1491,  3124,  1274,  1276,  3124,   940,  1694,  1839, -1491,  1279,
      16, -1491,  2700, -1491,  1696,   577, -1491, -1491, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491,  1285, -1491,   102, -1491, -1491,
     216, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491,   216,   216,   214,
     216, -1491,  1298,   329, -1491, -1491,  1300,  1301,   216, -1491,
   -1491,   216,  1302, -1491, -1491, -1491,  1308, -1491,    74,    -5,
   -1491, -1491, -1491, -1491,  1655, -1491, -1491, -1491, -1491, -1491,
    1520,   242,  1520, -1491,  2099,  3044,   736,  1303,  1710,   528,
   -1491,  3124,  1307,  1327, -1491, -1491, -1491, -1491, -1491, -1491,
     658,   658, -1491, -1491, -1491, -1491,  1520,  1869,  1731,  1568,
    1316, -1491, -1491, -1491, -1491,  1576, -1491,  1100,  1285, -1491,
   -1491,  1733,   642,  1510,  1339,  1100,  1337, -1491, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,  1348, -1491,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,  1349,
     216,  2130,  1340,  2155,  2238, -1491,  2174, -1491, -1491,  1520,
    1520,   578,  1451, -1491,  1355,  1759,  1777,  1897, -1491,  1360,
    1362,     7, -1491,  1771, -1491,   572, -1491, -1491,   577,  1541,
   -1491,  1290, -1491, -1491,    10,   -75,    28,   933, -1491, -1491,
     705, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
    1366,   597,  1579, -1491,    21,  2206,  2260,  1369,  1370,  1371,
    1374,  1373, -1491, -1491, -1491, -1491, -1491, -1491,  1520, -1491,
    1520, -1491,  1376,   214,   818,  1557,   216,   216, -1491,  1379,
   -1491,   214, -1491, -1491,  2634, -1491, -1491, -1491,    83,   214,
     216,   214, -1491,  1381, -1491,   642,  1380,   216,   216,   216,
    1560,   351,    23, -1491, -1491, -1491,  1399,  1383,  2622, -1491,
    1444,  1447,   214,   214,   214, -1491,  1419,   202,   194,  2236,
   -1491,  1420,  1423,  2174,   100, -1491, -1491, -1491,   868, -1491,
   -1491,  1846, -1491, -1491, -1491,   282, -1491, -1491,  1520,  1520,
    1520,  1520, -1491,   661, -1491,  1424,  1429, -1491, -1491,  1610,
    1611,  1612, -1491, -1491, -1491, -1491,  1552,   216,  1432,   214,
    1524,   301,  1571,   214,  1507,   214,   216,   216,   216,  1608,
     216,   415,   904,  1521,    65,  1555,   216,  1532,  1559, -1491,
   -1491,  1463, -1491,   216,  1464, -1491, -1491, -1491, -1491, -1491,
    1755, -1491, -1491, -1491,   216,   216, -1491, -1491, -1491, -1491,
     288, -1491,  1517,   577,  -155,   -65,  1522,   214,  1526,  1825,
    1523,  1650,  1660,  1661, -1491,  1493,   216,   216, -1491, -1491,
   -1491, -1491,   467,   577, -1491,  1494,   467,  1893, -1491,  1503,
     216,    30,  1840,   214,   577,   214,  1569,   354,   216,  1626,
     -25,  1577,  -219,  1857,  1858,   205,  1529,  1528, -1491, -1491,
    1513, -1491, -1491, -1491, -1491,  1931,   264,   100,   395,  1956,
    1986,  2011,  2036,   216,  1631,  1599,   379,  1700,   648,  1701,
     216, -1491,  1525,  1520, -1491,   216,   216,   216,   214, -1491,
   -1491, -1491,   251,   216,   216,   216,   216, -1491,   645, -1491,
    1584, -1491, -1491, -1491, -1491,   216, -1491,   216, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491,   214, -1491, -1491,
   -1491,   214, -1491,   216,   214, -1491, -1491, -1491,  1533,  1527,
   -1491, -1491,   216,   341,   563,  1540,  1704, -1491,   216,  1715,
     469,   216,   216, -1491,   214,   216,   216,  1902,   214,    74,
     214,    -5, -1491,  1578,  1578,   216, -1491, -1491, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491, -1491,   214,   214,   216, -1491,
   -1491, -1491,   216,   216,   216, -1491, -1491,   903, -1491, -1491,
   -1491, -1491, -1491,   216, -1491, -1491,   216,   216,   214, -1491,
     214,   214, -1491, -1491,  1520, -1491, -1491, -1491,  1547,  1549,
    1550,  1551, -1491,   214,   216,   216,   216, -1491,   216, -1491,
   -1491,   216, -1491, -1491,  1561, -1491, -1491, -1491, -1491,    55,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491,  1632, -1491,   214,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491,  1755,  1553,  1966,
    1966,  1966,  1966, -1491,   216, -1491,   216, -1491, -1491, -1491,
   -1491,  1578, -1491, -1491, -1491, -1491,   216, -1491, -1491, -1491,
   -1491,   214, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491,  1645, -1491, -1491, -1491, -1491, -1491, -1491, -1491,  1931,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491, -1491,  1652, -1491, -1491, -1491, -1491,   288, -1491,  1575,
    1580,  1581,  1582, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
    1583, -1491,   288,   288,   288,   288, -1491, -1491, -1491, -1491,
   -1491
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    75,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   387,     0,     0,
     899,   900,   901,   902,   903,   904,   905,   906,   907,   908,
     909,   910,   911,   912,   913,   914,   915,   916,   917,   918,
     919,   920,   921,   922,   923,   924,   925,   926,   927,   928,
     929,   930,   931,   932,   933,   934,   935,   936,   937,   938,
     939,   940,   941,   942,   943,   944,   945,   946,   947,   948,
     949,   950,     3,     1,     2,     0,     0,     0,     0,     0,
       0,     0,     0,   115,   116,     0,     0,     0,     0,   387,
       0,   883,   884,   885,   886,   887,   888,   117,   117,   889,
     890,   891,   892,   113,   893,     0,   895,   117,   121,   896,
     897,   898,   117,   954,   117,   121,   117,   121,   117,   121,
     117,   958,   117,   959,   117,   121,   117,   961,     5,   894,
     121,   121,   272,   274,   273,     0,    76,    75,     0,     0,
      75,    77,    74,     0,     0,     0,     0,     0,     0,   271,
     243,   276,     0,   227,     0,     0,   210,   235,     0,   206,
       0,   206,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   370,   374,   383,   380,   314,   389,   377,
       0,     0,   373,   387,   419,     0,     0,     0,   375,   376,
       0,     0,     0,   387,     0,   378,   379,   384,   417,   418,
       0,   416,     0,   259,   258,     0,   261,     0,     0,    30,
      29,    35,    38,    36,     0,    18,     0,     0,    57,    56,
      55,    54,     0,     0,     0,     0,     0,   107,     0,   278,
       0,   100,     0,     0,   280,   306,   118,     0,     0,     0,
     111,    80,    88,   163,   498,   468,   562,   698,   704,   780,
     827,   855,     0,     0,     0,     0,     0,     0,    18,   168,
       0,     0,     0,     0,     0,   953,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    18,     0,     0,
       0,     0,    18,     0,   499,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    18,     0,     0,
       0,     0,     0,     0,     0,     0,    18,     0,    18,   955,
       0,     0,     0,     0,    18,     0,     0,    18,     0,   956,
     565,     0,     0,   573,     0,     0,     0,   957,     0,     0,
       0,     0,     0,     0,     0,   960,     0,     0,   852,     0,
       0,    18,     0,    18,     0,     0,     0,   951,     0,     0,
       0,     0,    32,   952,     0,     0,   171,   170,     0,     0,
      77,    71,    72,     0,    78,     0,   265,   263,     0,     0,
     266,   182,   181,     0,     0,     0,     0,   275,   277,   276,
       0,   207,     0,   231,   202,   201,     0,     0,   206,   205,
     206,   206,   689,   206,   206,     0,   206,   206,     0,   206,
     206,   206,    19,    20,     0,     0,     0,   254,   250,   255,
     251,   248,   249,   252,   253,   370,   389,   370,   387,   370,
     370,     0,   362,     0,   387,     0,     0,     0,   373,   373,
       0,   414,   387,   387,   387,   387,   387,     0,   333,   334,
       0,   336,     0,     0,   315,   318,   316,   320,   387,   317,
     342,   340,   341,   348,     0,   353,   357,     0,   999,   969,
     970,   971,   972,   973,   974,   975,   976,   977,   978,   979,
     980,   981,   982,   983,   984,   985,   986,   987,   988,   989,
     990,   991,   992,   993,   994,   995,   996,   997,   390,   998,
     391,   392,   393,   394,   395,   396,   397,   398,   399,  1001,
    1004,  1003,  1000,  1002,  1005,  1006,  1007,  1010,  1008,  1009,
    1011,  1012,  1013,  1014,  1015,  1016,  1017,   420,   421,   256,
     387,   387,   387,   387,   387,   387,   387,   387,   387,   387,
     387,   387,   387,     0,    43,    44,    45,    46,    47,    48,
      49,    50,    51,     0,    41,   262,     0,   264,   387,     0,
      37,    39,     0,     0,     7,     9,    14,    16,    15,    17,
       0,   387,    13,    65,   147,   148,    58,     0,     0,    64,
       0,    67,    68,     0,   108,   109,    94,    96,    97,    98,
     159,   387,     0,   295,   110,     0,     0,    53,     0,     0,
     119,   962,   966,     0,   164,   124,    18,   146,   132,     0,
     122,   123,   149,   137,     0,   295,   138,     0,   387,   126,
     136,     0,   127,     0,   134,   125,   165,   166,   473,   502,
       0,     0,    18,    18,   514,     0,     0,     0,     0,     0,
      18,     0,    18,     0,     0,     0,   515,     0,    21,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      18,     0,     0,     0,     0,    18,     0,    18,     0,    18,
       0,    18,     0,     0,    18,    18,    18,     0,     0,     0,
     503,   563,    18,   574,   566,    18,   571,   568,     0,   564,
     576,   699,     0,     0,     0,   700,   713,   786,   828,    18,
     833,     0,   829,   844,     0,   843,     0,   847,     0,   845,
     846,   850,     0,   858,     0,    81,     0,    83,    18,    18,
      18,   964,   965,   963,     0,    31,     0,   968,   967,   176,
     175,   177,   179,   180,   178,     0,   173,   269,     0,    73,
      79,    69,   267,   268,   186,   187,     0,   184,   270,   244,
     247,     0,   203,   208,   226,     0,   233,   232,     0,     0,
     209,   216,     0,     0,   224,   295,   218,   217,   221,   222,
       0,   223,   225,   211,     0,   215,   234,   242,   236,   239,
     240,   238,   241,   237,     0,   680,   680,     0,   206,   680,
     206,   680,   681,   680,   680,   854,   680,   680,   680,     0,
       0,    23,     0,     0,   366,   367,     0,   368,   369,   364,
     352,   448,   451,     0,   428,     0,   429,   371,   372,   365,
       0,     0,     0,     0,     0,     0,   335,   387,   400,   387,
     329,   327,     0,     0,   326,     0,     0,   381,   354,   355,
       0,     0,   382,   412,   410,   408,   405,   406,   407,   409,
     411,   413,   401,   402,   403,   404,   422,     0,   423,   425,
     426,   427,   260,     0,   257,     0,    34,     0,    33,    66,
       0,     0,    60,    61,    62,    63,    10,    11,    12,     0,
     149,     0,     0,    92,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,     0,     0,     0,   279,
     299,     0,   104,   105,     0,    99,   101,    52,     0,   295,
     120,     0,   114,     0,   133,   153,   156,   169,   145,   139,
     129,   300,   301,   135,    18,   302,   130,   128,   121,     0,
       0,     0,     0,     0,     0,   508,    18,   544,   547,     0,
       0,     0,     0,    18,     0,    18,     0,   561,   516,     0,
     499,     0,     0,   506,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   510,     0,   511,
       0,   542,     0,     0,     0,     0,     0,     0,     0,   522,
     523,     0,     0,     0,   549,     0,   545,   570,   567,     0,
     572,     0,     0,   702,   703,   121,   121,     0,     0,   840,
      21,   842,     0,   837,   841,   387,   832,   121,    91,    82,
      84,    85,    86,    89,    25,    24,    90,   172,     0,    70,
     183,     0,   204,   230,   229,   228,   213,   220,   214,   212,
     219,   497,   679,     0,     0,   688,   697,     0,   695,   692,
       0,     0,   690,     0,   680,     0,   680,     0,     0,     0,
       0,     0,     0,    26,    27,     0,     0,   363,   387,   437,
       0,   387,   387,   387,   415,   387,   435,   387,     0,     0,
     387,   387,   387,   319,   314,   387,   343,   349,     0,     0,
     358,   387,    42,     6,    40,     8,    59,   106,   160,    93,
      95,   294,   293,   295,   387,   103,   102,   304,   297,     0,
     307,     0,   167,   154,     0,   149,     0,   144,   131,   476,
     476,     0,   475,   469,     0,     0,     0,   560,     0,   556,
     555,     0,   546,   550,   551,   552,     0,   540,     0,   531,
      22,     0,   500,   501,   504,     0,   512,     0,     0,   535,
       0,   518,   517,   530,   529,   524,     0,     0,   543,   527,
     519,   520,   521,   548,   558,   526,   525,   559,   528,   553,
       0,   569,   669,    18,     0,    18,   587,     0,     0,   589,
     579,    18,   575,     0,   593,   670,   701,   716,     0,   708,
     710,     0,   715,   705,     0,   789,    18,     0,   788,   781,
       0,   830,   831,   839,    21,    18,     0,   838,     0,   441,
       0,   442,   443,     0,   387,   439,   440,   438,   387,   387,
      18,   853,     0,     0,   387,   848,   851,   861,   860,   856,
       0,     0,   174,   185,   683,   682,   696,   691,   693,   694,
       0,   684,     0,   686,   825,   826,   880,   881,   882,     0,
       0,   449,   430,     0,     0,     0,     0,     0,   387,   385,
     328,   326,     0,     0,   332,     0,     0,     0,   296,     0,
     387,   310,     0,   303,     0,   150,   151,   155,   157,   142,
     140,   141,   143,   149,   470,   485,   471,   489,   472,   474,
       0,   536,   557,   538,   539,   541,   507,   505,   534,   533,
     513,   532,   509,   554,   149,   592,   580,     0,     0,    18,
       0,   578,     0,     0,   596,   591,   595,     0,     0,   585,
     577,     0,   603,   149,   706,   744,   753,   707,     0,     0,
     712,   714,   149,   785,   782,   784,   787,   834,   836,   835,
     387,   387,   387,   387,     0,     0,     0,     0,     0,     0,
     461,   444,   446,     0,   149,   857,   859,    87,   685,   687,
     243,   243,   434,   432,   433,   431,   387,     0,   330,   387,
       0,   424,   305,   311,   298,     0,   152,   158,   485,   483,
     488,     0,     0,   492,     0,   672,   676,   582,   583,   581,
     584,   657,   617,   597,   657,   586,   671,   604,   741,   751,
     750,   757,   756,   764,   709,   766,   767,   774,   711,   822,
       0,     0,     0,     0,     0,   455,   387,   359,   849,   387,
     387,     0,   387,   460,   877,     0,     0,     0,   386,     0,
       0,     0,   356,     0,   487,     0,   490,   491,     0,   494,
     537,   670,   674,   678,     0,     0,     0,   606,   739,   738,
       0,   755,   762,   772,   820,   790,   783,   454,   388,   458,
       0,   387,   452,   312,     0,     0,     0,     0,     0,     0,
       0,     0,   447,   875,   862,   245,   246,   436,   387,   339,
     387,   337,     0,    18,     0,     0,     0,     0,   486,     0,
     493,    18,   496,   673,     0,   588,   660,   658,   661,    18,
       0,    18,   594,     0,   590,     0,     0,     0,     0,     0,
       0,     0,     0,   602,   616,   189,   193,     0,     0,   743,
       0,     0,    18,    18,    18,   754,     0,   758,   768,     0,
     824,     0,     0,   387,   387,   321,   325,   323,   387,   462,
     324,   346,   344,   345,   350,     0,   457,   456,   387,   387,
     387,   387,   463,   863,   879,     0,     0,   112,   482,     0,
       0,     0,   477,   481,   484,   495,     0,     0,     0,    18,
       0,     0,     0,    18,     0,    18,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   677,
     656,     0,   662,     0,     0,   600,   601,   599,   598,   194,
     190,   610,   608,   607,     0,     0,   611,   613,   614,   615,
     195,   605,     0,     0,     0,     0,     0,    18,     0,     0,
       0,     0,   729,   731,   742,     0,     0,     0,   745,   746,
     747,   752,     0,     0,   761,     0,     0,     0,   771,     0,
       0,     0,     0,    18,     0,    18,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   823,   815,
       0,   459,   313,   453,   361,   326,     0,   387,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   878,     0,   387,   338,     0,     0,     0,    18,   622,
     664,   654,     0,     0,     0,     0,     0,   649,    18,   655,
       0,   638,   618,   621,   619,     0,   636,     0,   623,   625,
     626,   627,   628,   629,   630,   631,   632,    18,   643,   644,
     645,    18,   620,     0,    18,   675,   663,   659,     0,     0,
     609,   612,     0,     0,     0,     0,     0,   728,     0,     0,
       0,     0,     0,   720,    18,     0,     0,     0,    18,     0,
      18,     0,   740,   778,   778,     0,   776,   760,   759,   765,
     763,   770,   769,   775,   773,   796,    18,    18,     0,   794,
     795,   813,     0,     0,     0,   808,   791,    18,   816,   818,
     817,   819,   814,     0,   793,   792,     0,     0,    18,   797,
      18,    18,   821,   322,   387,   347,   360,   351,     0,     0,
       0,     0,   864,    18,     0,     0,     0,   872,     0,   868,
     869,     0,   865,   876,     0,   478,   479,   480,   639,     0,
     647,   646,   648,   161,   162,   650,   651,     0,   652,    18,
     635,   624,   634,   637,   640,   633,   188,   190,     0,     0,
       0,     0,     0,   192,     0,   719,     0,   735,   736,   737,
     727,   778,   722,   721,   723,   724,     0,   733,   730,   734,
     732,    18,   748,   749,   777,   812,   801,   803,   806,   809,
     807,     0,   810,   805,   802,   804,   798,   799,   800,     0,
     467,   465,   466,   464,   874,   870,   873,   871,   866,   867,
     331,   642,   666,   665,   653,   641,   191,   195,    28,     0,
       0,     0,     0,   718,   717,   726,   725,   779,   811,   667,
       0,   200,   195,   195,   195,   195,   668,   196,   197,   198,
     199
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1491, -1491, -1491, -1491,  -112,  -209,    63,  -267,  -912,  -159,
    -737, -1491,  -807,   -86, -1491, -1491, -1491, -1491, -1491,  1440,
    1149, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491, -1491,   638,  1641, -1491, -1491, -1491, -1491, -1491, -1491,
    -293, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491,  1367,  -106,  1742, -1491,    81,  -500, -1491, -1491, -1491,
   -1491,   921,  -596,  -637, -1491, -1491, -1111, -1491, -1491, -1491,
   -1491,   152, -1491,  1009,   234, -1491,  1016, -1030,   207, -1490,
   -1491,  -772, -1491, -1491, -1491, -1491,  -154, -1491, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491,  -265, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491, -1491,   951,  1646, -1491, -1491, -1491, -1491,  -853,   945,
     774,  1446,  1275,  1656, -1491,  1142, -1491, -1491, -1339, -1491,
     519,  -193,  1206,   403, -1050,   991, -1295, -1219,  1860, -1293,
    1230,   402, -1491, -1491,  -191,  1267, -1491, -1491, -1491, -1491,
     483,   675, -1491, -1491,  -974, -1491,   365,   852,   -17, -1491,
   -1491,   653,  1021,   749,  -987, -1491, -1491, -1491, -1491,  1002,
   -1491, -1491,   699, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491,  1159, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491,   729, -1491, -1491, -1491, -1491, -1491, -1491, -1491,   679,
   -1491, -1491, -1491, -1491, -1491,   357, -1491, -1491, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491,   511,   488, -1491,
   -1491, -1491, -1491,   376,   489, -1491, -1491, -1491, -1491,   381,
     497, -1391, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,  1120, -1491,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491, -1491,
   -1491, -1491, -1491, -1075
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    92,   562,   571,   563,   404,   940,  1005,
    1006,   791,  1879,   213,   716,    93,   550,   214,   553,   543,
     544,    94,   222,   223,    95,    96,    20,    21,    22,    23,
      24,    25,   141,   365,    97,   348,    98,   354,   349,    99,
     582,   100,   585,   896,   101,   575,   102,   103,   593,   104,
     105,   238,   266,   609,  1097,   910,   598,   106,   905,  1257,
    1094,   906,  1357,  1358,   870,   871,  1677,   107,   108,   602,
     267,   359,   725,   726,   374,   736,   737,  1494,  1708,  1495,
    1496,  1715,    26,    27,    28,    29,   395,    30,    31,    32,
     386,   764,    33,   383,   749,    34,   387,   376,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,   206,   546,    48,    49,    50,    51,    52,    53,    54,
      55,    56,   135,   380,   109,   583,   110,   886,   887,   888,
    1089,   912,   913,   610,   899,   890,   111,   588,  1249,  1250,
    1442,   195,   450,  1521,   821,   822,   451,  1243,   823,   452,
     453,  1524,   454,  1525,   196,   456,   457,  1444,   420,   197,
     421,   430,   198,   199,   200,  1203,   201,   517,  1241,  1204,
    1332,  1333,   802,   803,  1251,   112,  1104,   918,   113,  1263,
    1469,  1415,  1360,  1264,  1266,  1363,  1419,  1472,  1268,    57,
     114,   639,   115,   116,   117,   321,   322,   323,   981,  1163,
    1292,  1297,  1295,  1296,  1425,  1483,  1164,  1427,  1497,  1165,
    1571,  1424,  1477,  1478,  1574,  1799,  1890,  1873,  1284,  1302,
    1366,  1421,  1474,  1423,  1285,  1023,    58,    59,    60,    61,
      62,    63,    64,    65,   777,   118,   119,   120,  1174,  1308,
    1309,   985,   121,  1303,  1605,  1729,  1731,  1830,  1499,  1498,
    1429,  1304,  1306,  1506,  1431,  1430,  1380,  1307,  1383,  1432,
    1615,  1739,  1507,  1384,  1387,  1433,  1619,  1743,  1508,  1388,
    1737,  1842,   122,  1180,   986,   123,  1312,  1510,  1640,  1762,
    1509,  1435,  1313,    66,    67,   124,   125,   337,   993,   994,
     338,  1206,   995,   702,    68,   126,  1210,   997,   127,  1334,
    1534,  1662,  1533,  1454,  1335,    69,    70,    71,   128,    72,
     129,   130,   131,   518
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     202,   449,   233,   455,   405,   406,   907,   398,  1205,   310,
    1240,   320,   428,   328,  1460,  1385,   572,   638,   641,   336,
     673,  1202,  -309,  1019,   350,   355,   554,  1514,   402,   403,
     555,  -309,  -309,  -309,  -309,  1188,  1515,  1516,  1517,  1064,
     520,   521,   522,   523,   524,  1088,   402,   403,  1320,   415,
     828,   829,  1720,   416,   525,   526,   527,   528,   529,   530,
     531,   532,   417,   551,   533,   426,  1189,   520,   521,   522,
     523,   524,   234,   402,   403,   554,   789,   901,  1183,   555,
     203,   525,   526,   527,   528,   529,   530,   531,   532,   204,
    1709,   533,   402,   403,   556,   557,   558,   559,   662,  1758,
    1479,   399,  1512,   620,  1081,   565,  -308,   941,  1764,     1,
    1202,  1718,   570,   570,  1185,  -308,  -308,  -308,  -308,  1188,
     520,   521,   522,   523,   524,   554,   660,  1329,   560,   555,
    1411,   396,  1361,  1190,   525,   526,   527,   528,   529,   530,
     531,   532,   554,   400,   533,   600,   555,  1587,   356,  1522,
    1189,  1523,   444,   445,   446,   177,   447,   357,   371,   236,
     967,   556,   557,   558,   559,   554,   431,   372,   554,   555,
     381,   637,   555,   397,   690,  1644,   443,   614,   520,   521,
     522,   523,   524,  1765,   556,   557,   558,   559,   908,  1698,
     627,   988,   525,   526,   527,   528,   529,   530,   531,   532,
     826,   621,   533,   827,   676,  1191,  1192,  1193,  1194,  1195,
    1196,  1197,   444,   445,   446,  1064,   447,  1190,  1719,   576,
     554,   577,   578,   579,   555,  1198,  1186,   763,  1199,   554,
     631,   554,   941,   555,   774,   555,   775,   776,   942,   779,
     781,  1536,   783,   784,  1480,   786,   787,   788,   556,   557,
     558,   559,   730,   951,   643,   173,    73,   174,   175,   176,
     177,   178,   179,  1353,   142,   644,   554,  1481,   180,   181,
     555,   182,  1317,   183,  1078,   237,  1202,   427,   663,  1515,
    1516,  1517,  1064,   520,   521,   522,   523,   524,  1082,  1191,
    1192,  1193,  1194,  1195,  1196,  1197,   389,   525,   526,   527,
     528,   529,   530,   531,   532,   661,   904,   533,  1776,  1198,
     402,   403,  1199,  1759,   520,   521,   522,   523,   524,  1440,
    1721,   601,   444,   445,   446,  1064,   447,  1709,   525,   526,
     527,   528,   529,   530,   531,   532,   632,  1746,   533,   580,
     628,   566,   382,  1843,   576,   635,   577,   578,   579,  1394,
     149,   859,  1362,  1522,  1482,  1523,   902,  1256,  1588,   184,
     656,  1589,   633,   942,   224,   185,   554,   936,   564,   667,
     555,   669,   520,   521,   522,   523,   524,   674,   567,   568,
     677,   225,   952,   401,  1760,  1761,   525,   526,   527,   528,
     529,   530,   531,   532,   930,   931,   533,   390,   215,  1088,
    1699,   796,  1712,  1700,   705,   595,   707,   801,  1535,  1443,
    1515,  1516,  1517,  1064,   226,   810,   811,   812,   813,   814,
     186,   187,  1202,  1386,   218,  1572,   150,   990,   429,   991,
     554,   824,  1573,  1461,   555,   636,   561,  1713,  1747,  1475,
    1885,  -309,   744,   219,  1570,  -309,  1518,   552,   570,  1004,
    1519,  1321,   830,   734,   861,   188,   189,  1484,   818,   418,
     391,   869,   819,   856,   640,   419,   586,  1202,  1673,  1674,
     163,   216,   190,   205,   790,   191,  1819,   217,  1820,  1639,
     192,  1714,   554,  1298,  1871,   561,   555,   209,   210,  1048,
     943,   735,   909,  1004,   389,  1585,  1056,   220,   615,   909,
    1057,   909,  1381,   833,   834,   835,   836,   837,   838,   839,
     840,   841,   842,   843,   844,   845,  1755,   929,  1356,   778,
     164,  1673,  1674,  1044,   745,  -308,  1443,   208,   944,  -308,
     946,   855,   891,   949,  1149,   561,   953,   954,   422,  1202,
    1202,   358,  1051,   228,   860,  1787,  1673,  1674,   227,  1768,
    1400,   373,   561,   520,   521,   522,   523,   524,   221,  1687,
    1401,   554,   448,   229,   872,   555,   980,   525,   526,   527,
     528,   529,   530,   531,   532,   561,   389,   533,   561,  1616,
     556,   557,   558,   559,   746,   554,  1617,  1612,   963,   555,
    1015,   915,   998,  1613,   999,   402,   403,  1800,  1801,   747,
    1052,   780,  1003,   230,   556,   557,   558,   559,   232,   831,
     231,   748,   832,  1794,   235,  1276,  1188,   964,   965,   136,
    1259,   922,  1065,  1618,  1034,  1675,  1036,  1086,   392,   581,
     561,  1614,   449,   449,   520,   521,   522,   523,   524,   561,
     455,   561,   393,   394,   892,   893,   894,  1189,   525,   526,
     527,   528,   529,   530,   531,   532,   240,    74,   533,   903,
     554,   209,   210,  1676,   555,  1137,  1378,   193,  -450,  1260,
    1261,  1262,   361,  1202,   194,  1389,   561,  1043,  1753,   556,
     557,   558,   559,   648,   649,   921,   924,    75,  1365,  1774,
     132,   133,   916,   932,   917,   934,    76,  1404,  1821,    77,
    1822,  1447,  1653,  1785,   362,  1053,   132,   133,  1463,  1647,
      78,   366,  1648,   955,  1190,   134,  1754,   364,   960,   367,
     962,   370,   966,    79,   968,  1184,  1654,   971,   972,   973,
     384,   134,   448,    80,  1216,   977,  1055,  1217,   978,    81,
    1219,  1786,  1091,   375,   520,   521,   522,   523,   524,   377,
     378,   385,   987,   388,   581,   423,  1448,  1449,   525,   526,
     527,   528,   529,   530,   531,   532,   389,    82,   533,    83,
      84,  1000,  1001,  1002,   379,   360,   561,    85,   363,  1085,
     422,   407,   422,   408,   422,   422,  1191,  1192,  1193,  1194,
    1195,  1196,  1197,   409,  1238,   652,   653,   603,   410,   719,
    1058,   411,  1059,   412,    86,    87,  1198,  1105,  1106,  1199,
    1108,  1450,  1103,   424,  1464,  1465,    88,  1451,  1466,  1467,
    1518,   611,   531,   532,   683,   684,   533,  1004,   413,  1122,
    1123,   145,   146,  1125,  1267,  1127,  1128,   414,  1130,    89,
     561,   425,    90,   432,  1136,   433,   720,   721,   866,   867,
     868,  1735,   923,   434,   520,   521,   522,   523,   524,   722,
     723,   435,   724,  1150,  1827,  1828,  1829,  1151,   525,   526,
     527,   528,   529,   530,   531,   532,   605,   606,   533,  1173,
    1179,   173,   436,   174,   175,   176,   177,   178,   179,  1290,
    1807,  1209,   561,   545,   180,   181,   820,   182,   794,   183,
     795,   437,   797,   798,   547,  1655,  1656,   173,   548,   174,
     175,   176,   177,   178,   179,   895,   377,   378,   554,   549,
     180,   181,   555,   182,   569,   183,   402,   403,   989,   173,
     573,   174,   175,   176,   177,   178,   179,   556,   557,   558,
     559,   574,   180,   181,   820,   182,   693,   183,   520,   521,
     522,   523,   524,   852,   853,   209,   210,   584,   143,   144,
     147,   148,   525,   526,   527,   528,   529,   530,   531,   532,
     207,   561,   533,   862,   863,  1346,   587,  1098,   589,   211,
     402,   403,  1255,  1657,   590,   184,   591,  1658,  1004,  1111,
     212,   185,   592,   608,   594,   561,  1116,   596,  1118,  1294,
    1372,  1468,  1287,  1288,   520,   521,   522,   523,   524,  1305,
     694,   184,  1310,  1880,  1881,  1882,  1025,   185,   525,   526,
     527,   528,   529,   530,   531,   532,  -308,  1188,   533,   864,
     865,   801,  1026,   184,  1233,  1234,  1235,  1289,  1236,   185,
    1237,  1382,   695,  1007,  1008,  1244,   186,   187,  1245,  1010,
    1011,   696,  1047,   597,  1247,   599,   165,   613,  1189,  1074,
     853,  1659,  1539,  1540,   616,  1315,   622,  1485,  1789,  1790,
     561,   617,   186,   187,  1319,  1405,  1406,   618,    91,   623,
    1660,   188,   189,   438,   439,   440,   441,  1500,  1501,  1486,
    1661,  1502,  1503,  1504,   186,   187,   368,   369,   190,  1337,
     619,   191,  1487,   807,   808,  1891,   192,   188,   189,   438,
     439,   440,   441,   624,   625,   626,   166,   629,   167,   168,
    1897,  1898,  1899,  1900,   190,  1190,  1027,   191,   136,   188,
     189,   630,   192,  1024,  1505,   634,  1035,   642,  1037,   645,
    1038,  1039,   646,  1040,  1041,  1042,   190,   647,  1851,   191,
     651,  1470,   650,   654,   192,   655,   657,   659,  1364,   169,
     170,   171,   172,   137,  1397,   658,   697,   698,   699,   700,
     664,   138,   139,   140,   665,  1367,  1368,  1324,  1370,   666,
     668,  1325,  1326,   671,   670,   672,  1375,  1331,   675,  1376,
     520,   521,   522,   523,   524,   678,   679,  1191,  1192,  1193,
    1194,  1195,  1196,  1197,   525,   526,   527,   528,   529,   530,
     531,   532,   680,   681,   533,   682,  1286,  1198,  1291,   686,
    1199,  1347,   689,   685,  1299,   687,   520,   521,   522,   523,
     524,  1689,  1690,  1691,  1692,  1693,  1694,  1695,  1696,  1314,
     525,   526,   527,   528,   529,   530,   531,   532,  1318,  1200,
     533,  1520,   688,   691,  1488,  1489,  1490,  1542,  1491,   701,
     692,   703,   704,  1327,   706,  1476,   708,  1476,   710,  1492,
     709,   714,  1054,   711,  1028,   712,  1417,   713,  1436,   874,
     875,   876,   877,   878,   879,   880,   715,   881,   882,   883,
     884,   885,   727,   193,   520,   521,   522,   523,   524,   846,
     194,   717,   729,  1391,   801,  1393,   718,   731,   525,   526,
     527,   528,   529,   530,   531,   532,   732,   733,   533,   193,
    1029,   738,   847,   740,  1030,   739,   194,   742,   561,  1407,
     848,   743,  1244,   782,   785,   849,   850,   851,   800,  1031,
     792,   193,   793,   799,   805,   804,  1382,   533,   194,   806,
     809,   815,  1369,   816,   570,  1543,   817,  1750,   825,   854,
     898,   858,  1493,   873,   900,   914,  1063,   897,  1576,   919,
    1032,  1033,   920,   925,   927,  1581,  1582,  1583,   928,  1586,
     933,   937,  1445,  1446,   926,  1331,   520,   521,   522,   523,
     524,  1220,   935,  1222,   939,   938,   603,   945,   957,  1579,
     525,   526,   527,   528,   529,   530,   531,   532,   947,   958,
     533,   948,   520,   521,   522,   523,   524,   950,   956,   959,
     604,   961,  1075,   975,   969,   970,   525,   526,   527,   528,
     529,   530,   531,   532,  1305,  1669,   533,  1201,   974,   976,
     979,   982,   983,  1244,  1682,  1683,  1684,   984,  1686,  1688,
     992,   996,  1009,  1520,  1702,  1520,  1795,  1796,  1797,  1012,
    1013,  1706,  1382,  1014,   173,   239,   174,   175,   176,   177,
     178,   179,  1710,  1711,   252,   605,   606,   180,   181,   268,
     182,   269,   183,   311,   607,   324,  1016,   329,  1017,   330,
    1020,   331,  1021,   339,  1733,  1734,  1022,  1045,  1046,  1049,
    1736,  1645,  1050,  1060,  1736,  1068,  1061,  1062,  1745,  1087,
    1069,  1649,  1650,  1651,  1652,  1071,  1756,  1076,  1093,  1077,
    1079,  1083,  1092,  1769,  1096,  1120,  1538,  1084,  1107,  1211,
    1095,  1109,  1872,   173,  1545,   174,   175,   176,   177,   178,
     179,  1782,  1575,  1110,  1577,  1112,   180,   181,  1792,   182,
    1113,   183,  1114,   570,   570,   570,  1115,  1117,  1119,  1124,
    1802,  1803,  1804,  1805,  1806,  1608,  1609,  1610,   184,  1126,
    1129,  1131,  1132,  1810,   185,  1811,  1133,  1134,  1135,  1138,
    1139,   173,  1140,   174,   175,   176,   177,   178,   179,  1141,
    1142,  1814,   608,  1143,   180,   181,  1410,   182,  1144,   183,
    1818,  1214,  1145,  1146,  1147,  1148,  1825,  1166,  1080,  1831,
    1832,  1181,  1671,  1834,  1835,  1182,  1679,  1215,  1681,  1218,
    1221,  1223,  1224,  1844,  1225,  1229,  1226,  1227,  1228,   186,
     187,  1230,  1232,  1246,  1252,  1253,  1847,   184,  1254,  1269,
    1848,  1849,  1850,   185,  1239,  1271,  1270,  1272,  1273,  1301,
    1274,  1853,  1275,  1293,  1854,  1855,  1322,  1277,   151,   152,
    1723,  1278,  1279,  1280,   188,   189,  1281,   253,   153,  1282,
    1283,  1300,  1865,  1866,  1867,  1323,  1868,  1311,  1316,  1869,
    1330,   190,  1336,   154,   191,   184,  1749,   254,  1751,   192,
    1338,   185,   155,  1339,   156,   157,  1340,  1341,   186,   187,
    1348,   520,   521,   522,   523,   524,  1349,   255,  1352,  1350,
    1073,  1355,  1883,  1359,  1884,   525,   526,   527,   528,   529,
     530,   531,   532,  1390,  1886,   533,  1371,  1398,  1373,  1374,
    1377,  1798,  1399,   188,   189,   256,  1379,  1402,  1409,   257,
     258,  1808,   259,   260,   261,  1412,   186,   187,  1413,   262,
     190,  1403,  1416,   191,  -451,  -451,  -451,  1859,   192,   158,
    1812,  1418,  1455,  1420,  1813,  1422,  1438,  1815,  -451,  -451,
    -451,  -451,   529,   530,   531,   532,  1428,  1434,   533,   263,
    1456,   188,   189,  1453,   264,  1458,  1462,  1833,  1459,  1471,
    1513,  1837,  1511,  1839,  1528,  1529,  1530,  1532,   190,  1531,
    1537,   191,  1541,  1544,  1342,  1578,   192,  1591,  1580,  1845,
    1846,   534,   535,   536,   537,   538,   539,   540,   541,   542,
    1852,   520,   521,   522,   523,   524,  1584,  1590,   159,  1606,
    1343,  1856,  1607,  1857,  1858,   525,   526,   527,   528,   529,
     530,   531,   532,  1611,  1641,   533,  1864,   520,   521,   522,
     523,   524,  1642,  1646,  1663,  1664,  1665,  1666,  1667,  1668,
    1670,   525,   526,   527,   528,   529,   530,   531,   532,  1672,
    1680,   533,  1875,  1678,  1685,  -445,   193,   520,   521,   522,
     523,   524,  1697,   194,  1701,  1703,  1704,  1705,  1707,  1485,
    1716,   525,   526,   527,   528,   529,   530,   531,   532,  1722,
    1725,   533,  1724,  1726,  1887,   520,   521,   522,   523,   524,
    1727,  1728,  1730,  1385,  1752,  1748,   160,  1732,  1740,   525,
     526,   527,   528,   529,   530,   531,   532,  1744,  1757,   533,
    1763,   161,  1766,  1767,  1770,  1771,   162,  1772,  1783,   520,
     521,   522,   523,   524,  1784,   193,  1788,  1791,  1809,  1793,
    1824,  1817,   194,   525,   526,   527,   528,   529,   530,   531,
     532,  1826,  1816,   533,   520,   521,   522,   523,   524,  1823,
    1836,  1860,  1841,  1861,  1862,  1863,  1874,  1877,   525,   526,
     527,   528,   529,   530,   531,   532,  1878,  1870,   533,  1888,
     458,  1889,   857,   193,   520,   521,   522,   523,   524,  1892,
     194,   728,  1072,   612,  1893,  1894,  1895,  1896,   525,   526,
     527,   528,   529,   530,   531,   532,  1258,  1212,   533,   520,
     521,   522,   523,   524,  1876,   741,  1354,  1213,  1248,   889,
    1018,  1066,  1643,   525,   526,   527,   528,   529,   530,   531,
     532,  1090,   765,   533,   520,   521,   522,   523,   524,  1775,
    1777,   265,  1242,   442,  1328,  1452,  1067,  1414,   525,   526,
     527,   528,   529,   530,   531,   532,   459,   460,   533,  1231,
    1392,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,  1070,  1121,
    1473,  1738,  1265,  1426,  1717,  1838,  1742,   520,   521,   522,
     523,   524,  1840,  1741,  1187,     0,     0,     0,     0,  1344,
     488,   525,   526,   527,   528,   529,   530,   531,   532,   911,
       0,   533,     0,     0,     0,     0,     0,     0,   520,   521,
     522,   523,   524,     0,     0,     0,     0,     0,     0,     0,
       0,   489,   525,   526,   527,   528,   529,   530,   531,   532,
       0,     0,   533,   520,   521,   522,   523,   524,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,     0,     0,   533,     0,     0,
       0,     0,     0,  1188,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   490,   491,     0,   492,   493,   494,
     495,   496,   497,   498,   520,   521,   522,   523,   524,     0,
       0,     0,     0,     0,  1189,     0,     0,     0,   525,   526,
     527,   528,   529,   530,   531,   532,     0,     0,   533,  1345,
       0,     0,     0,   458,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   499,   500,   501,   502,   503,   504,
     505,   506,   507,     0,     0,  1351,     0,     0,   520,   521,
     522,   523,   524,     0,     0,     0,     0,  1620,     0,     0,
     508,   509,   525,   526,   527,   528,   529,   530,   531,   532,
       0,  1190,   533,     0,     0,  1408,     0,   510,   511,   512,
     513,  1621,  1622,     0,     0,     0,   874,   875,   876,   877,
     878,   879,   880,     0,   881,   882,   883,   884,   885,   459,
     460,     0,     0,  1457,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,     0,     0,     0,     0,     0,     0,  1773,     0,     0,
       0,     0,   253,  1191,  1192,  1193,  1194,  1195,  1196,  1197,
    1485,     0,  1623,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1778,  1198,     0,   766,  1199,   253,     0,     0,
       0,  1624,  1486,     0,     0,     0,   514,   515,     0,     0,
       0,   767,   255,     0,   489,     0,     0,   516,     0,     0,
     253,     0,  1779,     0,   340,   341,   342,     0,   343,   344,
       0,   345,     0,     0,     0,   346,     0,   255,     0,     0,
     256,     0,     0,     0,   257,   258,     0,  1780,   260,   261,
       0,     0,     0,     0,   262,     0,     0,     0,   312,     0,
     255,     0,     0,     0,     0,   256,     0,     0,     0,   257,
     258,     0,  1781,   260,   261,     0,     0,   768,     0,   262,
       0,     0,     0,     0,   263,     0,     0,  1625,   256,   264,
    1626,  1627,   257,   258,     0,     0,   260,   261,     0,   253,
       0,     0,   262,     0,     0,     0,     0,   769,   770,   263,
    1628,   253,     0,     0,   264,   771,   270,   499,   500,   501,
     502,   503,   504,   505,   506,   507,     0,     0,     0,     0,
       0,   271,   263,  1395,     0,     0,     0,   264,     0,   255,
       0,     0,   772,   508,   509,   272,     0,  1629,     0,     0,
       0,   255,     0,     0,   253,     0,     0,     0,     0,     0,
     510,   511,   512,   513,  1437,     0,     0,   256,     0,     0,
       0,   257,   258,     0,  1099,   260,   261,     0,     0,   256,
     773,   262,  1630,   257,   258,   273,   274,   260,   261,  1439,
       0,     0,     0,   262,   255,     0,     0,   275,  1631,     0,
     276,   253,   277,     0,     0,     0,     0,     0,     0,     0,
       0,   263,  1441,  1152,     0,  1632,   264,     0,     0,     0,
       0,   332,   256,   263,     0,     0,   257,   258,   264,  1167,
     260,   261,   241,     0,     0,     0,   262,   242,     0,     0,
    1526,   255,   278,     0,   279,     0,  1633,  1634,     0,  1635,
    1636,     0,  1637,   280,     0,     0,     0,     0,     0,   514,
     515,     0,     0,     0,     0,   253,   263,     0,  1153,   256,
     516,   264,     0,   257,   258,  1638,     0,   260,   261,   243,
       0,     0,     0,   262,     0,     0,   313,     0,     0,   281,
       0,   314,   315,   316,  1527,   325,   326,     0,     0,     0,
       0,     0,  1100,  1101,     0,   255,     0,   282,  1168,  1546,
       0,     0,   244,   263,   283,   284,     0,   285,   264,   286,
     287,   253,   288,   289,     0,   290,     0,   317,   291,   292,
       0,   293,   333,   256,   318,     0,     0,   257,   258,   253,
    1175,   260,   261,     0,   294,   295,     0,   262,     0,   296,
     351,   297,   298,     0,   299,  1154,   327,     0,     0,   300,
       0,   255,     0,   301,   302,     0,   303,   304,     0,   305,
     306,   307,     0,     0,     0,   308,     0,   263,  1485,   255,
       0,   347,   264,     0,     0,     0,     0,     0,     0,   256,
       0,     0,     0,   257,   258,     0,     0,   260,   261,     0,
    1486,   245,  1592,   262,   319,     0,     0,   256,     0,     0,
    1155,   257,   258,  1547,  1207,   260,   261,     0,   352,     0,
       0,   262,     0,     0,     0,     0,     0,  1548,     0,     0,
       0,  1593,     0,   263,  1156,     0,  1157,     0,   264,     0,
       0,  1158,     0,  1159,   520,   521,   522,  1160,  1161,     0,
       0,   263,     0,   334,     0,     0,   264,     0,   525,   526,
     527,   528,   529,   530,   531,   532,     0,     0,   533,     0,
     246,     0,     0,     0,  1594,     0,     0,     0,     0,     0,
       0,     0,     0,  1102,     0,  1549,     0,     0,  1550,  1551,
       0,     0,     0,     0,  1595,   309,     0,     0,  1169,  1170,
       0,     0,  1171,     0,     0,     0,   874,   875,   876,   877,
     878,   879,   880,   750,   881,   882,   883,   884,   885,     0,
       0,     0,  1162,     0,     0,     0,     0,   247,   402,   403,
       0,     0,   248,     0,     0,     0,     0,     0,  1172,  1596,
       0,     0,     0,     0,     0,  1552,     0,     0,  1553,     0,
       0,  1554,     0,     0,   751,     0,     0,     0,   249,     0,
       0,  1555,     0,  1556,     0,  1557,  1558,  1559,  1560,  1561,
    1562,     0,  1176,   250,     4,     0,  1563,     0,   251,     0,
    1564,  1565,     0,     0,  1566,   335,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   752,  1567,     0,     0,     5,
       6,     0,     0,     0,  1568,     0,  1597,  1598,     0,     7,
    1599,  1600,     0,  1601,     0,     0,     0,     0,     0,  1177,
       0,  1602,  1603,     0,     0,   753,     0,     0,     0,     0,
       0,     0,   754,   755,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   756,     0,     0,     0,     0,     0,  1178,
       0,     0,   757,   758,   759,   760,     0,   761,   762,     0,
       8,  1604,   520,   521,   522,   523,   524,     0,     0,     0,
       0,     0,     0,  1569,     0,     0,   525,   526,   527,   528,
     529,   530,   531,   532,     0,     0,   533,     0,     9,     0,
       0,    10,     0,    11,     0,     0,     0,     0,     0,     0,
      12,     0,    13,     0,     0,   353,     0,    14,    15,    16,
       0,     0,   519,     0,    17,    18,    19,   520,   521,   522,
     523,   524,     0,  1208,     0,     0,     0,     0,     0,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,     0,
       0,   533,   520,   521,   522,   523,   524,     0,     0,     0,
     608,     0,     0,     0,     0,     0,   525,   526,   527,   528,
     529,   530,   531,   532,     0,     0,   533,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1396
};

static const yytype_int16 yycheck[] =
{
      17,   194,    88,   194,   163,   164,   602,   161,   995,   115,
    1060,   117,    15,   119,     7,    20,   225,   284,   285,   125,
     313,   995,     6,   760,   130,   131,    15,     6,    18,    19,
      19,    15,    16,    17,    18,    19,    15,    16,    17,    18,
       8,     9,    10,    11,    12,   898,    18,    19,    22,    15,
      26,    27,   117,    19,    22,    23,    24,    25,    26,    27,
      28,    29,    28,    44,    32,    27,    50,     8,     9,    10,
      11,    12,    89,    18,    19,    15,    29,   150,   990,    19,
      35,    22,    23,    24,    25,    26,    27,    28,    29,    44,
    1580,    32,    18,    19,    34,    35,    36,    37,   119,   124,
     175,   141,  1441,   169,    19,   217,     6,    41,   327,     4,
    1084,   266,   224,   225,   241,    15,    16,    17,    18,    19,
       8,     9,    10,    11,    12,    15,    85,  1202,    68,    19,
    1349,   141,    30,   117,    22,    23,    24,    25,    26,    27,
      28,    29,    15,   183,    32,   257,    19,   124,    35,  1444,
      50,  1444,    15,    16,    17,    18,    19,    44,    35,    19,
     660,    34,    35,    36,    37,    15,   183,    44,    15,    19,
       3,   283,    19,   183,   333,  1514,   193,   263,     8,     9,
      10,    11,    12,   402,    34,    35,    36,    37,    35,   124,
     276,   691,    22,    23,    24,    25,    26,    27,    28,    29,
     430,   267,    32,   433,   316,   189,   190,   191,   192,   193,
     194,   195,    15,    16,    17,    18,    19,   117,   373,    15,
      15,    17,    18,    19,    19,   209,   353,   386,   212,    15,
     176,    15,    41,    19,   388,    19,   390,   391,   172,   393,
     394,  1460,   396,   397,   319,   399,   400,   401,    34,    35,
      36,    37,   364,   132,   255,    13,     0,    15,    16,    17,
      18,    19,    20,  1250,     3,   266,    15,   342,    26,    27,
      19,    29,  1184,    31,   870,   135,  1250,   239,   299,    15,
      16,    17,    18,     8,     9,    10,    11,    12,   203,   189,
     190,   191,   192,   193,   194,   195,    19,    22,    23,    24,
      25,    26,    27,    28,    29,   264,   599,    32,  1647,   209,
      18,    19,   212,   338,     8,     9,    10,    11,    12,  1394,
     385,   258,    15,    16,    17,    18,    19,  1817,    22,    23,
      24,    25,    26,    27,    28,    29,   282,   307,    32,   135,
     277,    20,   175,  1734,    15,   282,    17,    18,    19,  1323,
       3,   560,   250,  1648,   429,  1648,   429,  1094,   335,   117,
     297,   338,   308,   172,    49,   123,    15,   634,   216,   306,
      19,   308,     8,     9,    10,    11,    12,   314,    57,    58,
     317,    66,   261,   423,   409,   410,    22,    23,    24,    25,
      26,    27,    28,    29,   244,   245,    32,   120,    67,  1252,
     335,   418,   114,   338,   341,   253,   343,   424,  1458,  1396,
      15,    16,    17,    18,    80,   432,   433,   434,   435,   436,
     178,   179,  1396,   428,    42,   342,   150,   694,   431,   696,
      15,   448,   349,   426,    19,   424,   425,   149,   408,   429,
    1831,   425,     3,    61,  1474,   429,   425,   428,   560,   716,
     429,   425,   428,   125,   566,   213,   214,   429,   426,   425,
     183,   573,   430,   549,   172,   431,   232,  1441,   167,   168,
     150,   140,   230,   428,   427,   233,   135,   146,   137,  1509,
     238,   193,    15,   356,   429,   425,    19,    19,    20,   430,
     424,   163,   604,   760,    19,   144,   426,   115,   264,   611,
     430,   613,   428,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,  1627,   629,  1255,    44,
     150,   167,   168,   790,    85,   425,  1513,    19,   640,   429,
     642,   548,    41,   645,   424,   425,   648,   649,   173,  1513,
    1514,   428,   430,   114,   561,  1656,   167,   168,    19,   344,
      22,   428,   425,     8,     9,    10,    11,    12,   176,   144,
      32,    15,   425,    19,   581,    19,   678,    22,    23,    24,
      25,    26,    27,    28,    29,   425,    19,    32,   425,   385,
      34,    35,    36,    37,   145,    15,   392,   385,   261,    19,
     749,   608,   704,   391,   706,    18,    19,   346,   347,   160,
     430,    44,   714,    85,    34,    35,    36,    37,   140,   430,
     152,   172,   433,  1663,    19,   424,    19,   290,   291,    20,
      80,    75,   425,   429,   778,   324,   780,   894,   351,   425,
     425,   429,   825,   826,     8,     9,    10,    11,    12,   425,
     831,   425,   365,   366,   153,   154,   155,    50,    22,    23,
      24,    25,    26,    27,    28,    29,   428,     3,    32,   596,
      15,    19,    20,   362,    19,   958,  1303,   425,   426,   129,
     130,   131,     3,  1647,   432,  1312,   425,   789,   324,    34,
      35,    36,    37,   270,   271,   622,   623,    33,  1284,   425,
      19,    20,   611,   630,   613,   632,    42,  1334,   135,    45,
     137,   123,    41,   324,     3,   430,    19,    20,   136,   427,
      56,     3,   430,   650,   117,    44,   362,    66,   655,     3,
     657,     3,   659,    69,   661,   992,    65,   664,   665,   666,
       3,    44,   425,    79,  1027,   672,   430,  1030,   675,    85,
    1033,   362,   901,    85,     8,     9,    10,    11,    12,    19,
      20,     3,   689,   252,   425,    29,   178,   179,    22,    23,
      24,    25,    26,    27,    28,    29,    19,   113,    32,   115,
     116,   708,   709,   710,    44,   137,   425,   123,   140,   891,
     415,     3,   417,     3,   419,   420,   189,   190,   191,   192,
     193,   194,   195,     3,   430,   280,   281,    44,     3,    78,
     817,     3,   819,     3,   150,   151,   209,   919,   920,   212,
     922,   233,   918,   425,   242,   243,   162,   239,   246,   247,
     425,    68,    28,    29,   370,   371,    32,  1094,     3,   941,
     942,   160,   161,   945,  1101,   947,   948,     3,   950,   185,
     425,   239,   188,   425,   956,   425,   125,   126,    38,    39,
      40,   384,   306,   425,     8,     9,    10,    11,    12,   138,
     139,   425,   141,   975,   395,   396,   397,   979,    22,    23,
      24,    25,    26,    27,    28,    29,   123,   124,    32,   985,
     986,    13,   425,    15,    16,    17,    18,    19,    20,   319,
     245,   997,   425,    15,    26,    27,    28,    29,   415,    31,
     417,   425,   419,   420,     3,   244,   245,    13,    22,    15,
      16,    17,    18,    19,    20,   424,    19,    20,    15,    62,
      26,    27,    19,    29,   424,    31,    18,    19,    20,    13,
     169,    15,    16,    17,    18,    19,    20,    34,    35,    36,
      37,   158,    26,    27,    28,    29,   194,    31,     8,     9,
      10,    11,    12,   429,   430,    19,    20,    19,     7,     8,
       9,    10,    22,    23,    24,    25,    26,    27,    28,    29,
      19,   425,    32,    59,    60,   430,   424,   914,   135,    43,
      18,    19,    20,   322,    19,   117,   428,   326,  1255,   926,
      54,   123,   428,   240,   428,   425,   933,   307,   935,  1158,
    1293,   429,   319,   320,     8,     9,    10,    11,    12,  1168,
     258,   117,  1171,  1820,  1821,  1822,     3,   123,    22,    23,
      24,    25,    26,    27,    28,    29,   429,    19,    32,    59,
      60,  1048,    19,   117,  1051,  1052,  1053,   354,  1055,   123,
    1057,  1308,   290,   429,   430,  1062,   178,   179,  1065,   429,
     430,   299,   426,    19,  1071,   114,    78,    68,    50,   429,
     430,   400,   244,   245,   424,  1177,   307,   134,   420,   421,
     425,   424,   178,   179,  1186,  1340,  1341,   428,   424,    80,
     419,   213,   214,   215,   216,   217,   218,   382,   383,   156,
     429,   386,   387,   388,   178,   179,   145,   146,   230,  1211,
     428,   233,   169,   428,   429,  1877,   238,   213,   214,   215,
     216,   217,   218,   424,    20,   268,   138,    68,   140,   141,
    1892,  1893,  1894,  1895,   230,   117,   113,   233,    20,   213,
     214,    84,   238,   776,   429,   155,   779,    75,   781,    75,
     783,   784,   253,   786,   787,   788,   230,   260,   245,   233,
     266,  1418,   264,   280,   238,   284,   287,   294,  1270,   181,
     182,   183,   184,    55,   428,   289,   414,   415,   416,   417,
     264,    63,    64,    65,   302,  1287,  1288,  1194,  1290,   300,
     251,  1198,  1199,   428,   424,   350,  1298,  1204,   113,  1301,
       8,     9,    10,    11,    12,   114,   424,   189,   190,   191,
     192,   193,   194,   195,    22,    23,    24,    25,    26,    27,
      28,    29,   428,   428,    32,    85,  1153,   209,  1155,   428,
     212,  1238,   307,   424,  1161,   428,     8,     9,    10,    11,
      12,   327,   328,   329,   330,   331,   332,   333,   334,  1176,
      22,    23,    24,    25,    26,    27,    28,    29,  1185,   241,
      32,  1444,   428,    85,   321,   322,   323,  1466,   325,   428,
     424,   428,    85,  1200,    75,  1424,    78,  1426,    84,   336,
      80,    75,   426,   424,   261,   424,  1362,   424,  1390,   196,
     197,   198,   199,   200,   201,   202,    20,   204,   205,   206,
     207,   208,     3,   425,     8,     9,    10,    11,    12,   198,
     432,   424,     3,  1320,  1321,  1322,   424,     3,    22,    23,
      24,    25,    26,    27,    28,    29,     3,     3,    32,   425,
     307,     3,   221,     3,   311,    19,   432,     3,   425,  1346,
     229,     3,  1349,     3,     3,   234,   235,   236,    15,   326,
     170,   425,   170,    14,   239,    26,  1613,    32,   432,    27,
      29,    19,  1289,    15,  1466,  1467,   430,  1624,     7,     3,
     425,   424,   429,   424,    19,   133,   426,   424,  1480,    75,
     357,   358,    75,   424,   424,  1487,  1488,  1489,   424,  1491,
     292,   424,  1399,  1400,    50,  1402,     8,     9,    10,    11,
      12,  1034,   163,  1036,    30,   424,    44,   172,   424,  1485,
      22,    23,    24,    25,    26,    27,    28,    29,    75,   114,
      32,    75,     8,     9,    10,    11,    12,    75,    75,   424,
      68,   424,   426,   172,   424,   424,    22,    23,    24,    25,
      26,    27,    28,    29,  1593,  1547,    32,   429,   424,   424,
      68,    19,   424,  1460,  1556,  1557,  1558,   424,  1560,  1561,
     258,   424,     3,  1646,  1566,  1648,  1665,  1666,  1667,     3,
      19,  1573,  1729,    15,    13,    98,    15,    16,    17,    18,
      19,    20,  1584,  1585,   107,   123,   124,    26,    27,   112,
      29,   114,    31,   116,   132,   118,    19,   120,    19,   122,
      19,   124,     3,   126,  1606,  1607,    20,    15,    15,   426,
    1612,  1518,    27,     7,  1616,    15,   430,   430,  1620,   426,
      18,  1528,  1529,  1530,  1531,   425,  1628,    20,    27,   424,
     424,   424,   424,  1635,   128,    19,  1463,   428,   424,    68,
     430,   424,  1799,    13,  1471,    15,    16,    17,    18,    19,
      20,  1653,  1479,   424,  1481,   424,    26,    27,  1660,    29,
     424,    31,   424,  1665,  1666,  1667,   424,   424,   424,   424,
    1672,  1673,  1674,  1675,  1676,  1502,  1503,  1504,   117,   424,
     424,   424,   424,  1685,   123,  1687,   424,   424,   424,   424,
     424,    13,   424,    15,    16,    17,    18,    19,    20,   424,
     424,  1703,   240,   424,    26,    27,    28,    29,   424,    31,
    1712,     3,   424,   424,   424,   424,  1718,   424,   426,  1721,
    1722,   424,  1549,  1725,  1726,   424,  1553,     3,  1555,    15,
       3,     3,     3,  1735,     3,   172,     3,     3,     3,   178,
     179,   172,    27,   430,   424,   426,  1748,   117,   170,   424,
    1752,  1753,  1754,   123,   426,   424,   430,   424,   424,   359,
     424,  1763,   424,   307,  1766,  1767,    22,   424,   140,   141,
    1597,   424,   424,   424,   213,   214,   424,    45,   150,   424,
     424,   424,  1784,  1785,  1786,   425,  1788,   424,   424,  1791,
     424,   230,   424,   165,   233,   117,  1623,    65,  1625,   238,
       3,   123,   174,     3,   176,   177,    15,    15,   178,   179,
     426,     8,     9,    10,    11,    12,   430,    85,   429,    15,
     424,    15,  1824,   428,  1826,    22,    23,    24,    25,    26,
      27,    28,    29,    68,  1836,    32,   428,   424,   428,   428,
     428,  1668,    22,   213,   214,   113,   428,   430,     7,   117,
     118,  1678,   120,   121,   122,   429,   178,   179,   172,   127,
     230,   424,    19,   233,     8,     9,    10,  1774,   238,   241,
    1697,   251,     3,   424,  1701,   428,   426,  1704,    22,    23,
      24,    25,    26,    27,    28,    29,   428,   428,    32,   157,
       3,   213,   214,   428,   162,   425,    15,  1724,   426,   248,
     211,  1728,   426,  1730,   425,   425,   425,   424,   230,   425,
     424,   233,   245,   424,   426,   424,   238,   424,   428,  1746,
    1747,    45,    46,    47,    48,    49,    50,    51,    52,    53,
    1757,     8,     9,    10,    11,    12,   266,   428,   310,   385,
     426,  1768,   385,  1770,  1771,    22,    23,    24,    25,    26,
      27,    28,    29,   424,   424,    32,  1783,     8,     9,    10,
      11,    12,   429,     7,   430,   426,   246,   246,   246,   307,
     428,    22,    23,    24,    25,    26,    27,    28,    29,   345,
     363,    32,  1809,   302,   266,   424,   425,     8,     9,    10,
      11,    12,   361,   432,   329,   353,   327,   424,   424,   134,
     373,    22,    23,    24,    25,    26,    27,    28,    29,   377,
      75,    32,   376,   380,  1841,     8,     9,    10,    11,    12,
     260,   251,   251,    20,   345,    75,   398,   424,   424,    22,
      23,    24,    25,    26,    27,    28,    29,   424,   302,    32,
     353,   413,    75,    75,   405,   407,   418,   424,   307,     8,
       9,    10,    11,    12,   345,   425,   246,   246,   364,   424,
     246,   424,   432,    22,    23,    24,    25,    26,    27,    28,
      29,   246,   429,    32,     8,     9,    10,    11,    12,   429,
      68,   424,   394,   424,   424,   424,   344,   424,    22,    23,
      24,    25,    26,    27,    28,    29,    20,   426,    32,   344,
       5,   339,   552,   425,     8,     9,    10,    11,    12,   424,
     432,   360,   853,   261,   424,   424,   424,   424,    22,    23,
      24,    25,    26,    27,    28,    29,  1095,  1008,    32,     8,
       9,    10,    11,    12,  1817,   379,  1252,  1011,  1083,   583,
     755,   825,  1513,    22,    23,    24,    25,    26,    27,    28,
      29,   899,   386,    32,     8,     9,    10,    11,    12,  1646,
    1648,   429,  1061,   193,  1202,  1402,   826,  1358,    22,    23,
      24,    25,    26,    27,    28,    29,    81,    82,    32,  1048,
    1321,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   831,   940,
    1421,  1613,  1100,  1374,  1593,  1729,  1617,     8,     9,    10,
      11,    12,  1731,  1616,   994,    -1,    -1,    -1,    -1,   426,
     135,    22,    23,    24,    25,    26,    27,    28,    29,    19,
      -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   166,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    32,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    -1,    32,    -1,    -1,
      -1,    -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   219,   220,    -1,   222,   223,   224,
     225,   226,   227,   228,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    50,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    32,   426,
      -1,    -1,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,    -1,   426,    -1,    -1,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    41,    -1,    -1,
     295,   296,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,   117,    32,    -1,    -1,   426,    -1,   312,   313,   314,
     315,    65,    66,    -1,    -1,    -1,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,   206,   207,   208,    81,
      82,    -1,    -1,   426,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,    -1,    -1,    -1,    -1,    -1,    -1,   426,    -1,    -1,
      -1,    -1,    45,   189,   190,   191,   192,   193,   194,   195,
     134,    -1,   136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   426,   209,    -1,     3,   212,    45,    -1,    -1,
      -1,   155,   156,    -1,    -1,    -1,   411,   412,    -1,    -1,
      -1,    19,    85,    -1,   166,    -1,    -1,   422,    -1,    -1,
      45,    -1,   426,    -1,    72,    73,    74,    -1,    76,    77,
      -1,    79,    -1,    -1,    -1,    83,    -1,    85,    -1,    -1,
     113,    -1,    -1,    -1,   117,   118,    -1,   426,   121,   122,
      -1,    -1,    -1,    -1,   127,    -1,    -1,    -1,    83,    -1,
      85,    -1,    -1,    -1,    -1,   113,    -1,    -1,    -1,   117,
     118,    -1,   426,   121,   122,    -1,    -1,    85,    -1,   127,
      -1,    -1,    -1,    -1,   157,    -1,    -1,   241,   113,   162,
     244,   245,   117,   118,    -1,    -1,   121,   122,    -1,    45,
      -1,    -1,   127,    -1,    -1,    -1,    -1,   115,   116,   157,
     264,    45,    -1,    -1,   162,   123,    50,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,    -1,    -1,    -1,
      -1,    65,   157,   424,    -1,    -1,    -1,   162,    -1,    85,
      -1,    -1,   150,   295,   296,    79,    -1,   301,    -1,    -1,
      -1,    85,    -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,
     312,   313,   314,   315,   424,    -1,    -1,   113,    -1,    -1,
      -1,   117,   118,    -1,   120,   121,   122,    -1,    -1,   113,
     188,   127,   336,   117,   118,   119,   120,   121,   122,   424,
      -1,    -1,    -1,   127,    85,    -1,    -1,   131,   352,    -1,
     134,    45,   136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   157,   428,   120,    -1,   369,   162,    -1,    -1,    -1,
      -1,    65,   113,   157,    -1,    -1,   117,   118,   162,   120,
     121,   122,    72,    -1,    -1,    -1,   127,    77,    -1,    -1,
     424,    85,   176,    -1,   178,    -1,   400,   401,    -1,   403,
     404,    -1,   406,   187,    -1,    -1,    -1,    -1,    -1,   411,
     412,    -1,    -1,    -1,    -1,    45,   157,    -1,   175,   113,
     422,   162,    -1,   117,   118,   429,    -1,   121,   122,   119,
      -1,    -1,    -1,   127,    -1,    -1,   311,    -1,    -1,   223,
      -1,   316,   317,   318,   424,   368,   369,    -1,    -1,    -1,
      -1,    -1,   248,   249,    -1,    85,    -1,   241,   199,    65,
      -1,    -1,   152,   157,   248,   249,    -1,   251,   162,   253,
     254,    45,   256,   257,    -1,   259,    -1,   352,   262,   263,
      -1,   265,   176,   113,   359,    -1,    -1,   117,   118,    45,
     120,   121,   122,    -1,   278,   279,    -1,   127,    -1,   283,
      74,   285,   286,    -1,   288,   262,   429,    -1,    -1,   293,
      -1,    85,    -1,   297,   298,    -1,   300,   301,    -1,   303,
     304,   305,    -1,    -1,    -1,   309,    -1,   157,   134,    85,
      -1,   429,   162,    -1,    -1,    -1,    -1,    -1,    -1,   113,
      -1,    -1,    -1,   117,   118,    -1,    -1,   121,   122,    -1,
     156,   241,   170,   127,   429,    -1,    -1,   113,    -1,    -1,
     317,   117,   118,   169,   120,   121,   122,    -1,   142,    -1,
      -1,   127,    -1,    -1,    -1,    -1,    -1,   183,    -1,    -1,
      -1,   199,    -1,   157,   341,    -1,   343,    -1,   162,    -1,
      -1,   348,    -1,   350,     8,     9,    10,   354,   355,    -1,
      -1,   157,    -1,   297,    -1,    -1,   162,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    32,    -1,
     310,    -1,    -1,    -1,   242,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   429,    -1,   241,    -1,    -1,   244,   245,
      -1,    -1,    -1,    -1,   262,   429,    -1,    -1,   389,   390,
      -1,    -1,   393,    -1,    -1,    -1,   196,   197,   198,   199,
     200,   201,   202,     3,   204,   205,   206,   207,   208,    -1,
      -1,    -1,   429,    -1,    -1,    -1,    -1,   367,    18,    19,
      -1,    -1,   372,    -1,    -1,    -1,    -1,    -1,   429,   307,
      -1,    -1,    -1,    -1,    -1,   301,    -1,    -1,   304,    -1,
      -1,   307,    -1,    -1,    44,    -1,    -1,    -1,   398,    -1,
      -1,   317,    -1,   319,    -1,   321,   322,   323,   324,   325,
     326,    -1,   352,   413,    45,    -1,   332,    -1,   418,    -1,
     336,   337,    -1,    -1,   340,   429,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    85,   352,    -1,    -1,    70,
      71,    -1,    -1,    -1,   360,    -1,   374,   375,    -1,    80,
     378,   379,    -1,   381,    -1,    -1,    -1,    -1,    -1,   399,
      -1,   389,   390,    -1,    -1,   115,    -1,    -1,    -1,    -1,
      -1,    -1,   122,   123,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   133,    -1,    -1,    -1,    -1,    -1,   429,
      -1,    -1,   142,   143,   144,   145,    -1,   147,   148,    -1,
     131,   429,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,   429,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    32,    -1,   159,    -1,
      -1,   162,    -1,   164,    -1,    -1,    -1,    -1,    -1,    -1,
     171,    -1,   173,    -1,    -1,   429,    -1,   178,   179,   180,
      -1,    -1,     3,    -1,   185,   186,   187,     8,     9,    10,
      11,    12,    -1,   429,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      -1,    32,     8,     9,    10,    11,    12,    -1,    -1,    -1,
     240,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   210
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   435,   436,    45,    70,    71,    80,   131,   159,
     162,   164,   171,   173,   178,   179,   180,   185,   186,   187,
     460,   461,   462,   463,   464,   465,   516,   517,   518,   519,
     521,   522,   523,   526,   529,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   623,   660,   661,
     662,   663,   664,   665,   666,   667,   717,   718,   728,   739,
     740,   741,   743,     0,     3,    33,    42,    45,    56,    69,
      79,    85,   113,   115,   116,   123,   150,   151,   162,   185,
     188,   424,   437,   449,   455,   458,   459,   468,   470,   473,
     475,   478,   480,   481,   483,   484,   491,   501,   502,   558,
     560,   570,   609,   612,   624,   626,   627,   628,   669,   670,
     671,   676,   706,   709,   719,   720,   729,   732,   742,   744,
     745,   746,    19,    20,    44,   556,    20,    55,    63,    64,
      65,   466,     3,   556,   556,   160,   161,   556,   556,     3,
     150,   140,   141,   150,   165,   174,   176,   177,   241,   310,
     398,   413,   418,   150,   150,    78,   138,   140,   141,   181,
     182,   183,   184,    13,    15,    16,    17,    18,    19,    20,
      26,    27,    29,    31,   117,   123,   178,   179,   213,   214,
     230,   233,   238,   425,   432,   575,   588,   593,   596,   597,
     598,   600,   602,    35,    44,   428,   545,   556,    19,    19,
      20,    43,    54,   447,   451,    67,   140,   146,    42,    61,
     115,   176,   456,   457,    49,    66,    80,    19,   114,    19,
      85,   152,   140,   447,   602,    19,    19,   135,   485,   485,
     428,    72,    77,   119,   152,   241,   310,   367,   372,   398,
     413,   418,   485,    45,    65,    85,   113,   117,   118,   120,
     121,   122,   127,   157,   162,   429,   486,   504,   485,   485,
      50,    65,    79,   119,   120,   131,   134,   136,   176,   178,
     187,   223,   241,   248,   249,   251,   253,   254,   256,   257,
     259,   262,   263,   265,   278,   279,   283,   285,   286,   288,
     293,   297,   298,   300,   301,   303,   304,   305,   309,   429,
     486,   485,    83,   311,   316,   317,   318,   352,   359,   429,
     486,   629,   630,   631,   485,   368,   369,   429,   486,   485,
     485,   485,    65,   176,   297,   429,   486,   721,   724,   485,
      72,    73,    74,    76,    77,    79,    83,   429,   469,   472,
     486,    74,   142,   429,   471,   486,    35,    44,   428,   505,
     466,     3,     3,   466,    66,   467,     3,     3,   556,   556,
       3,    35,    44,   428,   508,    85,   531,    19,    20,    44,
     557,     3,   175,   527,     3,     3,   524,   530,   252,    19,
     120,   183,   351,   365,   366,   520,   141,   183,   520,   141,
     183,   423,    18,    19,   441,   443,   443,     3,     3,     3,
       3,     3,     3,     3,     3,    15,    19,    28,   425,   431,
     592,   594,   600,    29,   425,   239,    27,   239,    15,   431,
     595,   602,   425,   425,   425,   425,   425,   425,   215,   216,
     217,   218,   582,   602,    15,    16,    17,    19,   425,   575,
     576,   580,   583,   584,   586,   588,   589,   590,     5,    81,
      82,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   135,   166,
     219,   220,   222,   223,   224,   225,   226,   227,   228,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   295,   296,
     312,   313,   314,   315,   411,   412,   422,   601,   747,     3,
       8,     9,    10,    11,    12,    22,    23,    24,    25,    26,
      27,    28,    29,    32,    45,    46,    47,    48,    49,    50,
      51,    52,    53,   453,   454,    15,   546,     3,    22,    62,
     450,    44,   428,   452,    15,    19,    34,    35,    36,    37,
      68,   425,   438,   440,   505,   438,    20,    57,    58,   424,
     438,   439,   439,   169,   158,   479,    15,    17,    18,    19,
     135,   425,   474,   559,    19,   476,   508,   424,   571,   135,
      19,   428,   428,   482,   428,   505,   307,    19,   490,   114,
     438,   440,   503,    44,    68,   123,   124,   132,   240,   487,
     567,    68,   487,    68,   447,   508,   424,   424,   428,   428,
     169,   267,   307,    80,   424,    20,   268,   447,   440,    68,
      84,   176,   282,   308,   155,   440,   424,   438,   441,   625,
     172,   441,    75,   255,   266,    75,   253,   260,   270,   271,
     264,   266,   280,   281,   280,   284,   440,   287,   289,   294,
      85,   264,   119,   299,   264,   302,   300,   440,   251,   440,
     424,   428,   350,   474,   440,   113,   438,   440,   114,   424,
     428,   428,    85,   370,   371,   424,   428,   428,   428,   307,
     443,    85,   424,   194,   258,   290,   299,   414,   415,   416,
     417,   428,   727,   428,    85,   440,    75,   440,    78,    80,
      84,   424,   424,   424,    75,    20,   448,   424,   424,    78,
     125,   126,   138,   139,   141,   506,   507,     3,   467,     3,
     438,     3,     3,     3,   125,   163,   509,   510,     3,    19,
       3,   557,     3,     3,     3,    85,   145,   160,   172,   528,
       3,    44,    85,   115,   122,   123,   133,   142,   143,   144,
     145,   147,   148,   443,   525,   567,     3,    19,    85,   115,
     116,   123,   150,   188,   520,   520,   520,   668,    44,   520,
      44,   520,     3,   520,   520,     3,   520,   520,   520,    29,
     427,   445,   170,   170,   594,   594,   602,   594,   594,    14,
      15,   602,   606,   607,    26,   239,    27,   595,   595,    29,
     602,   602,   602,   602,   602,    19,    15,   430,   426,   430,
      28,   578,   579,   582,   602,     7,   430,   433,    26,    27,
     428,   430,   433,   602,   602,   602,   602,   602,   602,   602,
     602,   602,   602,   602,   602,   602,   198,   221,   229,   234,
     235,   236,   429,   430,     3,   602,   447,   453,   424,   439,
     602,   438,    59,    60,    59,    60,    38,    39,    40,   438,
     498,   499,   602,   424,   196,   197,   198,   199,   200,   201,
     202,   204,   205,   206,   207,   208,   561,   562,   563,   565,
     569,    41,   153,   154,   155,   424,   477,   424,   425,   568,
      19,   150,   429,   440,   474,   492,   495,   496,    35,   438,
     489,    19,   565,   566,   133,   602,   489,   489,   611,    75,
      75,   440,    75,   306,   440,   424,    50,   424,   424,   438,
     244,   245,   440,   292,   440,   163,   441,   424,   424,    30,
     442,    41,   172,   424,   438,   172,   438,    75,    75,   438,
      75,   132,   261,   438,   438,   440,    75,   424,   114,   424,
     440,   424,   440,   261,   290,   291,   440,   490,   440,   424,
     424,   440,   440,   440,   424,   172,   424,   440,   440,    68,
     438,   632,    19,   424,   424,   675,   708,   440,   490,    20,
     441,   441,   258,   722,   723,   726,   424,   731,   438,   438,
     440,   440,   440,   438,   441,   443,   444,   429,   430,     3,
     429,   430,     3,    19,    15,   443,    19,    19,   566,   444,
      19,     3,    20,   659,   659,     3,    19,   113,   261,   307,
     311,   326,   357,   358,   520,   659,   520,   659,   659,   659,
     659,   659,   659,   438,   441,    15,    15,   426,   430,   426,
      27,   430,   430,   430,   426,   430,   426,   430,   602,   602,
       7,   430,   430,   426,    18,   425,   576,   584,    15,    18,
     589,   425,   454,   424,   429,   426,    20,   424,   496,   424,
     426,    19,   203,   424,   428,   438,   441,   426,   562,   564,
     569,   443,   424,    27,   494,   430,   128,   488,   440,   120,
     248,   249,   429,   486,   610,   438,   438,   424,   438,   424,
     424,   440,   424,   424,   424,   424,   440,   424,   440,   424,
      19,   625,   438,   438,   424,   438,   424,   438,   438,   424,
     438,   424,   424,   424,   424,   424,   438,   474,   424,   424,
     424,   424,   424,   424,   424,   424,   424,   424,   424,   424,
     438,   438,   120,   175,   262,   317,   341,   343,   348,   350,
     354,   355,   429,   633,   640,   643,   424,   120,   199,   389,
     390,   393,   429,   486,   672,   120,   352,   399,   429,   486,
     707,   424,   424,   442,   441,   241,   353,   722,    19,    50,
     117,   189,   190,   191,   192,   193,   194,   195,   209,   212,
     241,   429,   598,   599,   603,   608,   725,   120,   429,   486,
     730,    68,   507,   510,     3,     3,   474,   474,    15,   474,
     659,     3,   659,     3,     3,     3,     3,     3,     3,   172,
     172,   606,    27,   602,   602,   602,   602,   602,   430,   426,
     578,   602,   579,   581,   602,   602,   430,   602,   563,   572,
     573,   608,   424,   426,   170,    20,   444,   493,   495,    80,
     129,   130,   131,   613,   617,   613,   618,   441,   622,   424,
     430,   424,   424,   424,   424,   424,   424,   424,   424,   424,
     424,   424,   424,   424,   652,   658,   440,   319,   320,   354,
     319,   440,   634,   307,   443,   636,   637,   635,   356,   440,
     424,   359,   653,   677,   685,   443,   686,   691,   673,   674,
     443,   424,   710,   716,   440,   438,   424,   442,   440,   438,
      22,   425,    22,   425,   602,   602,   602,   440,   601,   747,
     424,   602,   604,   605,   733,   738,   424,   438,     3,     3,
      15,    15,   426,   426,   426,   426,   430,   602,   426,   430,
      15,   426,   429,   608,   564,    15,   444,   496,   497,   428,
     616,    30,   250,   619,   438,   496,   654,   438,   438,   440,
     438,   428,   474,   428,   428,   438,   438,   428,   497,   428,
     690,   428,   441,   692,   697,    20,   428,   698,   703,   497,
      68,   602,   607,   602,   598,   424,   210,   428,   424,    22,
      22,    32,   430,   424,   497,   531,   531,   602,   426,     7,
      28,   581,   429,   172,   616,   615,    19,   447,   251,   620,
     424,   655,   428,   657,   645,   638,   645,   641,   428,   684,
     689,   688,   693,   699,   428,   715,   438,   424,   426,   424,
     747,   428,   574,   608,   591,   602,   602,   123,   178,   179,
     233,   239,   605,   428,   737,     3,     3,   426,   425,   426,
       7,   426,    15,   136,   242,   243,   246,   247,   429,   614,
     441,   248,   621,   653,   656,   429,   443,   646,   647,   175,
     319,   342,   429,   639,   429,   134,   156,   169,   321,   322,
     323,   325,   336,   429,   511,   513,   514,   642,   683,   682,
     382,   383,   386,   387,   388,   429,   687,   696,   702,   714,
     711,   426,   572,   211,     6,    15,    16,    17,   425,   429,
     575,   577,   580,   583,   585,   587,   424,   424,   425,   425,
     425,   425,   424,   736,   734,   578,   581,   424,   440,   244,
     245,   245,   439,   438,   424,   440,    65,   169,   183,   241,
     244,   245,   301,   304,   307,   317,   319,   321,   322,   323,
     324,   325,   326,   332,   336,   337,   340,   352,   360,   429,
     511,   644,   342,   349,   648,   440,   438,   440,   424,   447,
     428,   438,   438,   438,   266,   144,   438,   124,   335,   338,
     428,   424,   170,   199,   242,   262,   307,   374,   375,   378,
     379,   381,   389,   390,   429,   678,   385,   385,   440,   440,
     440,   424,   385,   391,   429,   694,   385,   392,   429,   700,
      41,    65,    66,   136,   155,   241,   244,   245,   264,   301,
     336,   352,   369,   400,   401,   403,   404,   406,   429,   511,
     712,   424,   429,   574,   572,   602,     7,   427,   430,   602,
     602,   602,   602,    41,    65,   244,   245,   322,   326,   400,
     419,   429,   735,   430,   426,   246,   246,   246,   307,   438,
     428,   440,   345,   167,   168,   324,   362,   500,   302,   440,
     363,   440,   438,   438,   438,   266,   438,   144,   438,   327,
     328,   329,   330,   331,   332,   333,   334,   361,   124,   335,
     338,   329,   438,   353,   327,   424,   438,   424,   512,   513,
     438,   438,   114,   149,   193,   515,   373,   691,   266,   373,
     117,   385,   377,   440,   376,    75,   380,   260,   251,   679,
     251,   680,   424,   438,   438,   384,   438,   704,   692,   695,
     424,   704,   698,   701,   424,   438,   307,   408,    75,   440,
     441,   440,   345,   324,   362,   500,   438,   302,   124,   338,
     409,   410,   713,   353,   327,   402,    75,    75,   344,   438,
     405,   407,   424,   426,   425,   577,   572,   585,   426,   426,
     426,   426,   438,   307,   345,   324,   362,   500,   246,   420,
     421,   246,   438,   424,   578,   439,   439,   439,   440,   649,
     346,   347,   438,   438,   438,   438,   438,   245,   440,   364,
     438,   438,   440,   440,   438,   440,   429,   424,   438,   135,
     137,   135,   137,   429,   246,   438,   246,   395,   396,   397,
     681,   438,   438,   440,   438,   438,    68,   440,   697,   440,
     703,   394,   705,   705,   438,   440,   440,   438,   438,   438,
     438,   245,   440,   438,   438,   438,   440,   440,   440,   602,
     424,   424,   424,   424,   440,   438,   438,   438,   438,   438,
     426,   429,   441,   651,   344,   440,   512,   424,    20,   446,
     446,   446,   446,   438,   438,   705,   438,   440,   344,   339,
     650,   515,   424,   424,   424,   424,   424,   515,   515,   515,
     515
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   434,   435,   435,   436,   436,   437,   438,   438,   438,
     439,   439,   439,   440,   440,   440,   440,   440,   440,   441,
     441,   442,   442,   443,   444,   444,   445,   445,   446,   447,
     447,   448,   448,   449,   450,   450,   451,   451,   451,   452,
     452,   453,   453,   454,   454,   454,   454,   454,   454,   454,
     454,   454,   455,   455,   456,   456,   456,   456,   457,   457,
     457,   457,   457,   457,   458,   459,   459,   459,   459,   460,
     461,   462,   463,   464,   465,   466,   466,   467,   467,   467,
     468,   469,   469,   469,   469,   469,   469,   469,   470,   471,
     471,   472,   473,   473,   474,   474,   474,   474,   474,   475,
     476,   476,   477,   477,   477,   477,   478,   479,   479,   480,
     481,   482,   482,   483,   483,   484,   484,   485,   485,   485,
     485,   486,   486,   486,   486,   486,   486,   486,   486,   486,
     486,   486,   486,   486,   486,   487,   487,   487,   487,   488,
     488,   488,   488,   488,   489,   489,   490,   491,   491,   492,
     493,   493,   493,   494,   494,   495,   496,   496,   497,   498,
     499,   500,   500,   501,   502,   502,   502,   502,   503,   504,
     505,   505,   505,   506,   506,   507,   507,   507,   507,   507,
     507,   508,   508,   508,   509,   509,   510,   510,   511,   511,
     512,   512,   513,   513,   514,   515,   515,   515,   515,   515,
     515,   516,   517,   518,   519,   520,   520,   521,   522,   523,
     524,   524,   524,   524,   524,   524,   524,   524,   524,   524,
     524,   524,   524,   525,   525,   525,   526,   527,   527,   527,
     527,   528,   528,   528,   529,   530,   530,   530,   530,   530,
     530,   530,   530,   531,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   545,
     545,   546,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   556,   556,   557,   557,   557,   559,   558,
     560,   561,   561,   561,   561,   561,   561,   561,   561,   561,
     561,   561,   561,   561,   562,   563,   563,   564,   564,   565,
     566,   566,   567,   568,   568,   569,   571,   570,   572,   572,
     573,   573,   574,   574,   575,   576,   576,   576,   576,   576,
     576,   577,   577,   577,   577,   577,   578,   579,   579,   579,
     580,   580,   581,   582,   582,   582,   582,   583,   583,   583,
     584,   584,   584,   584,   585,   585,   585,   585,   586,   586,
     587,   587,   588,   589,   589,   589,   589,   590,   590,   591,
     591,   591,   592,   592,   593,   593,   594,   594,   594,   594,
     594,   595,   595,   595,   596,   596,   596,   596,   596,   596,
     596,   596,   596,   596,   596,   597,   597,   598,   599,   600,
     601,   601,   601,   601,   601,   601,   601,   601,   601,   601,
     602,   602,   602,   602,   602,   602,   602,   602,   602,   602,
     602,   602,   602,   602,   602,   602,   602,   602,   602,   602,
     602,   602,   602,   602,   602,   602,   602,   602,   602,   602,
     602,   602,   602,   602,   602,   602,   602,   602,   603,   603,
     603,   603,   603,   603,   604,   605,   605,   605,   606,   606,
     607,   607,   608,   608,   608,   608,   608,   608,   608,   608,
     608,   608,   608,   608,   608,   608,   608,   608,   609,   610,
     610,   610,   610,   611,   611,   612,   613,   614,   614,   614,
     614,   614,   614,   615,   615,   616,   616,   617,   618,   619,
     619,   619,   620,   620,   621,   621,   622,   623,   624,   625,
     625,   625,   626,   626,   626,   626,   626,   626,   626,   626,
     626,   626,   626,   626,   626,   626,   626,   626,   626,   626,
     626,   626,   626,   626,   626,   626,   626,   626,   626,   626,
     626,   626,   626,   626,   626,   626,   626,   626,   626,   626,
     626,   626,   626,   626,   626,   626,   626,   626,   626,   626,
     626,   626,   626,   626,   626,   626,   626,   626,   626,   626,
     626,   626,   627,   628,   628,   629,   629,   629,   629,   629,
     629,   629,   629,   629,   630,   631,   632,   632,   633,   633,
     633,   633,   633,   633,   633,   633,   633,   634,   633,   635,
     633,   633,   633,   633,   636,   636,   637,   638,   638,   639,
     639,   639,   640,   640,   641,   641,   642,   642,   642,   642,
     642,   642,   642,   642,   642,   642,   642,   643,   644,   644,
     644,   644,   644,   644,   644,   644,   644,   644,   644,   644,
     644,   644,   644,   644,   644,   644,   644,   644,   644,   644,
     644,   644,   644,   644,   644,   644,   644,   644,   644,   644,
     644,   644,   644,   644,   644,   644,   644,   645,   645,   646,
     647,   648,   648,   648,   649,   649,   650,   650,   651,   652,
     653,   653,   655,   654,   656,   656,   657,   657,   658,   659,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     668,   668,   668,   668,   668,   668,   668,   668,   669,   670,
     670,   670,   670,   670,   671,   672,   672,   672,   673,   672,
     674,   672,   672,   675,   675,   676,   677,   678,   678,   678,
     678,   678,   678,   678,   678,   678,   678,   678,   678,   679,
     678,   680,   678,   678,   678,   681,   681,   681,   682,   683,
     683,   684,   684,   685,   686,   687,   687,   687,   687,   687,
     688,   689,   689,   690,   690,   691,   692,   693,   694,   694,
     694,   695,   696,   696,   697,   697,   698,   699,   700,   700,
     700,   701,   702,   702,   703,   703,   704,   704,   705,   705,
     706,   707,   707,   707,   707,   707,   708,   708,   709,   710,
     711,   712,   712,   712,   712,   712,   712,   712,   712,   712,
     712,   712,   712,   712,   712,   712,   712,   712,   712,   712,
     712,   712,   712,   712,   712,   712,   713,   713,   713,   713,
     714,   714,   715,   715,   716,   717,   718,   719,   720,   720,
     720,   720,   720,   721,   722,   722,   722,   723,   723,   724,
     724,   724,   724,   724,   724,   724,   724,   724,   725,   725,
     726,   726,   727,   727,   728,   729,   730,   730,   731,   731,
     732,   733,   734,   735,   735,   735,   735,   735,   735,   735,
     735,   735,   735,   735,   735,   736,   736,   737,   737,   738,
     739,   740,   741,   742,   742,   742,   742,   742,   742,   742,
     742,   742,   742,   742,   742,   742,   742,   742,   742,   743,
     743,   743,   743,   743,   743,   743,   743,   743,   743,   743,
     743,   743,   743,   743,   743,   743,   743,   743,   743,   743,
     743,   743,   743,   743,   743,   743,   743,   743,   743,   743,
     743,   743,   743,   743,   743,   743,   743,   743,   743,   743,
     743,   743,   743,   743,   743,   743,   743,   743,   743,   743,
     743,   744,   744,   744,   744,   744,   744,   744,   744,   744,
     744,   744,   745,   745,   745,   745,   746,   746,   746,   747,
     747,   747,   747,   747,   747,   747,   747,   747,   747,   747,
     747,   747,   747,   747,   747,   747,   747,   747,   747,   747,
     747,   747,   747,   747,   747,   747,   747,   747,   747,   747,
     747,   747,   747,   747,   747,   747,   747,   747,   747,   747,
     747,   747,   747,   747,   747,   747,   747,   747
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     5,     1,     3,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     0,     1,
       1,     0,     2,     2,     1,     1,     2,     2,     1,     1,
       1,     1,     0,     4,     2,     0,     1,     2,     1,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     3,     1,     1,     1,     1,     2,     4,
       3,     3,     3,     3,     3,     3,     4,     3,     3,     4,
       5,     3,     3,     4,     2,     0,     1,     0,     1,     2,
       2,     2,     3,     2,     3,     3,     3,     5,     2,     3,
       3,     3,     4,     5,     1,     3,     1,     1,     1,     4,
       0,     2,     2,     2,     1,     1,     5,     0,     1,     3,
       3,     0,     8,     1,     4,     1,     1,     0,     1,     2,
       3,     0,     2,     2,     2,     2,     2,     2,     3,     3,
       3,     4,     2,     3,     2,     2,     1,     1,     1,     0,
       2,     2,     2,     2,     2,     1,     1,     3,     3,     0,
       1,     1,     2,     0,     1,     3,     1,     3,     1,     0,
       2,     2,     2,     2,     3,     3,     3,     5,     0,     3,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     3,     1,     1,     4,     1,
       0,     3,     4,     1,     2,     0,     5,     5,     5,     5,
       4,     3,     3,     4,     5,     1,     0,     3,     4,     4,
       0,     2,     3,     3,     3,     2,     2,     2,     2,     3,
       3,     2,     2,     1,     1,     1,     4,     0,     3,     3,
       3,     0,     1,     1,     4,     0,     2,     2,     2,     2,
       2,     2,     2,     0,     2,     9,     9,     4,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     4,     1,     1,
       3,     0,     1,     3,     3,     3,     3,     4,     4,     4,
       4,     2,     1,     1,     1,     1,     0,     1,     0,     4,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     0,     3,     1,     3,     1,
       1,     1,     2,     3,     2,     4,     0,     5,     0,     1,
       1,     2,     1,     3,     1,     1,     1,     1,     1,     3,
       1,     1,     3,     1,     1,     1,     1,     1,     3,     1,
       5,    11,     1,     1,     1,     2,     1,     7,     9,     7,
       1,     1,     1,     3,     1,     1,     1,     3,     1,     3,
       1,     3,     3,     1,     2,     2,     6,     1,     3,     0,
       4,     3,     1,     3,     3,     3,     2,     2,     2,     2,
       0,     2,     2,     0,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     1,     1,     5,     7,     0,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     4,     1,     1,     1,     1,
       2,     2,     3,     3,     6,     3,     3,     3,     3,     3,
       5,     6,     6,     6,     6,     4,     8,     4,     1,     1,
       1,     1,     1,     1,     1,     0,     1,     3,     1,     3,
       0,     1,     4,     6,     4,     3,     5,     5,     4,     6,
       3,     2,     5,     5,     8,     8,     8,     8,     2,     1,
       2,     2,     2,     0,     3,     5,     0,     2,     4,     4,
       4,     2,     2,     0,     3,     0,     3,     3,     2,     0,
       2,     2,     0,     2,     0,     2,     4,     5,     2,     0,
       3,     3,     3,     3,     5,     6,     4,     6,     4,     6,
       4,     4,     5,     6,     3,     3,     4,     5,     5,     5,
       5,     5,     4,     4,     5,     5,     5,     5,     5,     5,
       5,     5,     6,     6,     6,     5,     6,     8,     6,     6,
       5,     6,     4,     5,     4,     4,     5,     4,     5,     4,
       5,     5,     5,     5,     6,     5,     5,     6,     5,     5,
       5,     4,     2,     3,     3,     1,     2,     3,     2,     4,
       3,     2,     3,     1,     2,     4,     0,     3,     2,     1,
       2,     3,     3,     3,     3,     2,     3,     0,     5,     0,
       5,     2,     2,     1,     4,     1,     1,     0,     3,     2,
       2,     2,     5,     2,     0,     3,     0,     2,     2,     3,
       2,     2,     3,     2,     2,     2,     1,     3,     2,     2,
       2,     2,     2,     2,     3,     2,     2,     2,     2,     2,
       2,     2,     2,     3,     3,     3,     2,     3,     2,     3,
       3,     4,     4,     2,     2,     2,     3,     3,     3,     2,
       3,     3,     3,     4,     2,     2,     1,     0,     2,     3,
       1,     0,     1,     2,     0,     2,     0,     1,     3,     0,
       0,     2,     0,     3,     0,     3,     0,     3,     3,     1,
       0,     4,     6,     6,     6,     7,     6,     7,     5,     0,
       2,     3,     2,     3,     3,     2,     3,     2,     2,     3,
       3,     5,     4,     4,     2,     1,     2,     2,     0,     3,
       0,     3,     2,     0,     3,     5,     0,     4,     4,     3,
       2,     3,     3,     3,     3,     4,     4,     3,     2,     0,
       3,     0,     3,     3,     3,     1,     1,     1,     0,     0,
       3,     0,     3,     4,     1,     2,     2,     2,     4,     4,
       0,     0,     3,     0,     3,     3,     1,     0,     0,     2,
       2,     0,     0,     3,     1,     5,     1,     0,     0,     2,
       2,     0,     0,     3,     1,     5,     1,     2,     0,     2,
       2,     1,     2,     4,     2,     2,     0,     3,     5,     0,
       0,     2,     2,     2,     2,     2,     2,     2,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     3,
       3,     4,     3,     2,     2,     1,     1,     1,     1,     1,
       0,     3,     0,     3,     4,     6,     6,     2,     3,     3,
       5,     5,     4,     2,     3,     3,     3,     1,     2,     4,
       3,     3,     3,     2,     2,     2,     2,     2,     1,     3,
       0,     2,     0,     3,     4,     2,     1,     2,     0,     3,
       5,     0,     0,     0,     2,     2,     3,     3,     2,     2,
       3,     3,     2,     3,     3,     0,     3,     0,     3,     4,
       6,     6,     6,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     1,     2,     2,     2,     1,     1,
       2,     1,     3,     3,     3,     3,     3,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 771 "cf-parse.y" /* yacc.c:1646  */
    { return 0; }
#line 4014 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 772 "cf-parse.y" /* yacc.c:1646  */
    { return 0; }
#line 4020 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 785 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[-1].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[-3].s), SYM_CONSTANT | val->type, val);
   }
#line 4031 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 795 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = f_eval_int((yyvsp[-1].x)); }
#line 4037 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 796 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[0].s)).i; }
#line 4045 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 803 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000000; }
#line 4051 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 804 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000; }
#line 4057 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 805 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1; }
#line 4063 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 813 "cf-parse.y" /* yacc.c:1646  */
    {(yyval.i) = !!(yyvsp[0].i); }
#line 4069 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 814 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4075 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 815 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4081 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 816 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4087 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 817 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4093 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 818 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4099 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 825 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[0].s)).px.ip;
   }
#line 4108 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 832 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 4114 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 833 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 4120 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 837 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!ip_is_prefix((yyvsp[-1].a), (yyvsp[0].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[-1].a); (yyval.px).len = (yyvsp[0].i);
   }
#line 4129 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 845 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.px).addr = (yyvsp[0].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
#line 4135 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 849 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[0].i));
     (yyval.i) = (yyvsp[0].i);
   }
#line 4144 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 853 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.i) = ipa_masklen((yyvsp[0].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[0].a));
   }
#line 4153 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 860 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.time) = tm_parse_datetime((yyvsp[0].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
#line 4163 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 869 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_STRING)) cf_error("String expected");
     (yyval.t) = SYM_VAL((yyvsp[0].s)).s;
   }
#line 4172 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 876 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = (yyvsp[0].t); }
#line 4178 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 877 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 4184 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 883 "cf-parse.y" /* yacc.c:1646  */
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[-2].g);
    c->mask = (yyvsp[-1].i);
    add_tail(&new_config->logfiles, &c->n);
  }
#line 4195 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 892 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = (yyvsp[0].t); }
#line 4201 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 893 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = bird_name; }
#line 4207 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 897 "cf-parse.y" /* yacc.c:1646  */
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[0].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[0].t));
     (yyval.g) = f;
   }
#line 4217 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 902 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[0].t); }
#line 4223 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 903 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = stderr; }
#line 4229 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 907 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 4235 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 908 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 4241 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 912 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << (yyvsp[0].i); }
#line 4247 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 913 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (1 << (yyvsp[0].i)); }
#line 4253 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 917 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_DEBUG[0]; }
#line 4259 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 918 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_TRACE[0]; }
#line 4265 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 919 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_INFO[0]; }
#line 4271 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 920 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_REMOTE[0]; }
#line 4277 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 921 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_WARN[0]; }
#line 4283 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 922 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_ERR[0]; }
#line 4289 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 923 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_AUTH[0]; }
#line 4295 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 924 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_FATAL[0]; }
#line 4301 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 925 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_BUG[0]; }
#line 4307 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 931 "cf-parse.y" /* yacc.c:1646  */
    { new_config->proto_default_mrtdump = (yyvsp[-1].i); }
#line 4313 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 932 "cf-parse.y" /* yacc.c:1646  */
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[-1].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[-1].t));
     new_config->mrtdump_file = fileno(f);
   }
#line 4323 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 942 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_route; }
#line 4329 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 943 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_proto; }
#line 4335 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 944 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_base; }
#line 4341 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 945 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_log; }
#line 4347 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 948 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-1].tf) = (struct timeformat){(yyvsp[0].t), NULL, 0}; }
#line 4353 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 949 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-3].tf) = (struct timeformat){(yyvsp[-2].t), (yyvsp[0].t), (yyvsp[-1].i)}; }
#line 4359 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 950 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
#line 4365 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 951 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%F %T", NULL, 0}; }
#line 4371 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 952 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){NULL, NULL, 0}; }
#line 4377 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 953 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%d-%m-%Y %T", NULL, 0}; }
#line 4383 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 963 "cf-parse.y" /* yacc.c:1646  */
    { new_config->latency_debug = (yyvsp[0].i); }
#line 4389 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 964 "cf-parse.y" /* yacc.c:1646  */
    { new_config->latency_limit = (yyvsp[0].i32); }
#line 4395 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 965 "cf-parse.y" /* yacc.c:1646  */
    { new_config->watchdog_warning = (yyvsp[0].i32); }
#line 4401 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 966 "cf-parse.y" /* yacc.c:1646  */
    { new_config->watchdog_timeout = ((yyvsp[0].i32) + 999999) TO_S; }
#line 4407 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 975 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_HARD, (yyvsp[-1].i)); }
#line 4413 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 978 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_SOFT, (yyvsp[-1].i)); }
#line 4419 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 985 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig_confirm(); }
#line 4425 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 988 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig_undo(); }
#line 4431 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 991 "cf-parse.y" /* yacc.c:1646  */
    { cmd_check_config((yyvsp[-1].t)); }
#line 4437 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 994 "cf-parse.y" /* yacc.c:1646  */
    { cmd_shutdown(); }
#line 4443 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 997 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 4449 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 1002 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4455 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 1003 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
#line 4461 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 1004 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 4467 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 1012 "cf-parse.y" /* yacc.c:1646  */
    { this_proto = krt_init_config((yyvsp[-1].i)); }
#line 4473 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 1017 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->persist = (yyvsp[0].i); }
#line 4479 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 1018 "cf-parse.y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[0].i);
   }
#line 4488 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 1022 "cf-parse.y" /* yacc.c:1646  */
    {
      THIS_KRT->learn = (yyvsp[0].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[0].i))
	cf_error("Learning of kernel routes not supported in this configuration");
#endif
   }
#line 4500 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 1029 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->devroutes = (yyvsp[0].i); }
#line 4506 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 1030 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->graceful_restart = (yyvsp[0].i); }
#line 4512 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 1031 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->merge_paths = (yyvsp[0].i) ? KRT_DEFAULT_ECMP_LIMIT : 0; }
#line 4518 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 1032 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->merge_paths = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; if (((yyvsp[0].i) <= 0) || ((yyvsp[0].i) > 255)) cf_error("Merge paths limit must be in range 1-255"); }
#line 4524 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 1038 "cf-parse.y" /* yacc.c:1646  */
    { this_proto = kif_init_config((yyvsp[-1].i)); }
#line 4530 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 1043 "cf-parse.y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[0].i);
   }
#line 4539 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 1047 "cf-parse.y" /* yacc.c:1646  */
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[-1].t);
     kpi->prefix = (yyvsp[0].px).addr;
     kpi->pxlen = (yyvsp[0].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
#line 4551 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 1061 "cf-parse.y" /* yacc.c:1646  */
    {
	THIS_KRT->sys.table_id = (yyvsp[0].i);
   }
#line 4559 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 1077 "cf-parse.y" /* yacc.c:1646  */
    { new_config->router_id = (yyvsp[-1].i32); }
#line 4565 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 1078 "cf-parse.y" /* yacc.c:1646  */
    { new_config->router_id_from = this_ipatt; }
#line 4571 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 1082 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (yyvsp[0].i); }
#line 4577 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 1083 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = f_eval_int((yyvsp[-1].x)); }
#line 4583 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 1085 "cf-parse.y" /* yacc.c:1646  */
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[0].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
#line 4595 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 1092 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_INT) || (yyvsp[0].s)->class == (SYM_CONSTANT | T_QUAD))
       (yyval.i32) = SYM_VAL((yyvsp[0].s)).i;
#ifndef IPV6
     else if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_IP))
       (yyval.i32) = ipa_to_u32(SYM_VAL((yyvsp[0].s)).px.ip);
#endif
     else
       cf_error("Number or IPv4 address constant expected");
   }
#line 4610 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 1114 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_addr = (yyvsp[0].a); }
#line 4616 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 1115 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_port = (yyvsp[0].i); }
#line 4622 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 1116 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_flags = 0; }
#line 4628 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 1117 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_flags = 1; }
#line 4634 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 1122 "cf-parse.y" /* yacc.c:1646  */
    { new_config->gr_wait = (yyvsp[-1].i); }
#line 4640 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 1128 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4646 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 1129 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4652 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 1133 "cf-parse.y" /* yacc.c:1646  */
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[-1].s));
   cf->sorted = (yyvsp[0].i);
   }
#line 4662 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 1141 "cf-parse.y" /* yacc.c:1646  */
    {
  this_roa_table = roa_new_table_config((yyvsp[0].s));
}
#line 4670 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 1147 "cf-parse.y" /* yacc.c:1646  */
    {
     roa_add_item_config(this_roa_table, (yyvsp[-5].px).addr, (yyvsp[-5].px).len, (yyvsp[-3].i), (yyvsp[-1].i));
   }
#line 4678 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 1161 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = SYM_PROTO; }
#line 4684 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 1162 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = SYM_TEMPLATE; }
#line 4690 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 1166 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
#line 4701 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 1172 "cf-parse.y" /* yacc.c:1646  */
    {
     cf_define_symbol((yyvsp[0].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[0].s)->name;
   }
#line 4710 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1176 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;

     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[0].s)->def);
   }
#line 4724 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1185 "cf-parse.y" /* yacc.c:1646  */
    {
     cf_define_symbol((yyvsp[-2].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[-2].s)->name;

     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[0].s)->def);
   }
#line 4736 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1196 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[0].i);
   }
#line 4745 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1200 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->disabled = (yyvsp[0].i); }
#line 4751 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1201 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->debug = (yyvsp[0].i); }
#line 4757 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1202 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->mrtdump = (yyvsp[0].i); }
#line 4763 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1203 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_filter = (yyvsp[0].f); }
#line 4769 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1204 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->out_filter = (yyvsp[0].f); }
#line 4775 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1205 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->rx_limit = (yyvsp[0].g); }
#line 4781 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1206 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_limit = (yyvsp[0].g); }
#line 4787 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1207 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->out_limit = (yyvsp[0].g); }
#line 4793 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1208 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_keep_filtered = (yyvsp[0].i); }
#line 4799 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1209 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->table = (yyvsp[0].r); }
#line 4805 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1210 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->router_id = (yyvsp[0].i32); }
#line 4811 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1211 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->dsc = (yyvsp[0].t); }
#line 4817 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1215 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = (yyvsp[0].f); }
#line 4823 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1217 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_ACCEPT; }
#line 4829 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_REJECT; }
#line 4835 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1222 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 4841 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1223 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_WARN; }
#line 4847 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1224 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_BLOCK; }
#line 4853 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1225 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_RESTART; }
#line 4859 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1226 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 4865 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1230 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[-1].i);
     l->action = (yyvsp[0].i);
     (yyval.g) = l;
   }
#line 4876 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1236 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = NULL; }
#line 4882 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1240 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[0].s)->def;
   }
#line 4891 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1248 "cf-parse.y" /* yacc.c:1646  */
    { new_config->proto_default_debug = (yyvsp[0].i); }
#line 4897 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1249 "cf-parse.y" /* yacc.c:1646  */
    { new_config->cli_debug = (yyvsp[0].i); }
#line 4903 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1257 "cf-parse.y" /* yacc.c:1646  */
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
#line 4913 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1265 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[0].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
#line 4919 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1266 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 4925 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1267 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[-1].t); this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 4931 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1271 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->positive = 1; }
#line 4937 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1272 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->positive = 0; }
#line 4943 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1286 "cf-parse.y" /* yacc.c:1646  */
    { iface_patt_check(); }
#line 4949 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1288 "cf-parse.y" /* yacc.c:1646  */
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
#line 4959 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1300 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i) & 0xfc;        if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 255)) cf_error("TX class must be in range 0-255"); }
#line 4965 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1301 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ((yyvsp[0].i) & 0x3f) << 2; if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 63))  cf_error("TX DSCP must be in range 0-63"); }
#line 4971 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1307 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_device, (yyvsp[-1].i));
     init_list(&DIRECT_CFG->iface_list);
   }
#line 4980 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1317 "cf-parse.y" /* yacc.c:1646  */
    { DIRECT_CFG->check_link = (yyvsp[-1].i); }
#line 4986 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1321 "cf-parse.y" /* yacc.c:1646  */
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
#line 4996 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1335 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 5002 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1336 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 5008 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1337 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5014 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1342 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 5020 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1346 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_STATES; }
#line 5026 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1347 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_ROUTES; }
#line 5032 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1348 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_FILTERS; }
#line 5038 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1349 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_IFACES; }
#line 5044 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1350 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_EVENTS; }
#line 5050 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1351 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_PACKETS; }
#line 5056 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1357 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 5062 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1358 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 5068 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1359 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5074 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1364 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 5080 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1368 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = MD_STATES; }
#line 5086 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1369 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = MD_MESSAGES; }
#line 5092 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1390 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[0].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   }
#line 5112 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1408 "cf-parse.y" /* yacc.c:1646  */
    { }
#line 5118 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1409 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->genfrom = (yyvsp[-2].time); }
#line 5124 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1410 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->gento = (yyvsp[-2].time); }
#line 5130 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1411 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->accfrom = (yyvsp[-2].time); }
#line 5136 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1412 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->accto = (yyvsp[-2].time); }
#line 5142 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1413 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->id = (yyvsp[-2].i); if ((yyvsp[-2].i) <= 0) cf_error("Password ID has to be greated than zero."); }
#line 5148 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1422 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_status(); }
#line 5154 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1425 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_memory(); }
#line 5160 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1428 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 0); }
#line 5166 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1431 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 1); }
#line 5172 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1435 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 5178 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1439 "cf-parse.y" /* yacc.c:1646  */
    { if_show(); }
#line 5184 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1442 "cf-parse.y" /* yacc.c:1646  */
    { if_show_summary(); }
#line 5190 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1446 "cf-parse.y" /* yacc.c:1646  */
    { rt_show((yyvsp[-1].ra)); }
#line 5196 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1449 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
#line 5206 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1454 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
   }
#line 5217 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1460 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
     (yyval.ra)->show_for = 1;
   }
#line 5229 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1467 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[0].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[0].s)->def)->table;
   }
#line 5239 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1472 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 5249 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1477 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 5259 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1482 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->verbose = 1;
   }
#line 5268 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1486 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->primary_only = 1;
   }
#line 5277 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1490 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->filtered = 1;
   }
#line 5286 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1494 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->export_mode = (yyvsp[-1].i);
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 5300 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1503 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 5313 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1511 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 1;
   }
#line 5322 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1515 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 2;
   }
#line 5331 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1522 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_PREEXPORT; }
#line 5337 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1523 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_EXPORT; }
#line 5343 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1524 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_NOEXPORT; }
#line 5349 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1530 "cf-parse.y" /* yacc.c:1646  */
    { roa_show((yyvsp[-1].ro)); }
#line 5355 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1533 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
#line 5367 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1540 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[0].px).addr;
     (yyval.ro)->pxlen = (yyvsp[0].px).len;
     (yyval.ro)->mode = (yyvsp[-1].i);
   }
#line 5379 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1547 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     (yyval.ro)->asn = (yyvsp[0].i);
   }
#line 5388 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1551 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyvsp[0].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 5398 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1559 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_PX; }
#line 5404 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1560 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_IN; }
#line 5410 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1561 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_FOR; }
#line 5416 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1567 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_symbols((yyvsp[-1].sd)); }
#line 5422 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1570 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
#line 5430 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1573 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TABLE; }
#line 5436 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1574 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FUNCTION; }
#line 5442 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1575 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FILTER; }
#line 5448 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1576 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_PROTO; }
#line 5454 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1577 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TEMPLATE; }
#line 5460 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1578 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_ROA; }
#line 5466 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1579 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->sym = (yyvsp[0].s); }
#line 5472 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1584 "cf-parse.y" /* yacc.c:1646  */
    { 
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
#line 5482 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1589 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 5492 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1598 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5501 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1605 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5510 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1612 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[-1].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5519 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1620 "cf-parse.y" /* yacc.c:1646  */
    { rdump(&root_pool); cli_msg(0, ""); }
#line 5525 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1622 "cf-parse.y" /* yacc.c:1646  */
    { sk_dump_all(); cli_msg(0, ""); }
#line 5531 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1624 "cf-parse.y" /* yacc.c:1646  */
    { io_log_dump(); cli_msg(0, ""); }
#line 5537 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1626 "cf-parse.y" /* yacc.c:1646  */
    { if_dump_all(); cli_msg(0, ""); }
#line 5543 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1628 "cf-parse.y" /* yacc.c:1646  */
    { neigh_dump_all(); cli_msg(0, ""); }
#line 5549 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1630 "cf-parse.y" /* yacc.c:1646  */
    { rta_dump_all(); cli_msg(0, ""); }
#line 5555 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1632 "cf-parse.y" /* yacc.c:1646  */
    { rt_dump_all(); cli_msg(0, ""); }
#line 5561 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1634 "cf-parse.y" /* yacc.c:1646  */
    { protos_dump_all(); cli_msg(0, ""); }
#line 5567 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1637 "cf-parse.y" /* yacc.c:1646  */
    { cmd_eval((yyvsp[-1].x)); }
#line 5573 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1640 "cf-parse.y" /* yacc.c:1646  */
    {
  cli_set_log_echo(this_cli, (yyvsp[-2].i), (yyvsp[-1].i));
  cli_msg(0, "");
}
#line 5582 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1646 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 5588 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1647 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 5594 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1648 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5600 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1652 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 4096; }
#line 5606 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1653 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 256 || (yyvsp[0].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[0].i);
   }
#line 5615 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1660 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_disable, 1, 0); }
#line 5621 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1662 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_enable, 1, 0); }
#line 5627 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1664 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_restart, 1, 0); }
#line 5633 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1666 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD); }
#line 5639 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1668 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
#line 5645 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1670 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
#line 5651 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1674 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_debug, 1, (yyvsp[-1].i)); }
#line 5657 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1678 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_mrtdump, 1, (yyvsp[-1].i)); }
#line 5663 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1681 "cf-parse.y" /* yacc.c:1646  */
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
#line 5669 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1684 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 5675 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1685 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 5681 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1686 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 5687 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1690 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 5693 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1691 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 5699 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1692 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 5705 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1700 "cf-parse.y" /* yacc.c:1646  */
    { (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[0].s) ); }
#line 5711 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1701 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyvsp[-2].s)->def = (yyvsp[0].f);
     (yyvsp[0].f)->name = (yyvsp[-2].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[-2].s)->name );
     cf_pop_scope();
   }
#line 5722 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1710 "cf-parse.y" /* yacc.c:1646  */
    { f_eval_int((yyvsp[0].x)); }
#line 5728 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1714 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_INT; }
#line 5734 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1715 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_BOOL; }
#line 5740 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1716 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_IP; }
#line 5746 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1717 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PREFIX; }
#line 5752 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1718 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PAIR; }
#line 5758 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1719 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_QUAD; }
#line 5764 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1720 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_EC; }
#line 5770 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1721 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_STRING; }
#line 5776 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1722 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH_MASK; }
#line 5782 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1723 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH; }
#line 5788 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1724 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_CLIST; }
#line 5794 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1725 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_ECLIST; }
#line 5800 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1726 "cf-parse.y" /* yacc.c:1646  */
    { 
	switch ((yyvsp[-1].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
#line 5823 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1747 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_VARIABLE | (yyvsp[-1].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[0].s)->name, (yyvsp[-1].i) );
     (yyvsp[0].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[0].s);
   }
#line 5836 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1758 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 5842 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 1759 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 5851 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1766 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = (yyvsp[0].s); }
#line 5857 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1767 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 5866 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1774 "cf-parse.y" /* yacc.c:1646  */
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[0].x);
     (yyval.f) = f;
   }
#line 5877 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1783 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[0].s)->def;
   }
#line 5886 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1791 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[0].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
#line 5912 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1815 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[-1].s); }
#line 5918 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1816 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s)=NULL; }
#line 5924 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1820 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-3].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[-3].s);
       (yyval.x)->next = (yyvsp[-1].x);
     } else
       (yyval.x) = (yyvsp[-1].x);
   }
#line 5939 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1833 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "Beginning of function %s\n", (yyvsp[0].s)->name );
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[0].s));
   }
#line 5948 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1836 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyvsp[-3].s)->def = (yyvsp[0].x);
     (yyvsp[-3].s)->aux2 = (yyvsp[-1].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[-3].s)->name); 
     cf_pop_scope();
   }
#line 5959 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1849 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 5965 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1850 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x)->next; (yyvsp[0].x)->next = NULL; }
#line 5971 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1853 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[0].x); }
#line 5977 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1854 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[-1].x)->next ; (yyvsp[-1].x)->next = (yyvsp[0].x); }
#line 5983 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1858 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[0].x);
   }
#line 5991 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1861 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[-1].x);
   }
#line 5999 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1870 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[0].a); }
#line 6005 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1883 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 6011 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1884 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 6017 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1885 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 6023 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1886 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 6029 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1887 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.v) = f_eval((yyvsp[-1].x), cfg_mem);
     if (!f_valid_set_type((yyval.v).type)) cf_error("Set-incompatible type");
   }
#line 6038 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1891 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!cf_symbol_is_constant((yyvsp[0].s))) cf_error("%s: constant expected", (yyvsp[0].s)->name);
     if (!f_valid_set_type(SYM_TYPE((yyvsp[0].s)))) cf_error("%s: set-incompatible type", (yyvsp[0].s)->name);
     (yyval.v) = *(struct f_val *)((yyvsp[0].s)->def);
   }
#line 6048 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1899 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 6054 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1900 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[-1].x)); }
#line 6060 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1901 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 6066 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1902 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 6072 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1903 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 6078 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1907 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = f_eval_int((yyvsp[0].x)); check_u16((yyval.i)); }
#line 6084 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1910 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = pair((yyvsp[0].i), (yyvsp[0].i)); }
#line 6090 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1911 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = pair((yyvsp[-2].i), (yyvsp[0].i)); }
#line 6096 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1912 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = 0xFFFF; }
#line 6102 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1916 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.e) = f_new_pair_set(pair_a((yyvsp[-3].i32)), pair_b((yyvsp[-3].i32)), pair_a((yyvsp[-1].i32)), pair_b((yyvsp[-1].i32)));
   }
#line 6110 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1919 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Hack: $2 and $4 should be pair_expr, but that would cause shift/reduce conflict */
     if ((pair_a((yyvsp[-9].i32)) != pair_b((yyvsp[-9].i32))) || (pair_a((yyvsp[-7].i32)) != pair_b((yyvsp[-7].i32))))
       cf_error("syntax error");
     (yyval.e) = f_new_pair_item(pair_b((yyvsp[-9].i32)), (yyvsp[-3].i), pair_b((yyvsp[-7].i32)), (yyvsp[-1].i)); 
   }
#line 6121 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1928 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = f_eval_int((yyvsp[0].x)); }
#line 6127 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1931 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_RT; }
#line 6133 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1932 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_RO; }
#line 6139 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 1933 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 6145 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 1934 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_GENERIC; }
#line 6151 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1938 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6157 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1939 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-7].i), 0, (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6163 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 1940 "cf-parse.y" /* yacc.c:1646  */
    {  (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), 0, EC_ALL); }
#line 6169 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 1946 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 6175 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 1947 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 6181 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1953 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 6187 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 1954 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 6193 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1959 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 6199 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1964 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 6205 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 1968 "cf-parse.y" /* yacc.c:1646  */
    {
     if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[-2].a), (yyvsp[0].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[-2].a), (yyvsp[0].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[-2].a); (yyval.v).val.px.len = (yyvsp[0].i);
   }
#line 6214 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 1975 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 6220 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 1976 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_PLUS; }
#line 6226 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 1977 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_MINUS; }
#line 6232 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 1978 "cf-parse.y" /* yacc.c:1646  */
    { 
     if (! ((0 <= (yyvsp[-3].i)) && ((yyvsp[-3].i) <= (yyvsp[-1].i)) && ((yyvsp[-1].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[-3].i), (yyvsp[-1].i));
     (yyval.v) = (yyvsp[-5].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[-3].i) << 16) | ((yyvsp[-1].i) << 8);
   }
#line 6241 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1985 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.trie) = f_new_trie(cfg_mem, sizeof(struct f_trie_node)); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 6247 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1986 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.trie) = (yyvsp[-2].trie); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 6253 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 1989 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = NULL; }
#line 6259 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 1990 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[-2].e); t; t = t->left)
       t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-3].e), (yyvsp[-2].e));
   }
#line 6271 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 1997 "cf-parse.y" /* yacc.c:1646  */
    { 
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-2].e), t);
 }
#line 6283 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2009 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6289 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2010 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6295 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2014 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 6301 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2015 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 6307 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2019 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[-1].i); }
#line 6313 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2020 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
#line 6319 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2021 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_QUESTION; (yyval.h)->val  = 0; }
#line 6325 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 2022 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[-1].x); }
#line 6331 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 2023 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = NULL; }
#line 6337 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 2027 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[-1].i); }
#line 6343 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 2028 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
#line 6349 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 373:
#line 2029 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = NULL; }
#line 6355 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 2033 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[0].i); }
#line 6361 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 2034 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
#line 6367 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 2035 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
#line 6373 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 2036 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[0].t); }
#line 6379 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 378:
#line 2037 "cf-parse.y" /* yacc.c:1646  */
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 6385 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 2038 "cf-parse.y" /* yacc.c:1646  */
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 6391 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 2039 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[0].i32); }
#line 6397 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 2040 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[-1].e)); DBG( "ook\n" ); }
#line 6403 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 382:
#line 2041 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[-1].trie); }
#line 6409 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2042 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[0].i) >> 16; (yyval.x)->a2.i = (yyvsp[0].i) & 0xffff; }
#line 6415 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2043 "cf-parse.y" /* yacc.c:1646  */
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[0].h); (yyval.x)->a1.p = val; }
#line 6421 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2047 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_dpair((yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6427 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2048 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_ec((yyvsp[-5].i), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6433 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2062 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 6458 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2085 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();

     switch ((yyvsp[0].s)->class & 0xff00) {
       case SYM_CONSTANT: (yyval.x)->code = 'C'; break;
       case SYM_VARIABLE: (yyval.x)->code = 'V'; break;
       default: cf_error("%s: variable expected.", (yyvsp[0].s)->name);
     }

     (yyval.x)->a1.p = (yyvsp[0].s)->def;
     (yyval.x)->a2.p = (yyvsp[0].s)->name;
   }
#line 6475 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2099 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_FROM;	(yyval.x)->a1.i = 1; }
#line 6481 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2100 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_GW;	(yyval.x)->a1.i = 1; }
#line 6487 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 2101 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = SA_NET; }
#line 6493 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 2102 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_PROTO; }
#line 6499 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 2103 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = SA_SOURCE; }
#line 6505 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 2104 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = SA_SCOPE;	(yyval.x)->a1.i = 1; }
#line 6511 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 2105 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = SA_CAST; }
#line 6517 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 2106 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = SA_DEST;	(yyval.x)->a1.i = 1; }
#line 6523 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 2107 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_IFNAME; }
#line 6529 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 2108 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_INT;        (yyval.x)->a2.i = SA_IFINDEX; }
#line 6535 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2112 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6541 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 2113 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6547 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 2114 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6553 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2115 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6559 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 2116 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6565 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2117 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6571 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 2118 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6577 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2119 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6583 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2120 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6589 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2121 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6595 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 2122 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6601 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 2123 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 6607 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 2124 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 6613 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2125 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6619 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2126 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[0].x); }
#line 6625 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2127 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[-1].x); }
#line 6631 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2129 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6637 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2130 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6643 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 2131 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6649 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 2133 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; }
#line 6655 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 2135 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyval.x)->code = 'a'; }
#line 6661 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 2137 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyval.x)->code = P('e','a'); }
#line 6667 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 2139 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->aux = T_IP; }
#line 6673 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 2140 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6679 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 2141 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[-5].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 6685 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2142 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6691 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 2143 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6697 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2144 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','L'); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6703 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 2154 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; }
#line 6709 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2155 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; }
#line 6715 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 2156 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_ECLIST; }
#line 6721 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2157 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 6727 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2158 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'a'; }
#line 6733 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2159 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'd'; }
#line 6739 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 2160 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'f'; }
#line 6745 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 2162 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-1].s), NULL, NULL); }
#line 6751 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 2163 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-5].s), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6757 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 2168 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 6782 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 2191 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_QUITBIRD; }
#line 6788 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 2192 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_ACCEPT; }
#line 6794 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2193 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_REJECT; }
#line 6800 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 2194 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_ERROR; }
#line 6806 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 2195 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_NOP; }
#line 6812 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 2196 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_NONL; }
#line 6818 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 2200 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = NULL; }
#line 6824 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 2203 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 6830 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 2204 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6836 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 2205 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-2].x)) {
       (yyvsp[-2].x)->next = (yyvsp[0].x);
       (yyval.x) = (yyvsp[-2].x);
     } else (yyval.x) = (yyvsp[0].x);
   }
#line 6847 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2213 "cf-parse.y" /* yacc.c:1646  */
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[0].x);
     (yyval.x)->next = NULL;
   }
#line 6859 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 2220 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[-2].x);
     (yyval.x)->next = (yyvsp[0].x);
   }
#line 6871 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 2229 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 6877 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 2230 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6883 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 2234 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[-2].x);
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 6894 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 2240 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[-4].x);
     i->a2.p = (yyvsp[-2].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 6909 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 2250 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[-3].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[-3].s);
     (yyval.x)->a2.p = (yyvsp[-1].x);
   }
#line 6923 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 2259 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6934 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 2265 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = (yyvsp[-3].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6944 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 2270 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = (yyvsp[-3].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6956 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 2277 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6966 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 2282 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = (yyvsp[-2].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   }
#line 6977 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 2288 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[-1].x); (yyval.x)->a2.i = (yyvsp[-2].i); }
#line 6983 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 2289 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6989 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 2290 "cf-parse.y" /* yacc.c:1646  */
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[-3].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[-1].e) );
   }
#line 7000 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 2298 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_empty((yyvsp[-3].x)); }
#line 7006 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 2299 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 7012 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 2300 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 7018 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 2301 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 7024 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 2302 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('C','a'), 'f', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 7030 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 2309 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_bfd, (yyvsp[-1].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);

  if (bfd_cf)
    cf_error("Only one BFD instance allowed");
  bfd_cf = BFD_CFG;
}
#line 7044 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 476:
#line 2336 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;
}
#line 7058 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 477:
#line 2347 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 7064 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 478:
#line 2348 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = (yyvsp[0].i32); }
#line 7070 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 479:
#line 2349 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 7076 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 480:
#line 2350 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->idle_tx_int = (yyvsp[0].i32); }
#line 7082 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 2351 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->multiplier = (yyvsp[0].i); }
#line 7088 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 2352 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->passive = (yyvsp[0].i); }
#line 7094 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 487:
#line 2366 "cf-parse.y" /* yacc.c:1646  */
    { add_tail(&BFD_CFG->patt_list, NODE this_ipatt); }
#line 7100 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 2369 "cf-parse.y" /* yacc.c:1646  */
    { BFD_CFG->multihop = BFD_IFACE; }
#line 7106 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 2373 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 7112 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 490:
#line 2374 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 7118 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 2375 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].t)); }
#line 7124 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 2379 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = IPA_NONE; }
#line 7130 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 2380 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = (yyvsp[0].a); }
#line 7136 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 2384 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 7142 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 2385 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 7148 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 496:
#line 2389 "cf-parse.y" /* yacc.c:1646  */
    {
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[-3].a);
  BFD_NEIGHBOR->local = (yyvsp[-1].a);
  BFD_NEIGHBOR->iface = (yyvsp[-2].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[0].i);

  if ((yyvsp[0].i) && (yyvsp[-2].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[0].i) && ipa_zero((yyvsp[-1].a)))
    cf_error("Multihop neighbor requires specified local address");
}
#line 7168 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 497:
#line 2408 "cf-parse.y" /* yacc.c:1646  */
    { bfd_show_sessions(proto_get_named((yyvsp[-1].s), &proto_bfd)); }
#line 7174 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 2413 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_bgp, (yyvsp[-1].i));
     BGP_CFG->remote_port = BGP_PORT;
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->connect_delay_time = 5;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
     BGP_CFG->setkey = 1;
 }
#line 7202 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 2440 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->remote_port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number");  }
#line 7208 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 2441 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->remote_as = (yyvsp[0].i); }
#line 7214 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 504:
#line 2447 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->local_as = (yyvsp[-1].i); }
#line 7220 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 505:
#line 2448 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->source_addr = (yyvsp[-3].a); BGP_CFG->local_as = (yyvsp[-1].i); }
#line 7226 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 507:
#line 2450 "cf-parse.y" /* yacc.c:1646  */
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     BGP_CFG->remote_ip = (yyvsp[-3].a);
     if ((yyvsp[-2].iface)) BGP_CFG->iface = (yyvsp[-2].iface);
   }
#line 7237 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 508:
#line 2456 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->iface = if_get_by_name((yyvsp[-1].t)); }
#line 7243 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 509:
#line 2457 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rr_cluster_id = (yyvsp[-1].i32); }
#line 7249 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 510:
#line 2458 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rr_client = 1; }
#line 7255 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 511:
#line 2459 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rs_client = 1; }
#line 7261 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 512:
#line 2460 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->hold_time = (yyvsp[-1].i); }
#line 7267 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 513:
#line 2461 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->initial_hold_time = (yyvsp[-1].i); }
#line 7273 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 514:
#line 2462 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 0; }
#line 7279 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 2463 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 64; }
#line 7285 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 516:
#line 2464 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = (yyvsp[-1].i); if (((yyvsp[-1].i)<1) || ((yyvsp[-1].i)>255)) cf_error("Multihop must be in range 1-255"); }
#line 7291 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 2465 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
#line 7297 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 2466 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
#line 7303 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 2467 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_SELF; }
#line 7309 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 2468 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_DROP; }
#line 7315 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 2469 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
#line 7321 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 2470 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gw_mode = GW_DIRECT; }
#line 7327 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 2471 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
#line 7333 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 2472 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->compare_path_lengths = (yyvsp[-1].i); }
#line 7339 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 525:
#line 2473 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->med_metric = (yyvsp[-1].i); }
#line 7345 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 526:
#line 2474 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->igp_metric = (yyvsp[-1].i); }
#line 7351 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 527:
#line 2475 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->prefer_older = (yyvsp[-1].i); }
#line 7357 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 528:
#line 2476 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->deterministic_med = (yyvsp[-1].i); }
#line 7363 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 529:
#line 2477 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->default_med = (yyvsp[-1].i); }
#line 7369 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 530:
#line 2478 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->default_local_pref = (yyvsp[-1].i); }
#line 7375 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 531:
#line 2479 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->source_addr = (yyvsp[-1].a); }
#line 7381 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 532:
#line 2480 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_delay_time = (yyvsp[-1].i); log(L_WARN "%s: Start delay time option is deprecated, use connect delay time", this_proto->name); }
#line 7387 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 533:
#line 2481 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_delay_time = (yyvsp[-1].i); }
#line 7393 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 534:
#line 2482 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_retry_time = (yyvsp[-1].i); }
#line 7399 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 535:
#line 2483 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->keepalive_time = (yyvsp[-1].i); }
#line 7405 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 536:
#line 2484 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->error_amnesia_time = (yyvsp[-1].i); }
#line 7411 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 537:
#line 2485 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->error_delay_time_min = (yyvsp[-3].i); BGP_CFG->error_delay_time_max = (yyvsp[-1].i); }
#line 7417 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 538:
#line 2486 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->disable_after_error = (yyvsp[-1].i); }
#line 7423 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 539:
#line 2487 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_refresh = (yyvsp[-1].i); }
#line 7429 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 540:
#line 2488 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_as4 = (yyvsp[-1].i); }
#line 7435 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 541:
#line 2489 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_extended_messages = (yyvsp[-1].i); }
#line 7441 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 542:
#line 2490 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->capabilities = (yyvsp[-1].i); }
#line 7447 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 543:
#line 2491 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->advertise_ipv4 = (yyvsp[-1].i); }
#line 7453 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 544:
#line 2492 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->password = (yyvsp[-1].t); }
#line 7459 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 545:
#line 2493 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->setkey = (yyvsp[-1].i); }
#line 7465 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 546:
#line 2494 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[-1].i);
     this_proto->in_limit->action = PLA_RESTART;
     log(L_WARN "%s: Route limit option is deprecated, use import limit", this_proto->name);
   }
#line 7476 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 547:
#line 2500 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->passive = (yyvsp[-1].i); }
#line 7482 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 548:
#line 2501 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->interpret_communities = (yyvsp[-1].i); }
#line 7488 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 549:
#line 2502 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->secondary = (yyvsp[-1].i); }
#line 7494 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 550:
#line 2503 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = ADD_PATH_RX; }
#line 7500 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 551:
#line 2504 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = ADD_PATH_TX; }
#line 7506 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 552:
#line 2505 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = (yyvsp[-1].i) ? ADD_PATH_FULL : 0; }
#line 7512 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 553:
#line 2506 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = -1; }
#line 7518 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 554:
#line 2507 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = (yyvsp[-1].i); }
#line 7524 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 555:
#line 2508 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_mode = (yyvsp[-1].i); }
#line 7530 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 556:
#line 2509 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_mode = BGP_GR_AWARE; }
#line 7536 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 557:
#line 2510 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_time = (yyvsp[-1].i); }
#line 7542 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 558:
#line 2511 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->igp_table = (yyvsp[-1].r); }
#line 7548 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 559:
#line 2512 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->ttl_security = (yyvsp[-1].i); }
#line 7554 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 560:
#line 2513 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->check_link = (yyvsp[-1].i); }
#line 7560 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 561:
#line 2514 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->bfd = (yyvsp[-1].i); cf_check_bfd((yyvsp[-1].i)); }
#line 7566 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 562:
#line 2525 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_ospf, (yyvsp[-1].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->tick = OSPF_DEFAULT_TICK;
     OSPF_CFG->ospf2 = OSPF_IS_V2;
  }
#line 7578 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 566:
#line 2541 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->rfc1583 = (yyvsp[0].i); }
#line 7584 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 567:
#line 2542 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->stub_router = (yyvsp[0].i); }
#line 7590 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 568:
#line 2543 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[0].i) ? OSPF_DEFAULT_ECMP_LIMIT : 0; }
#line 7596 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 569:
#line 2544 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; if ((yyvsp[0].i) < 0) cf_error("ECMP limit cannot be negative"); }
#line 7602 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 570:
#line 2545 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->merge_external = (yyvsp[0].i); }
#line 7608 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 571:
#line 2546 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->tick = (yyvsp[0].i); if((yyvsp[0].i)<=0) cf_error("Tick must be greater than zero"); }
#line 7614 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 572:
#line 2547 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->instance_id = (yyvsp[0].i); if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Instance ID must be in range 0-255"); }
#line 7620 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 574:
#line 2551 "cf-parse.y" /* yacc.c:1646  */
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[0].i32);
  this_area->default_cost = OSPF_DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = OSPF_DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
#line 7638 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 575:
#line 2566 "cf-parse.y" /* yacc.c:1646  */
    { ospf_area_finish(); }
#line 7644 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 578:
#line 2575 "cf-parse.y" /* yacc.c:1646  */
    { this_area->type = (yyvsp[0].i) ? 0 : OPT_E; /* We should remove the option */ }
#line 7650 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 579:
#line 2576 "cf-parse.y" /* yacc.c:1646  */
    { this_area->type = OPT_N; }
#line 7656 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 580:
#line 2577 "cf-parse.y" /* yacc.c:1646  */
    { this_area->summary = (yyvsp[0].i); }
#line 7662 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 581:
#line 2578 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_nssa = (yyvsp[0].i); }
#line 7668 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 582:
#line 2579 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 7674 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 583:
#line 2580 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i) | LSA_EXT3_EBIT; ospf_check_defcost((yyvsp[0].i)); }
#line 7680 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 584:
#line 2581 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 7686 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 585:
#line 2582 "cf-parse.y" /* yacc.c:1646  */
    { this_area->translator = (yyvsp[0].i); }
#line 7692 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 586:
#line 2583 "cf-parse.y" /* yacc.c:1646  */
    { this_area->transint = (yyvsp[0].i); }
#line 7698 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 587:
#line 2584 "cf-parse.y" /* yacc.c:1646  */
    { this_nets = &this_area->net_list; }
#line 7704 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 589:
#line 2585 "cf-parse.y" /* yacc.c:1646  */
    { this_nets = &this_area->enet_list; }
#line 7710 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 596:
#line 2597 "cf-parse.y" /* yacc.c:1646  */
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[0].px);
     this_stubnet->cost = COST_D;
   }
#line 7721 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 599:
#line 2611 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->hidden = (yyvsp[0].i); }
#line 7727 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 600:
#line 2612 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->summary = (yyvsp[0].i); }
#line 7733 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 601:
#line 2613 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->cost = (yyvsp[0].i); }
#line 7739 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 602:
#line 2617 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 7745 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 603:
#line 2618 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 7751 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 607:
#line 2627 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 7757 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 608:
#line 2628 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 7763 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 609:
#line 2629 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 7769 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 610:
#line 2630 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 7775 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 611:
#line 2631 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 7781 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 612:
#line 2632 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 7787 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 613:
#line 2633 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE;  }
#line 7793 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 614:
#line 2634 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 7799 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 615:
#line 2635 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
#line 7805 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 616:
#line 2636 "cf-parse.y" /* yacc.c:1646  */
    { ospf_check_auth(); }
#line 7811 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 617:
#line 2640 "cf-parse.y" /* yacc.c:1646  */
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[0].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_VLINK;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  reset_passwords();
 }
#line 7832 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 618:
#line 2659 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->cost = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Cost must be in range 1-65535"); }
#line 7838 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 619:
#line 2660 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 7844 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 620:
#line 2661 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->pollint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Poll int must be greater than zero"); }
#line 7850 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 621:
#line 2662 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 7856 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 622:
#line 2663 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 7862 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 623:
#line 2664 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 7868 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 624:
#line 2665 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 7874 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 625:
#line 2666 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 7880 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 626:
#line 2667 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 7886 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 627:
#line 2668 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 7892 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 628:
#line 2669 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 7898 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 629:
#line 2670 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 7904 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 630:
#line 2671 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 7910 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 631:
#line 2672 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 7916 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 632:
#line 2673 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 7922 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 633:
#line 2674 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->real_bcast = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("Real broadcast option requires OSPFv2"); }
#line 7928 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 634:
#line 2675 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ptp_netmask = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("PtP netmask option requires OSPFv2"); }
#line 7934 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 635:
#line 2676 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 7940 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 636:
#line 2677 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->priority = (yyvsp[0].i) ; if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Priority must be in range 0-255"); }
#line 7946 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 637:
#line 2678 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->strictnbma = (yyvsp[0].i) ; }
#line 7952 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 638:
#line 2679 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->stub = (yyvsp[0].i) ; }
#line 7958 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 639:
#line 2680 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->check_link = (yyvsp[0].i); }
#line 7964 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 640:
#line 2681 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 7970 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 641:
#line 2682 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->link_lsa_suppression = (yyvsp[0].i); if (!ospf_cfg_is_v3()) cf_error("Link LSA suppression option requires OSPFv3"); }
#line 7976 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 643:
#line 2684 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE; }
#line 7982 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 644:
#line 2685 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 7988 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 645:
#line 2686 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
#line 7994 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 646:
#line 2687 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = 0; }
#line 8000 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 647:
#line 2688 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
#line 8006 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 648:
#line 2689 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
#line 8012 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 649:
#line 2690 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_tos = (yyvsp[0].i); }
#line 8018 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 650:
#line 2691 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_priority = (yyvsp[0].i); }
#line 8024 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 651:
#line 2692 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_length = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
#line 8030 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 652:
#line 2693 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = (yyvsp[0].i); }
#line 8036 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 653:
#line 2694 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = 2; }
#line 8042 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 654:
#line 2695 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 8048 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 655:
#line 2696 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->bsd_secondary = (yyvsp[0].i); }
#line 8054 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 656:
#line 2697 "cf-parse.y" /* yacc.c:1646  */
    { ospf_check_auth(); }
#line 8060 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 660:
#line 2708 "cf-parse.y" /* yacc.c:1646  */
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[0].px).addr;
   this_pref->px.len = (yyvsp[0].px).len;
 }
#line 8071 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 662:
#line 2718 "cf-parse.y" /* yacc.c:1646  */
    { this_pref->hidden = 1; }
#line 8077 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 663:
#line 2719 "cf-parse.y" /* yacc.c:1646  */
    { this_pref->tag = (yyvsp[0].i); }
#line 8083 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 666:
#line 2728 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 8089 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 667:
#line 2729 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 8095 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 668:
#line 2733 "cf-parse.y" /* yacc.c:1646  */
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[-2].a);
   this_nbma->eligible=(yyvsp[-1].i);
 }
#line 8106 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 669:
#line 2742 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
#line 8130 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 671:
#line 2765 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->instance_id = (yyvsp[0].i); if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Instance ID must be in range 0-255"); }
#line 8136 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 672:
#line 2769 "cf-parse.y" /* yacc.c:1646  */
    { if (ospf_cfg_is_v3()) iface_patt_check(); }
#line 8142 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 678:
#line 2783 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 8148 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 680:
#line 2788 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 8154 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 681:
#line 2794 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh(proto_get_named((yyvsp[-1].s), &proto_ospf)); }
#line 8160 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 682:
#line 2797 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_neigh(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 8166 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 683:
#line 2800 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_iface(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 8172 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 684:
#line 2805 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 1); }
#line 8178 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 685:
#line 2808 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 0); }
#line 8184 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 686:
#line 2813 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 1); }
#line 8190 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 687:
#line 2816 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 0); }
#line 8196 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 688:
#line 2820 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_lsadb((yyvsp[-1].ld)); }
#line 8202 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 689:
#line 2823 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
#line 8210 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 690:
#line 2826 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
#line 8216 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 691:
#line 2827 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[0].i32); }
#line 8222 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 692:
#line 2828 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
#line 8228 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 693:
#line 2829 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->type = (yyvsp[0].i); }
#line 8234 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 694:
#line 2830 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->lsid = (yyvsp[0].i32); }
#line 8240 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 695:
#line 2831 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
#line 8246 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 696:
#line 2832 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->router = (yyvsp[0].i32); }
#line 8252 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 697:
#line 2833 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->name = (yyvsp[0].s); }
#line 8258 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 698:
#line 2839 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_pipe, (yyvsp[-1].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
#line 8267 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 701:
#line 2848 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-1].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[-1].s)->def;
   }
#line 8277 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 702:
#line 2853 "cf-parse.y" /* yacc.c:1646  */
    { PIPE_CFG->mode = PIPE_OPAQUE; }
#line 8283 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 703:
#line 2854 "cf-parse.y" /* yacc.c:1646  */
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
#line 8289 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 704:
#line 2861 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_radv, (yyvsp[-1].i));
  init_list(&RADV_CFG->patt_list);
  init_list(&RADV_CFG->pref_list);
  init_list(&RADV_CFG->rdnss_list);
  init_list(&RADV_CFG->dnssl_list);
}
#line 8301 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 707:
#line 2872 "cf-parse.y" /* yacc.c:1646  */
    { add_tail(&RADV_CFG->pref_list, NODE this_radv_prefix); }
#line 8307 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 708:
#line 2873 "cf-parse.y" /* yacc.c:1646  */
    { init_list(&radv_dns_list); }
#line 8313 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 709:
#line 2873 "cf-parse.y" /* yacc.c:1646  */
    { add_tail_list(&RADV_CFG->rdnss_list, &radv_dns_list); }
#line 8319 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 710:
#line 2874 "cf-parse.y" /* yacc.c:1646  */
    { init_list(&radv_dns_list); }
#line 8325 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 711:
#line 2874 "cf-parse.y" /* yacc.c:1646  */
    { add_tail_list(&RADV_CFG->dnssl_list, &radv_dns_list); }
#line 8331 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 712:
#line 2875 "cf-parse.y" /* yacc.c:1646  */
    {
     RADV_CFG->trigger_prefix = (yyvsp[0].px).addr;
     RADV_CFG->trigger_pxlen = (yyvsp[0].px).len;
     RADV_CFG->trigger_valid = 1;
   }
#line 8341 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 716:
#line 2892 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct radv_iface_config));
  add_tail(&RADV_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  init_list(&RADV_IFACE->pref_list);
  init_list(&RADV_IFACE->rdnss_list);
  init_list(&RADV_IFACE->dnssl_list);

  RADV_IFACE->min_ra_int = -1; /* undefined */
  RADV_IFACE->max_ra_int = DEFAULT_MAX_RA_INT;
  RADV_IFACE->min_delay = DEFAULT_MIN_DELAY;
  RADV_IFACE->current_hop_limit = DEFAULT_CURRENT_HOP_LIMIT;
  RADV_IFACE->default_lifetime = -1;
  RADV_IFACE->default_lifetime_sensitive = 1;
  RADV_IFACE->default_preference = RA_PREF_MEDIUM;
}
#line 8362 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 717:
#line 2910 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->min_ra_int = (yyvsp[0].i); if ((yyvsp[0].i) < 3) cf_error("Min RA interval must be at least 3"); }
#line 8368 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 718:
#line 2911 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->max_ra_int = (yyvsp[0].i); if (((yyvsp[0].i) < 4) || ((yyvsp[0].i) > 1800)) cf_error("Max RA interval must be in range 4-1800"); }
#line 8374 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 719:
#line 2912 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->min_delay = (yyvsp[0].i); if ((yyvsp[0].i) <= 0) cf_error("Min delay must be positive"); }
#line 8380 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 720:
#line 2913 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->managed = (yyvsp[0].i); }
#line 8386 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 721:
#line 2914 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->other_config = (yyvsp[0].i); }
#line 8392 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 722:
#line 2915 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->link_mtu = (yyvsp[0].i); if ((yyvsp[0].i) < 0) cf_error("Link MTU must be 0 or positive"); }
#line 8398 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 723:
#line 2916 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->reachable_time = (yyvsp[0].i); if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 3600000)) cf_error("Reachable time must be in range 0-3600000"); }
#line 8404 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 724:
#line 2917 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->retrans_timer = (yyvsp[0].i); if ((yyvsp[0].i) < 0) cf_error("Retrans timer must be 0 or positive"); }
#line 8410 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 725:
#line 2918 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->current_hop_limit = (yyvsp[0].i); if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 255))  cf_error("Current hop limit must be in range 0-255"); }
#line 8416 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 726:
#line 2919 "cf-parse.y" /* yacc.c:1646  */
    {
     RADV_IFACE->default_lifetime = (yyvsp[-1].i);
     if (((yyvsp[-1].i) < 0) || ((yyvsp[-1].i) > 9000))  cf_error("Default lifetime must be in range 0-9000");
     if ((yyvsp[0].i) != -1) RADV_IFACE->default_lifetime_sensitive = (yyvsp[0].i);
   }
#line 8426 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 727:
#line 2924 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->default_preference = (yyvsp[0].i); }
#line 8432 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 728:
#line 2925 "cf-parse.y" /* yacc.c:1646  */
    { add_tail(&RADV_IFACE->pref_list, NODE this_radv_prefix); }
#line 8438 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 729:
#line 2926 "cf-parse.y" /* yacc.c:1646  */
    { init_list(&radv_dns_list); }
#line 8444 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 730:
#line 2926 "cf-parse.y" /* yacc.c:1646  */
    { add_tail_list(&RADV_IFACE->rdnss_list, &radv_dns_list); }
#line 8450 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 731:
#line 2927 "cf-parse.y" /* yacc.c:1646  */
    { init_list(&radv_dns_list); }
#line 8456 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 732:
#line 2927 "cf-parse.y" /* yacc.c:1646  */
    { add_tail_list(&RADV_IFACE->dnssl_list, &radv_dns_list); }
#line 8462 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 733:
#line 2928 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->rdnss_local = (yyvsp[0].i); }
#line 8468 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 734:
#line 2929 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->dnssl_local = (yyvsp[0].i); }
#line 8474 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 735:
#line 2933 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RA_PREF_LOW; }
#line 8480 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 736:
#line 2934 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RA_PREF_MEDIUM; }
#line 8486 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 737:
#line 2935 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RA_PREF_HIGH; }
#line 8492 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 738:
#line 2938 "cf-parse.y" /* yacc.c:1646  */
    {
  struct radv_iface_config *ic = RADV_IFACE;

  if (ic->min_ra_int == (u32) -1)
    ic->min_ra_int = MAX_(ic->max_ra_int / 3, 3);

  if (ic->default_lifetime == (u32) -1)
    ic->default_lifetime = 3 * ic->max_ra_int;

  if ((ic->min_ra_int > 3) &&
      (ic->min_ra_int > (ic->max_ra_int * 3 / 4)))
    cf_error("Min RA interval must be at most 3/4 * Max RA interval %d %d", ic->min_ra_int, ic->max_ra_int);

  if ((ic->default_lifetime > 0) && (ic->default_lifetime < ic->max_ra_int))
    cf_error("Default lifetime must be either 0 or at least Max RA interval");
}
#line 8513 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 744:
#line 2971 "cf-parse.y" /* yacc.c:1646  */
    {
  this_radv_prefix = cfg_allocz(sizeof(struct radv_prefix_config));
  RADV_PREFIX->prefix = (yyvsp[0].px).addr;
  RADV_PREFIX->pxlen = (yyvsp[0].px).len;

  RADV_PREFIX->onlink = 1;
  RADV_PREFIX->autonomous = 1;
  RADV_PREFIX->valid_lifetime = DEFAULT_VALID_LIFETIME;
  RADV_PREFIX->preferred_lifetime = DEFAULT_PREFERRED_LIFETIME;
}
#line 8528 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 745:
#line 2983 "cf-parse.y" /* yacc.c:1646  */
    { RADV_PREFIX->skip = (yyvsp[0].i); }
#line 8534 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 746:
#line 2984 "cf-parse.y" /* yacc.c:1646  */
    { RADV_PREFIX->onlink = (yyvsp[0].i); }
#line 8540 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 747:
#line 2985 "cf-parse.y" /* yacc.c:1646  */
    { RADV_PREFIX->autonomous = (yyvsp[0].i); }
#line 8546 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 748:
#line 2986 "cf-parse.y" /* yacc.c:1646  */
    {
     RADV_PREFIX->valid_lifetime = (yyvsp[-1].i);
     if ((yyvsp[-1].i) < 0) cf_error("Valid lifetime must be 0 or positive");
     if ((yyvsp[0].i) != -1) RADV_PREFIX->valid_lifetime_sensitive = (yyvsp[0].i);
   }
#line 8556 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 749:
#line 2991 "cf-parse.y" /* yacc.c:1646  */
    {
     RADV_PREFIX->preferred_lifetime = (yyvsp[-1].i);
     if ((yyvsp[-1].i) < 0) cf_error("Preferred lifetime must be 0 or positive");
     if ((yyvsp[0].i) != -1) RADV_PREFIX->preferred_lifetime_sensitive = (yyvsp[0].i);
   }
#line 8566 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 750:
#line 2999 "cf-parse.y" /* yacc.c:1646  */
    {
  if (RADV_PREFIX->preferred_lifetime > RADV_PREFIX->valid_lifetime)
    cf_error("Preferred lifetime must be at most Valid lifetime");

  if (RADV_PREFIX->valid_lifetime_sensitive > RADV_PREFIX->preferred_lifetime_sensitive)
    cf_error("Valid lifetime sensitive requires that Preferred lifetime is sensitive too");
}
#line 8578 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 756:
#line 3023 "cf-parse.y" /* yacc.c:1646  */
    {
  struct radv_rdnss_config *cf = cfg_allocz(sizeof(struct radv_rdnss_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->server = (yyvsp[0].a);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 8590 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 757:
#line 3032 "cf-parse.y" /* yacc.c:1646  */
    {
  RADV_RDNSS->lifetime = 0;
  RADV_RDNSS->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 8599 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 760:
#line 3039 "cf-parse.y" /* yacc.c:1646  */
    { RADV_RDNSS->lifetime = (yyvsp[0].i); RADV_RDNSS->lifetime_mult = radv_mult_val; }
#line 8605 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 761:
#line 3043 "cf-parse.y" /* yacc.c:1646  */
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No nameserver in RDNSS section");

  struct radv_rdnss_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_RDNSS->lifetime;
    cf->lifetime_mult = RADV_RDNSS->lifetime_mult;
  }
}
#line 8621 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 766:
#line 3067 "cf-parse.y" /* yacc.c:1646  */
    {
  struct radv_dnssl_config *cf = cfg_allocz(sizeof(struct radv_dnssl_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->domain = (yyvsp[0].t);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;

  if (radv_process_domain(cf) < 0)
    cf_error("Invalid domain dame");
}
#line 8636 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 767:
#line 3079 "cf-parse.y" /* yacc.c:1646  */
    {
  RADV_DNSSL->lifetime = 0;
  RADV_DNSSL->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 8645 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 770:
#line 3086 "cf-parse.y" /* yacc.c:1646  */
    { RADV_DNSSL->lifetime = (yyvsp[0].i); RADV_DNSSL->lifetime_mult = radv_mult_val; }
#line 8651 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 771:
#line 3090 "cf-parse.y" /* yacc.c:1646  */
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No domain in DNSSL section");

  struct radv_dnssl_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_DNSSL->lifetime;
    cf->lifetime_mult = RADV_DNSSL->lifetime_mult;
  }
}
#line 8667 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 776:
#line 3114 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); radv_mult_val = 0; }
#line 8673 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 777:
#line 3115 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; radv_mult_val = (yyvsp[0].i); if (((yyvsp[0].i) < 1) || ((yyvsp[0].i) > 254)) cf_error("Multiplier must be in range 1-254"); }
#line 8679 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 778:
#line 3119 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = -1; }
#line 8685 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 779:
#line 3120 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 8691 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 780:
#line 3127 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_rip, (yyvsp[-1].i));
  init_list(&RIP_CFG->patt_list);

  RIP_CFG->rip2 = RIP_IS_V2;
  RIP_CFG->infinity = RIP_DEFAULT_INFINITY;

  RIP_CFG->min_timeout_time = 60;
  RIP_CFG->max_garbage_time = 60;
}
#line 8706 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 782:
#line 3140 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->ecmp = (yyvsp[0].i) ? RIP_DEFAULT_ECMP_LIMIT : 0; }
#line 8712 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 783:
#line 3141 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; if ((yyvsp[0].i) < 0) cf_error("ECMP limit cannot be negative"); }
#line 8718 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 784:
#line 3142 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->infinity = (yyvsp[0].i); }
#line 8724 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 789:
#line 3156 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct rip_iface_config));
  add_tail(&RIP_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  reset_passwords();

  RIP_IFACE->metric = 1;
  RIP_IFACE->port = rip_cfg_is_v2() ? RIP_PORT : RIP_NG_PORT;
  RIP_IFACE->version = rip_cfg_is_v2() ? RIP_V2 : RIP_V1;
  RIP_IFACE->split_horizon = 1;
  RIP_IFACE->poison_reverse = 1;
  RIP_IFACE->check_zero = 1;
  RIP_IFACE->ttl_security = rip_cfg_is_v2() ? 0 : 1;
  RIP_IFACE->rx_buffer = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_length = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  RIP_IFACE->tx_priority = sk_priority_control;
  RIP_IFACE->update_time = RIP_DEFAULT_UPDATE_TIME;
  RIP_IFACE->timeout_time = RIP_DEFAULT_TIMEOUT_TIME;
  RIP_IFACE->garbage_time = RIP_DEFAULT_GARBAGE_TIME;
}
#line 8750 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 790:
#line 3179 "cf-parse.y" /* yacc.c:1646  */
    {
  RIP_IFACE->passwords = get_passwords();

  if (!RIP_IFACE->auth_type != !RIP_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  /* Default mode is broadcast for RIPv1, multicast for RIPv2 and RIPng */
  if (!RIP_IFACE->mode)
    RIP_IFACE->mode = (rip_cfg_is_v2() && (RIP_IFACE->version == RIP_V1)) ?
      RIP_IM_BROADCAST : RIP_IM_MULTICAST;

  RIP_CFG->min_timeout_time = MIN_(RIP_CFG->min_timeout_time, RIP_IFACE->timeout_time);
  RIP_CFG->max_garbage_time = MAX_(RIP_CFG->max_garbage_time, RIP_IFACE->garbage_time);
}
#line 8769 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 791:
#line 3195 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->metric = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>255)) cf_error("Metric must be in range 1-255"); }
#line 8775 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 792:
#line 3196 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->mode = RIP_IM_MULTICAST; }
#line 8781 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 793:
#line 3197 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->mode = RIP_IM_BROADCAST; if (rip_cfg_is_ng()) cf_error("Broadcast not supported in RIPng"); }
#line 8787 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 794:
#line 3198 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->passive = (yyvsp[0].i); }
#line 8793 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 795:
#line 3199 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->address = (yyvsp[0].a); }
#line 8799 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 796:
#line 3200 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 8805 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 797:
#line 3201 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->version = (yyvsp[0].i);
			  if (rip_cfg_is_ng()) cf_error("Version not supported in RIPng");
			  if (((yyvsp[0].i) != RIP_V1) && ((yyvsp[0].i) != RIP_V2)) cf_error("Unsupported version");
			}
#line 8814 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 798:
#line 3205 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->version_only = (yyvsp[0].i); }
#line 8820 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 799:
#line 3206 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->split_horizon = (yyvsp[0].i); }
#line 8826 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 800:
#line 3207 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->poison_reverse = (yyvsp[0].i); }
#line 8832 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 801:
#line 3208 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->check_zero = (yyvsp[0].i); }
#line 8838 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 802:
#line 3209 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->update_time = (yyvsp[0].i); if ((yyvsp[0].i)<=0) cf_error("Update time must be positive"); }
#line 8844 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 803:
#line 3210 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->timeout_time = (yyvsp[0].i); if ((yyvsp[0].i)<=0) cf_error("Timeout time must be positive"); }
#line 8850 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 804:
#line 3211 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->garbage_time = (yyvsp[0].i); if ((yyvsp[0].i)<=0) cf_error("Garbage time must be positive"); }
#line 8856 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 805:
#line 3212 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 8862 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 806:
#line 3213 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("RX length must be in range 256-65535"); }
#line 8868 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 807:
#line 3214 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->tx_length = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("TX length must be in range 256-65535"); }
#line 8874 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 808:
#line 3215 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->tx_tos = (yyvsp[0].i); }
#line 8880 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 809:
#line 3216 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->tx_priority = (yyvsp[0].i); }
#line 8886 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 810:
#line 3217 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->ttl_security = (yyvsp[0].i); }
#line 8892 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 811:
#line 3218 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->ttl_security = 2; }
#line 8898 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 812:
#line 3219 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->check_link = (yyvsp[0].i); }
#line 8904 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 813:
#line 3220 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 8910 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 814:
#line 3221 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->auth_type = (yyvsp[0].i); if ((yyvsp[0].i)) rip_check_auth(); }
#line 8916 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 815:
#line 3222 "cf-parse.y" /* yacc.c:1646  */
    { rip_check_auth(); }
#line 8922 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 816:
#line 3226 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_NONE; }
#line 8928 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 817:
#line 3227 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_PLAIN; }
#line 8934 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 818:
#line 3228 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 8940 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 819:
#line 3229 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 8946 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 825:
#line 3250 "cf-parse.y" /* yacc.c:1646  */
    { rip_show_interfaces(proto_get_named((yyvsp[-2].s), &proto_rip), (yyvsp[-1].t)); }
#line 8952 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 826:
#line 3253 "cf-parse.y" /* yacc.c:1646  */
    { rip_show_neighbors(proto_get_named((yyvsp[-2].s), &proto_rip), (yyvsp[-1].t)); }
#line 8958 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 827:
#line 3259 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_static, (yyvsp[-1].i));
     static_init_config((struct static_config *) this_proto);
  }
#line 8967 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 830:
#line 3268 "cf-parse.y" /* yacc.c:1646  */
    { STATIC_CFG->check_link = (yyvsp[-1].i); }
#line 8973 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 831:
#line 3269 "cf-parse.y" /* yacc.c:1646  */
    { STATIC_CFG->igp_table = (yyvsp[-1].r); }
#line 8979 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 832:
#line 3270 "cf-parse.y" /* yacc.c:1646  */
    { static_route_finish(); }
#line 8985 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 833:
#line 3273 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[0].px).addr;
     this_srt->masklen = (yyvsp[0].px).len;
     this_srt_last_cmd = &(this_srt->cmds);
  }
#line 8997 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 834:
#line 3283 "cf-parse.y" /* yacc.c:1646  */
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[-1].a);
     this_srt_nh->via_if = (yyvsp[0].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
     this_srt_nh->use_bfd = -1; /* undefined */
   }
#line 9011 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 835:
#line 3292 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt_nh->masklen = (yyvsp[0].i) - 1; /* really */
     if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
#line 9020 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 836:
#line 3296 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt_nh->use_bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i));
   }
#line 9028 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 837:
#line 3302 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->mp_next = this_srt_nh; }
#line 9034 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 838:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { last_srt_nh->mp_next = this_srt_nh; }
#line 9040 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 839:
#line 3307 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[-1].a);
      this_srt->via_if = (yyvsp[0].iface);
   }
#line 9050 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 840:
#line 3312 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[0].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
#line 9061 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 841:
#line 3318 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_MULTIPATH;
   }
#line 9069 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 842:
#line 3321 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[0].a);
   }
#line 9078 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 843:
#line 3326 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 9084 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 844:
#line 3327 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 9090 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 845:
#line 3328 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 9096 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 846:
#line 3329 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 9102 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 847:
#line 3330 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_PROHIBIT; }
#line 9108 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 848:
#line 3334 "cf-parse.y" /* yacc.c:1646  */
    { *this_srt_last_cmd = (yyvsp[0].x); this_srt_last_cmd = &((yyvsp[0].x)->next); }
#line 9114 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 849:
#line 3335 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->use_bfd = (yyvsp[-1].i); cf_check_bfd((yyvsp[-1].i)); }
#line 9120 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 854:
#line 3350 "cf-parse.y" /* yacc.c:1646  */
    { static_show(proto_get_named((yyvsp[-1].s), &proto_static)); }
#line 9126 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 855:
#line 3356 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_babel, (yyvsp[-1].i));
  init_list(&BABEL_CFG->iface_list);
}
#line 9135 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 861:
#line 3376 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct babel_iface_config));
  add_tail(&BABEL_CFG->iface_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  BABEL_IFACE->port = BABEL_PORT;
  BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRED;
  BABEL_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  BABEL_IFACE->tx_priority = sk_priority_control;
  BABEL_IFACE->check_link = 1;
}
#line 9150 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 862:
#line 3389 "cf-parse.y" /* yacc.c:1646  */
    {
  if (BABEL_IFACE->type == BABEL_IFACE_TYPE_WIRELESS)
  {
    if (!BABEL_IFACE->hello_interval)
      BABEL_IFACE->hello_interval = BABEL_HELLO_INTERVAL_WIRELESS;
    if (!BABEL_IFACE->rxcost)
      BABEL_IFACE->rxcost = BABEL_RXCOST_WIRELESS;
  }
  else
  {
    if (!BABEL_IFACE->hello_interval)
      BABEL_IFACE->hello_interval = BABEL_HELLO_INTERVAL_WIRED;
    if (!BABEL_IFACE->rxcost)
      BABEL_IFACE->rxcost = BABEL_RXCOST_WIRED;
  }

  if (!BABEL_IFACE->update_interval)
    BABEL_IFACE->update_interval = BABEL_IFACE->hello_interval*BABEL_UPDATE_INTERVAL_FACTOR;
  BABEL_IFACE->ihu_interval = BABEL_IFACE->hello_interval*BABEL_IHU_INTERVAL_FACTOR;
}
#line 9175 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 864:
#line 3412 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 9181 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 865:
#line 3413 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->rxcost = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid rxcost"); }
#line 9187 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 866:
#line 3414 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->hello_interval = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid hello interval"); }
#line 9193 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 867:
#line 3415 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->update_interval = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid hello interval"); }
#line 9199 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 868:
#line 3416 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRED; }
#line 9205 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 869:
#line 3417 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRELESS; }
#line 9211 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 870:
#line 3418 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("RX buffer must be in range 256-65535"); }
#line 9217 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 871:
#line 3419 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->tx_length = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("TX length must be in range 256-65535"); }
#line 9223 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 872:
#line 3420 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->tx_tos = (yyvsp[0].i); }
#line 9229 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 873:
#line 3421 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->tx_priority = (yyvsp[0].i); }
#line 9235 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 874:
#line 3422 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->check_link = (yyvsp[0].i); }
#line 9241 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 880:
#line 3443 "cf-parse.y" /* yacc.c:1646  */
    { babel_show_interfaces(proto_get_named((yyvsp[-2].s), &proto_babel), (yyvsp[-1].t)); }
#line 9247 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 881:
#line 3446 "cf-parse.y" /* yacc.c:1646  */
    { babel_show_neighbors(proto_get_named((yyvsp[-2].s), &proto_babel), (yyvsp[-1].t)); }
#line 9253 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 882:
#line 3449 "cf-parse.y" /* yacc.c:1646  */
    { babel_show_entries(proto_get_named((yyvsp[-2].s), &proto_babel)); }
#line 9259 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 955:
#line 3457 "cf-parse.y" /* yacc.c:1646  */
    { bgp_check_config(BGP_CFG); }
#line 9265 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 956:
#line 3457 "cf-parse.y" /* yacc.c:1646  */
    { ospf_proto_finish(); }
#line 9271 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 969:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
#line 9277 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 970:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
#line 9283 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 971:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
#line 9289 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 972:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
#line 9295 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 973:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_MTU); }
#line 9301 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 974:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_WINDOW); }
#line 9307 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 975:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTT); }
#line 9313 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 976:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTTVAR); }
#line 9319 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 977:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SSTRESH); }
#line 9325 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 978:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_CWND); }
#line 9331 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 979:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_ADVMSS); }
#line 9337 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 980:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REORDERING); }
#line 9343 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 981:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_HOPLIMIT); }
#line 9349 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 982:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITCWND); }
#line 9355 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 983:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTO_MIN); }
#line 9361 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 984:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITRWND); }
#line 9367 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 985:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_QUICKACK); }
#line 9373 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 986:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_MTU); }
#line 9379 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 987:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_WINDOW); }
#line 9385 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 988:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTT); }
#line 9391 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 989:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTTVAR); }
#line 9397 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 990:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_SSTHRESH); }
#line 9403 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 991:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_CWND); }
#line 9409 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 992:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_ADVMSS); }
#line 9415 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 993:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_REORDERING); }
#line 9421 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 994:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_HOPLIMIT); }
#line 9427 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 995:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTO_MIN); }
#line 9433 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 996:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ECN); }
#line 9439 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 997:
#line 3460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ALLFRAG); }
#line 9445 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 998:
#line 3461 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
#line 9451 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 999:
#line 3461 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 9457 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1000:
#line 3462 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
#line 9463 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1001:
#line 3463 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
#line 9469 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1002:
#line 3464 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
#line 9475 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1003:
#line 3465 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
#line 9481 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1004:
#line 3466 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
#line 9487 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1005:
#line 3467 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
#line 9493 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1006:
#line 3468 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
#line 9499 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1007:
#line 3469 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
#line 9505 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1008:
#line 3470 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
#line 9511 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1009:
#line 3471 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
#line 9517 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1010:
#line 3472 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
#line 9523 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1011:
#line 3472 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
#line 9529 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1012:
#line 3472 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
#line 9535 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1013:
#line 3472 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
#line 9541 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1014:
#line 3472 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
#line 9547 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1015:
#line 3472 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
#line 9553 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1016:
#line 3472 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
#line 9559 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1017:
#line 3472 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_BABEL_METRIC); }
#line 9565 "cf-parse.tab.c" /* yacc.c:1646  */
    break;


#line 9569 "cf-parse.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 3474 "cf-parse.y" /* yacc.c:1906  */

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bfd/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/radv/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */

/* C Code from ../../proto/babel/config.Y */

